<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | admin/index.php                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alford Deeley aka machinari - ajdeeley@summitpages.ca             |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');

// Only let admin users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the inmemoriam Admin page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_INM00['access_denied']);
    $display .= $LANG_INM00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

function inm_configForm(){
    global $_TABLES, $_CONF, $INM_TABLES, $LANG_INM06;

    //get config
    $result = DB_query("SELECT * FROM {$INM_TABLES['settings']}");
    $A = DB_fetchArray($result);

    //display form
    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array ('page' => 'admin.thtml'));
    
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);
    $T->set_var('langgeneral', $LANG_INM06[10]);
    $T->set_var('langdisplay', $LANG_INM06[11]);
    $T->set_var('langglobal', $LANG_INM06[12]);
    $T->set_var('yes', $LANG_INM06[21]);
    $T->set_var('no', $LANG_INM06[22]);
    $T->set_var('langanon', $LANG_INM06[1]);
    $T->set_var('langadd', $LANG_INM06[2]);
    $T->set_var('langcreate', $LANG_INM06[25]);
    $T->set_var('langsplash', $LANG_INM06[3]);
    $T->set_var('langmenu', $LANG_INM06[113]);
    $T->set_var('langrandom', $LANG_INM06[4]);
    $T->set_var('langwhatsnew', $LANG_INM06[108]);
    $T->set_var('peralbum', $LANG_INM06[110]);
    $T->set_var('individual', $LANG_INM06[109]);
    $T->set_var('langlisttype', $LANG_INM06[111]);
    $T->set_var('langthumbsize', $LANG_INM06[62]);
    $T->set_var('small', $LANG_INM06[59]);
    $T->set_var('medium', $LANG_INM06[60]);
    $T->set_var('large', $LANG_INM06[61]);
    $T->set_var('langdateformat', $LANG_INM06[114]);
    $T->set_var('langblocks', $LANG_INM06[5]);
    $T->set_var('langleft', $LANG_INM06[6]);
    $T->set_var('langright', $LANG_INM06[7]);
    $T->set_var('langboth', $LANG_INM06[8]);
    $T->set_var('langnone', $LANG_INM06[9]);
    $T->set_var('langupdate', $LANG_INM06[13]);
    $T->set_var('langreset', $LANG_INM06[14]);
    $T->set_var('langdefaults', $LANG_INM06[15]);
    $T->set_var('langalbums', $LANG_INM06[16]);
    $T->set_var('langsearch', $LANG_INM06[20]);
    $T->set_var('langmaxfile', $LANG_INM06[17]);
    //$T->set_var('langmaxw', $LANG_INM06[18]);
    //$T->set_var('langmaxh', $LANG_INM06[19]);
    //$T->set_var('langdimensions', $LANG_INM06[28]);
    $T->set_var('langbytes', $LANG_INM06[29]);
    $inimaxM = ini_get('post_max_size');
    $inimax = inm_returnBytes($inimaxM);
    $T->set_var('langinimax', sprintf($LANG_INM06[115], $inimax, $inimaxM));
    $T->set_var('langmail', $LANG_INM06[112]);
    $T->set_var('generaldocs', sprintf($LANG_INM06[24], 'admingeneral'));
    $T->set_var('displaydocs', sprintf($LANG_INM06[24], 'admindisplay'));

    $selected = ' selected="selected"';
    $checked = ' checked="checked"';

    $T->set_var('anon' . $A['anonview'], $checked);
    $T->set_var('log' . $A['loginadd'], $checked);
    $T->set_var('create' . $A['logincreate'], $checked);
    $T->set_var('splash' . $A['enable_splash'], $checked);
    $T->set_var('menu' . $A['enable_menuitem'], $checked);
    $is_enabled = DB_getItem($_TABLES['blocks'], 'is_enabled', "name='inmrandom'");
    $T->set_var('random' . $is_enabled, $checked);
    $T->set_var('size' . $A['thumbsize'], $selected);
    $T->set_var('whatsnew' . $A['whatsnew'], $checked);
    $T->set_var('list' . $A['listtype'], $selected);
    $T->set_var('blks' . $A['lr_blocks'], $selected);
    $T->set_var('alb' . $A['albums_perpage'], $selected);
    $T->set_var('srch' . $A['searchdisplim'], $selected);
    if ($A['max_filesize'] > $inimax){
        $A['max_filesize'] = $inimax;
    }
    $T->set_var('maxfile', $A['max_filesize']);
    $T->set_var('mail' . $A['sendmail'], $checked);

    //get date formats
    $result = DB_query("SELECT dfid, description FROM {$_TABLES['dateformats']} ORDER BY dfid");
    $dfoptions = '';
    while ($O = DB_fetchArray($result)){
        $dfoptions .= '<option value="' . $O['dfid'] . '"';
        if ($O['dfid'] == $A['dfid']){
            $dfoptions .= ' selected="selected"';
        }
        $dfoptions .= '>' . $O['description'] . '</option>' . LB;
    }
    $T->set_var('dateformatoptions', $dfoptions);

    //$T->set_var('maxw', $A['max_width']);
    //$T->set_var('maxh', $A['max_height']);

    $T->parse('output','page');
    $retval = $T->finish($T->get_var('output'));

    return $retval;
}

//updates the settings table with new prefs
function inm_updateConfig($valid){
    global $_TABLES, $INM_TABLES, $LANG_INM06;

    //gather the posted settings into query
    $sql = "UPDATE {$INM_TABLES['settings']} SET";
    $sql .= " searchdisplim={$valid['search']}";
    $sql .= ", anonview={$valid['anonview']}";
    $sql .= ", loginadd={$valid['logadd']}";
    $sql .= ", logincreate={$valid['logcreate']}";
    $sql .= ", albums_perpage={$valid['albums']}";
    if ($valid['randomblock'] == 1){
        DB_query("UPDATE {$_TABLES['blocks']} SET is_enabled='1' WHERE name='inmrandom'");
    } else {
        DB_query("UPDATE {$_TABLES['blocks']} SET is_enabled='0' WHERE name='inmrandom'");
    }
    $sql .= ", thumbsize={$valid['thumbsize']}";
    $sql .= ", whatsnew={$valid['whatsnewlist']}";
    $sql .= ", listtype={$valid['listtype']}";
    $sql .= ", enable_splash={$valid['splash']}";
    $sql .= ", enable_menuitem={$valid['menuitem']}";
    $sql .= ", lr_blocks={$valid['blocks']}";
    $inimax = inm_returnBytes(ini_get('post_max_size'));
    if ($valid['maxfile'] > $inimax){
        $valid['maxfile'] = $inimax;
    }
    $sql .= ", max_filesize={$valid['maxfile']}";
    $sql .= ", sendmail={$valid['mail']}";
    $sql .= ", dfid={$valid['dfid']}";
    //$sql .= ", max_width={$valid['maxw']}";
    //$sql .= ", max_height={$valid['maxh']}";

    //update the table
    DB_query($sql);
    //update albums with new max size if applicable
    DB_query("UPDATE {$INM_TABLES['albums']} SET max_filesize='{$valid['maxfile']}' WHERE max_filesize>'{$valid['maxfile']}'");

    //return success;
    return $LANG_INM06[30];
}

//applies the default prefs to the settings table
function inm_defaultConfig(){
    global $INM_TABLES, $LANG_INM06, $_TABLES;

    //list the default settings
    $sql = "UPDATE {$INM_TABLES['settings']} SET";
    $sql .= " searchdisplim='10'";
    $sql .= ", anonview='1'";
    $sql .= ", loginadd='1'";
    $sql .= ", logincreate='1'";
    $sql .= ", albums_perpage='5'";
    //$sql .= ", randomblk='0'";
    DB_query("UPDATE {$_TABLES['blocks']} SET is_enabled=0 WHERE name='inmrandom'");
    $sql .= ", thumbsize='2'";
    $sql .= ", whatsnew='1'";
    $sql .= ", listtype='2'";
    $sql .= ", enable_splash='1'";
    $sql .= ", enable_menuitem='1'";
    $sql .= ", lr_blocks='1'";
    //if you edit the default max filesize, ensure that it does not exceed ini_get('post_max_size').
    $sql .= ", max_filesize='2097152'";
    $sql .= ", sendmail='1'";
    $sql .= ", dfid='0'";
    //$sql .= ", max_width='640'";
    //$sql .= ", max_height='640'";

    //update the table
    DB_query($sql);
    return $LANG_INM06[31];
}

//duh
function inm_adminMenu(){
    global $_CONF, $LANG_INM06;
    //general settings link
    $retval = '<a href="' . $_CONF['site_admin_url'] . '/plugins/inmemoriam/index.php?cfg=general">' . $LANG_INM06[32] . '</a>&nbsp;::&nbsp;';
    //album management link for ftp'd media
    $retval .= '<a href="' . $_CONF['site_admin_url'] . '/plugins/inmemoriam/index.php?cfg=manftp">' . $LANG_INM06[33] . '</a>&nbsp;::&nbsp;';
    //database integrity tools
    $retval .= '<a href="' . $_CONF['site_admin_url'] . '/plugins/inmemoriam/index.php?cfg=database">' . $LANG_INM06[34] . '</a>&nbsp;::&nbsp;';
    //static image management link
    $retval .= '<a href="' . $_CONF['site_admin_url'] . '/plugins/inmemoriam/index.php?cfg=static">' . $LANG_INM06[67] . '</a>&nbsp;&nbsp;';
    return $retval;
}

//displays buttons calling for action
function inm_ftpForm(){
    global $_CONF, $LANG_INM06;

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array ('page' => 'ftp-form.thtml'));
    
    $T->set_var('ftpaction', $_CONF['site_admin_url'] . '/plugins/inmemoriam/index.php');
    $T->set_var('langauto', $LANG_INM06[37]);
    $T->set_var('langmanual', $LANG_INM06[38]);
    $T->set_var('langpermissions', $LANG_INM06[65]);

    $T->parse('output','page');
    $retval = $T->finish($T->get_var('output'));
    return $retval;
}

//scan and return results--do not update db
function inm_manualUpdate(){
    global $INM_CONF, $LANG_INM06, $_TABLES, $_CONF, $INM_TABLES;

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array ('page' => 'structure.thtml', 'filerow' => 'file-row.thtml'));

    $T->set_var('action', $_CONF['site_admin_url'] . '/plugins/inmemoriam/index.php');
    $T->set_var('langapply', $LANG_INM06[46]);
    $T->set_var('langcancel', $LANG_INM06[44]);
    $T->set_var('langcheckall', $LANG_INM06[45]);
    $T->set_var('languncheckall', $LANG_INM06[52]);
    $T->set_var('langresults', $LANG_INM06[51]);

    $i = 1;
    $asterisk = 0;
    $errors = '';
    //open album dir
    $albums = $INM_CONF['path_albums'];
    if (is_dir($albums)) {

        if ($dh = @opendir($albums)) {
           //loop thru dir and sub dirs for new albums and media
           while (($file = @readdir($dh)) !== false) {
               if (@filetype($albums . $file) == 'dir' && $file != '.' && $file != '..'){

                   if ($sdh = @opendir($albums . $file)){
                       //loop thru sub dir for subalbums
                       while (($sfile = @readdir($sdh)) !== false) {
                           if (@filetype($albums . $file . '/' . $sfile) == 'dir' && $sfile != '.' && $sfile != '..'){

                               if ($ssdh = @opendir($albums . $file . '/' . $sfile)){
                                   //loop thru sub dir for media--deeper subalbums not accommodated
                                    while (($ssfile = @readdir($ssdh)) !== false) {
                                       //if (filetype($albums . $file . '/' . $sfile . '/' . $ssfile) == 'dir' && $ssfile != '.' && $ssfile != '..'){
                                           //not accommodating dirs at this depth

                                        //} else
                                        if (@filetype($albums . $file . '/' . $sfile . '/' . $ssfile) == 'file'){
                                            $extension = strtolower(strrchr($ssfile,"."));
                                            if (in_array($extension, $INM_CONF['image_ext']) || in_array($extension, $INM_CONF['aud_ext']) || in_array($extension, $INM_CONF['vid_ext']) || in_array($extension, $INM_CONF['cod_ext'])){
                                                $albumID = DB_getItem($INM_TABLES['albums'], 'id', "aid='$file'");
                                                $subalbumID = DB_getItem($INM_TABLES['albums'], 'id', "aid='$sfile' AND pid='$albumID'");
                                                $result = DB_query("SELECT mid FROM {$INM_TABLES['media']} WHERE filename='$ssfile' AND aid='$subalbumID'");
                                                if (DB_numRows($result) < 1){
                                                    if (!inm_isWritable($albums . $file . '/' . $sfile . '/' . $ssfile)){
                                                        $T->set_var('asterisk', $LANG_INM06[63]);
                                                        $asterisk++;
                                                    }
                                                    //$T->set_var('langfile', $LANG_INM06[48]);
                                                    $T->set_var('filename', sprintf($LANG_INM06[54], $file, $sfile, $ssfile));
                                                    $T->set_var('value', $file . ';' . $sfile . ';' . $ssfile);
                                                    if ($i % 2 == '1'){
                                                       $T->set_var('class', 'inm-oddrow');
                                                    } elseif ($i % 2 == '0') {
                                                       $T->set_var('class', 'inm-evenrow');
                                                    }
                                                    $i++;
                                                    $T->parse('dirfilerow','filerow',true);
                                                }
                                            }
                                        }
                                    }
                                   closedir($ssdh);
                               } else {
                                   //retval can't read album
                                   $errors .= sprintf($LANG_INM06[52], $albums . $file . '/' . $sfile);
                               }
                           } elseif (@filetype($albums . $file . '/' . $sfile) == 'file'){
                                $extension = strtolower(strrchr($sfile,"."));
                                if (in_array($extension, $INM_CONF['image_ext']) || in_array($extension, $INM_CONF['aud_ext']) || in_array($extension, $INM_CONF['vid_ext']) || in_array($extension, $INM_CONF['cod_ext'])){
                                    $albumID = DB_getItem($INM_TABLES['albums'], 'id', "aid='$file'");
                                    $result = DB_query("SELECT mid FROM {$INM_TABLES['media']} WHERE filename='$sfile' AND aid='$albumID'");
                                    if(DB_numRows($result) < 1){
                                            if (!inm_isWritable($albums . $file . '/' . $sfile)){
                                                $T->set_var('asterisk', $LANG_INM06[63]);
                                                $asterisk++;
                                            }
                                        //$T->set_var('langfile', $LANG_INM06[48]);
                                        $T->set_var('filename', sprintf($LANG_INM06[55], $file, $sfile));
                                        $T->set_var('value', $file . ';' . $sfile);
                                        if ($i % 2 == '1'){
                                           $T->set_var('class', 'inm-oddrow');
                                        } elseif ($i % 2 == '0') {
                                           $T->set_var('class', 'inm-evenrow');
                                        }
                                        $i++;
                                        $T->parse('dirfilerow','filerow',true);
                                    }
                                }
                           }
                       }
                       closedir($sdh);
                   } else {
                       //retval can't read album
                       $errors .= sprintf($LANG_INM06[52], $albums . $file);
                   }
               } elseif (@filetype($albums . $file) == 'file'){
                   //priveledged media only
               }
           }

           clearstatcache();
           closedir($dh);
       } else {
           //retval can't read album
           $errors .= sprintf($LANG_INM06[52], $albums);
       }
    } else {
        //retval can't read album
        $errors .= sprintf($LANG_INM06[52], $albums);
    }
    if ($errors != ''){
        $T->set_var('errors', $errors);
    }
    if ($i <= 1 && $errors == ''){
        return $LANG_INM06[57];
    } elseif ($i <= 1 && $errors != ''){
        return $LANG_INM06[57] . $LANG_INM06[58] . $errors;
    }
    if($asterisk >= 1){
        $T->set_var('langasterisk', $LANG_INM06[64]);
    }

    $T->parse('output','page');
    $retval = $T->finish($T->get_var('output'));
    return $retval;
}

//update database--called by manualUdate post or by autoUpdate
function inm_dbUpdate($valid){
    global $INM_TABLES, $_USER, $_GROUPS, $INM_CONF, $LANG_INM06;
    $i = 0;
    if (isset($valid['include'])){
        //get group id
        if (isset ($_GROUPS['Inmemoriam Admin'])) {
            $group_id = $_GROUPS['Inmemoriam Admin'];
        } else {
            $group_id = SEC_getFeatureGroup ('inmemoriam.admin');
        }
        $setid = ", group_id='$group_id', owner_id='{$_USER['uid']}'";

        foreach ($valid['include'] as $path){
            $pieces = explode(";", $path);
            $depth = count($pieces);

            if ($depth == 3){
            //separate $path into aid, sub-aid, and filename
                $parentalbum = $pieces[0];
                $subalbum = $pieces[1];
                $filename = $pieces[2];

                $result = DB_query("SELECT id FROM {$INM_TABLES['albums']} WHERE aid='$parentalbum' AND (pid='' OR pid IS NULL)");
                if (DB_numRows($result) < 1){
                    //create album
                    $path = $INM_CONF['path_albums'] . $parentalbum . '/';
                    DB_query("INSERT INTO {$INM_TABLES['albums']} SET aid='$parentalbum', path='$path', name='$parentalbum', date_created=NOW()" . $setid);
                    $albumID = DB_insertID();
                    //create subalbum
                    $path = $INM_CONF['path_albums'] . $parentalbum . '/' . $subalbum . '/';
                    DB_query("INSERT INTO {$INM_TABLES['albums']} SET aid='$subalbum', pid='$albumID', path='$path', name='$subalbum', date_created=NOW(), date_lastadd=NOW()" . $setid);
                    $subalbumID = DB_insertID();
                    //insert media
                    DB_query("INSERT INTO {$INM_TABLES['media']} SET filename='$filename', aid='$subalbumID', date=NOW(), status='0'" . $setid);
                } else {
                    list($albumID) = DB_fetchArray($result);
                    $result = DB_query("SELECT id FROM {$INM_TABLES['albums']} WHERE aid='$subalbum' AND pid='$albumID'");
                    if (DB_numRows($result) < 1){
                        //create subalbum
                        $path = $INM_CONF['path_albums'] . $parentalbum . '/' . $subalbum . '/';
                        DB_query("INSERT INTO {$INM_TABLES['albums']} SET aid='$subalbum', pid='$albumID', path='$path', name='$subalbum', date_created=NOW(), date_lastadd=NOW()" . $setid);
                        $subalbumID = DB_insertID();
                        //insert media
                        DB_query("INSERT INTO {$INM_TABLES['media']} SET filename='$filename', aid='$subalbumID', date=NOW(), status='0'" . $setid);
                    } else {
                        list($subalbumID) = DB_fetchArray($result);
                        //insert media
                        DB_query("INSERT INTO {$INM_TABLES['media']} SET filename='$filename', aid='$subalbumID', date=NOW(), status='0'" . $setid);
                    }
                }

            } elseif ($depth == 2){
            //separate $path into aid, sub-aid, and filename
                $parentalbum = $pieces[0];
                $filename = $pieces[1];

                $result = DB_query("SELECT id FROM {$INM_TABLES['albums']} WHERE aid='$parentalbum' AND (pid='' OR pid IS NULL)");
                if (DB_numRows($result) < 1){
                    //create album
                    $path = $INM_CONF['path_albums'] . $parentalbum . '/';
                    DB_query("INSERT INTO {$INM_TABLES['albums']} SET aid='$parentalbum', path='$path', name='$parentalbum', date_created=NOW(), date_lastadd=NOW()" . $setid);
                    $albumID = DB_insertID();
                    //insert media
                    DB_query("INSERT INTO {$INM_TABLES['media']} SET filename='$filename', aid='$albumID', date=NOW(), status='0'" . $setid);
                } else {
                    list($albumID) = DB_fetchArray($result);
                    //insert media
                    DB_query("INSERT INTO {$INM_TABLES['media']} SET filename='$filename', aid='$albumID', date=NOW(), status='0'" . $setid);
                }
            }
            $i++;
        }
    }
    return sprintf($LANG_INM06[56], $i);
}

function inm_autoUpdate(){
    //scan and update db--return success/error log
    global $INM_CONF, $LANG_INM06, $_TABLES, $_CONF, $INM_TABLES;

    $i = 1;
    $include = array();
    $errors = '';
    //open album dir
    $albums = $INM_CONF['path_albums'];
    if (is_dir($albums)) {

        if ($dh = @opendir($albums)) {
           //loop thru dir and sub dirs for new albums and media
           while (($file = @readdir($dh)) !== false) {
               if (@filetype($albums . $file) == 'dir' && $file != '.' && $file != '..'){

                   if ($sdh = @opendir($albums . $file)){
                       //loop thru sub dir for subalbums
                       while (($sfile = @readdir($sdh)) !== false) {
                           if (@filetype($albums . $file . '/' . $sfile) == 'dir' && $sfile != '.' && $sfile != '..'){

                               if ($ssdh = @opendir($albums . $file . '/' . $sfile)){
                                   //loop thru sub dir for media--deeper subalbums not accommodated
                                    while (($ssfile = @readdir($ssdh)) !== false) {
                                       //if (filetype($albums . $file . '/' . $sfile . '/' . $ssfile) == 'dir' && $ssfile != '.' && $ssfile != '..'){
                                           //not accommodating dirs at this depth

                                        //} else
                                        if (@filetype($albums . $file . '/' . $sfile . '/' . $ssfile) == 'file'){
                                            $extension = strtolower(strrchr($ssfile,"."));
                                            if (in_array($extension, $INM_CONF['image_ext']) || in_array($extension, $INM_CONF['aud_ext']) || in_array($extension, $INM_CONF['vid_ext']) || in_array($extension, $INM_CONF['cod_ext'])){
                                                $albumID = DB_getItem($INM_TABLES['albums'], 'id', "aid='$file'");
                                                $subalbumID = DB_getItem($INM_TABLES['albums'], 'id', "aid='$sfile' AND pid='$albumID'");
                                                $result = DB_query("SELECT mid FROM {$INM_TABLES['media']} WHERE filename='$ssfile' AND aid='$subalbumID'");
                                                //list($count) = DB_fetchArray($result);
                                                if (DB_numRows($result) < 1){
                                                //if($count < 1){
                                                    $include['include'][] = $file . ';' . $sfile . ';' . $ssfile;
                                                    $i++;
                                                }
                                            }
                                        }
                                    }
                                   closedir($ssdh);
                               } else {
                                   //retval can't read album
                                   $errors .= sprintf($LANG_INM06[52], $albums . $file . '/' . $sfile);
                               }
                           } elseif (@filetype($albums . $file . '/' . $sfile) == 'file'){
                                $extension = strtolower(strrchr($sfile,"."));
                                if (in_array($extension, $INM_CONF['image_ext']) || in_array($extension, $INM_CONF['aud_ext']) || in_array($extension, $INM_CONF['vid_ext']) || in_array($extension, $INM_CONF['cod_ext'])){
                                    $albumID = DB_getItem($INM_TABLES['albums'], 'id', "aid='$file'");
                                    $result = DB_query("SELECT COUNT(*) as count FROM {$INM_TABLES['media']} WHERE filename='$sfile' AND aid='$albumID'");
                                    list($count) = DB_fetchArray($result);
                                    if($count < 1){
                                        $include['include'][] = $file . ';' . $sfile;
                                        $i++;
                                    }
                                }
                           }
                       }
                       closedir($sdh);
                   } else {
                       //retval can't read album
                       $errors .= sprintf($LANG_INM06[52], $albums . $file);
                   }
               } elseif (@filetype($albums . $file) == 'file'){
                   //priveledged media only
               }
           }

           clearstatcache();
           closedir($dh);
       } else {
           //retval can't read album
           $errors .= sprintf($LANG_INM06[52], $albums);
       }
    } else {
        //retval can't read album
        $errors .= sprintf($LANG_INM06[52], $albums);
    }
    $process = inm_dbUpdate($include);

    return $errors . '<br /><br />' . $process;
}

//create a backup of the dailyquote database tables
function inm_tableDump ($table) {
    global $_CONF, $DQ_TABLES;
    $retval .= "# Dump of $table \n";
    $retval .= "# Dump DATE : " . date("d-M-Y H:i:s a") ."\n\n";

    $query = DB_query("SELECT * FROM $table");
    $num_fields = DB_numFields($query);
    $numrow = DB_numRows($query);

    while ($row = DB_fetchArray($query)){
        $retval .= "INSERT INTO ".$table." VALUES(";
        for($j=0; $j<$num_fields; $j++) {
            $row[$j] = addslashes($row[$j]);
            $row[$j] = ereg_replace("\n","\\n",$row[$j]);
            if (isset($row[$j])){
                $retval .= "\"$row[$j]\"";
            } else $retval .= "\"\"";
            if ($j<($num_fields-1)) $retval .= ",";
        }
        $retval .= ");\n";
    }
    return $retval . "\n\n\n";
}

//specify tables to be backed up by tabledump
//and display resulting dump txt file.
function inm_backup(){
    global $INM_TABLES, $LANG_INM06, $_CONF;

    $content = '# dump using Inmemoriam table backup utility version 0.2' . LB;
    $content .= '# use at your own risk  :P' . LB;
    foreach ($INM_TABLES as $table){
        $table = inm_tableDump($table);
        $content .= $table;
    }

    //write data to file
    $filepath = $_CONF['path'] . 'plugins/inmemoriam/backups/';
    if(inm_isWritable($filepath)) {
        $filename = date("YmdHis") . '_inmemoriam_db_backup.sql.gz';
        if (!$handle = gzopen($filepath . $filename, 'w')){
            //return fopen error
        } elseif (!$write = gzwrite($handle, $content)){
            //return fwrite error
        } else {
            gzclose($handle);
            //return positive result
            return $filename;
        }
    } else {
        return $LANG_INM06[87];
    }
}

function inm_listBackups(){
    global $_CONF;
    $bks = array();
    $i = 0;
    $bkdir = $_CONF['path'] . 'plugins/inmemoriam/backups/';
    if ($dh = @opendir($bkdir)){
        //loop thru dir for backup files
        while (($bkfile = @readdir($dh)) !== false) {
            if (@filetype($bkdir . $bkfile) == 'file'){
                $bks[] = $bkfile;
                $i++;
            }
        }
        closedir($dh);
    }
    if ($i > 0){
        return COM_makeList($bks);
    }
}

//checking for album ID's with invalid owners
//reassigns them
function inm_scan1($valid,&$T){
    global $INM_TABLES, $_TABLES, $LANG_INM06;

    if ($valid['submit'] == $LANG_INM06[76]){
        //scan
        $result = DB_query("SELECT id, name, owner_id, uid FROM {$INM_TABLES['albums']} LEFT JOIN {$_TABLES['users']} ON owner_id=uid GROUP BY owner_id HAVING uid IS NULL");
        if (DB_numRows($result) > 0){
            $T->set_var('langresults', $LANG_INM06[95]);
            $rogue = '';
            while($A = DB_fetchArray($result)){
                $rogue .= '<li>' . $A['id'] . '--<i><b>' . stripslashes($A['name']) . '</b></i></li>' . LB;
            }
            $T->set_var('results', $rogue);
            $T->set_var('repair', $LANG_INM06[90]);
            $T->parse('scan1results', 'scanres');
        } else {
            //no bad entries
            $T->set_var('scan1results', $LANG_INM06[94]);
        }
    } elseif ($valid['submit'] == $LANG_INM06[90]){
        //repair
        $result = DB_query("SELECT id, name, owner_id, uid FROM {$INM_TABLES['albums']} LEFT JOIN {$_TABLES['users']} ON owner_id=uid GROUP BY owner_id HAVING uid IS NULL");
        if (DB_numRows($result) > 0){
            while($A = DB_fetchArray($result)){
                //update albums
                DB_query("UPDATE {$INM_TABLES['albums']} SET owner_id='2', perm_members='0', perm_anon='0' WHERE owner_id='{$A['owner_id']}'");
                //update media
                DB_query("UPDATE {$INM_TABLES['media']} SET owner_id='2' WHERE owner_id='{$A['owner_id']}'");
                //delete favorites
                inm_deleteFav('',$A['owner_id']);
            }
            $T->set_var('scan1results', $LANG_INM06[96]);
        }
    }
}

//checking for not extant album on server
//deletes it
function inm_scan2($valid,&$T){
    global $INM_TABLES, $_TABLES, $LANG_INM06, $INM_CONF;
    if ($valid['submit'] == $LANG_INM06[77]){
        //scan
        $result = DB_query("SELECT id, path, name FROM {$INM_TABLES['albums']}");
        if (DB_numRows($result) > 0){
            //check path
            $rogue = '';
            $i = 0;
            while ($A = DB_fetchArray($result)){
                if (!inm_isDir($A['path'])){
                    $rogue .= '<li>' . $A['id'] . '--<i><b>' . stripslashes($A['name']) . '</b></i></li>' . LB;
                    $i++;
                }
            }
            if ($i > 0){
                $T->set_var('langresults', $LANG_INM06[99]);
                $T->set_var('results', $rogue);
                $T->set_var('repair', $LANG_INM06[91]);
                $T->parse('scan2results', 'scanres');
            } else {
                //no bad entries
                $T->set_var('scan2results', $LANG_INM06[100]);
            }
        }
    } elseif ($valid['submit'] == $LANG_INM06[91]){
        //repair
        $result = DB_query("SELECT id, path FROM {$INM_TABLES['albums']}");
        if (DB_numRows($result) > 0){
            while($A = DB_fetchArray($result)){
                if (!inm_isDir($A['path'])){
                    //delete favorites
                    $favres = DB_query("SELECT mid, filename FROM {$INM_TABLES['media']} WHERE aid='{$A['id']}'");
                    if(DB_numRows($favres) > 0){
                        while($F = DB_fetchArray($favres)){
                            inm_deleteFav($F['mid']);
                        }
                    }
                    //delete static images
                    inm_deleteStatic($A['id'], 'album');
                    //delete media
                    DB_query("DELETE FROM {$INM_TABLES['media']} WHERE aid='{$A['id']}'");
                    //delete albums
                    DB_query("DELETE FROM {$INM_TABLES['albums']} WHERE id='{$A['id']}'");
                }
            }
            $T->set_var('scan2results', $LANG_INM06[101]);
        }
    }
}

//checking for media with invalid aid
//deletes it
function inm_scan3($valid,&$T){
    global $INM_TABLES, $_TABLES, $LANG_INM06;
    if ($valid['submit'] == $LANG_INM06[78]){
        //scan
        $result = DB_query("SELECT m.mid, m.title, m.aid, a.id FROM {$INM_TABLES['media']} m LEFT JOIN {$INM_TABLES['albums']} a ON m.aid=a.id GROUP BY m.mid HAVING a.id IS NULL");
        if (DB_numRows($result) > 0){
            $T->set_var('langresults', $LANG_INM06[102]);
            $rogue = '';
            while($A = DB_fetchArray($result)){
                if (empty($A['title'])){
                    $A['title'] = 'empty title';
                }
                $rogue .= '<li>' . $A['mid'] . '--<i><b>' . stripslashes($A['title']) . '</b></i></li>' . LB;
            }
            $T->set_var('results', $rogue);
            $T->set_var('repair', $LANG_INM06[92]);
            $T->parse('scan3results', 'scanres');
        } else {
            //no bad entries
            $T->set_var('scan3results', $LANG_INM06[103]);
        }
    } elseif ($valid['submit'] == $LANG_INM06[92]){
        //repair
        $result = DB_query("SELECT m.mid, m.title, m.aid, a.id FROM {$INM_TABLES['media']} m LEFT JOIN {$INM_TABLES['albums']} a ON m.aid=a.id GROUP BY m.mid HAVING a.id IS NULL");
        if (DB_numRows($result) > 0){
            while($A = DB_fetchArray($result)){
                //delete static images
                inm_deleteStatic($A['mid'], 'media');
                //delete favorite
                inm_deleteFav($A['mid']);
                //delete media
                DB_query("DELETE FROM {$INM_TABLES['media']} WHERE mid='{$A['mid']}'");
            }
            $T->set_var('scan3results', $LANG_INM06[101]);
        }
    }
}

//checking for not extant media on server
//deletes it
function inm_scan4($valid,&$T){
    global $INM_TABLES, $_TABLES, $LANG_INM06;
    if ($valid['submit'] == $LANG_INM06[79]){
        //scan
        $result = DB_query("SELECT m.mid, m.filename, m.title, a.path FROM {$INM_TABLES['media']} m, {$INM_TABLES['albums']} a WHERE m.aid=a.id");
        if (DB_numRows($result) > 0){
            //check path
            $rogue = '';
            $i = 0;
            while ($A = DB_fetchArray($result)){
                if (!inm_isFile($A['path'] . $A['filename'])){
                    if (empty($A['title'])){
                        $A['title'] = 'empty title';
                    }
                    $rogue .= '<li>' . $A['mid'] . '--<i><b>' . stripslashes($A['title']) . '</b></i></li>' . LB;
                    $i++;
                }
            }
            if ($i > 0){
                $T->set_var('langresults', $LANG_INM06[104]);
                $T->set_var('results', $rogue);
                $T->set_var('repair', $LANG_INM06[93]);
                $T->parse('scan4results', 'scanres');
            } else {
                //no bad entries
                $T->set_var('scan4results', $LANG_INM06[105]);
            }
        }
    } elseif ($valid['submit'] == $LANG_INM06[93]){
        //repair
        $result = DB_query("SELECT m.mid, m.filename, a.path FROM {$INM_TABLES['media']} m, {$INM_TABLES['albums']} a WHERE m.aid=a.id");
        if (DB_numRows($result) > 0){
            while ($A = DB_fetchArray($result)){
                if (!inm_isFile($A['path'] . $A['filename'])){
                    //delete static images
                    inm_deleteStatic($A['mid'], 'media');
                    //delete favorite
                    inm_deleteFav($A['mid']);
                    //delete media
                    DB_query("DELETE FROM {$INM_TABLES['media']} WHERE mid='{$A['mid']}'");
                }
            }
            $T->set_var('scan4results', $LANG_INM06[106]);
        }
    }
}

function inm_dbForm($valid = ''){
    global $INM_TABLES, $LANG_INM06, $_CONF;
    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array ('page' => 'db-form.thtml', 'scanres' => 'scan-results.thtml'));
    $T->set_var('action', $_CONF['site_admin_url'] . '/plugins/inmemoriam/index.php');
    $T->set_var('scan1', $LANG_INM06[76]);
    $T->set_var('scan2', $LANG_INM06[77]);
    $T->set_var('scan3', $LANG_INM06[78]);
    $T->set_var('scan4', $LANG_INM06[79]);
    $T->set_var('note1', $LANG_INM06[80]);
    $T->set_var('note2', $LANG_INM06[81]);
    $T->set_var('note3', $LANG_INM06[82]);
    $T->set_var('note4', $LANG_INM06[83]);
    $T->set_var('backup', $LANG_INM06[84]);
    $T->set_var('bknote', $LANG_INM06[86]);
    $T->set_var('endblock', COM_endBlock());
    $T->set_var('startblock', COM_startBlock($LANG_INM06[85]));
    $existingbks = inm_listBackups();
    if (!empty($existingbks)){
        $T->set_var('langbks', $LANG_INM06[89]);
        $T->set_var('currentbackups', inm_listBackups());
    }

    if (isset($valid['dbscan']) || isset($valid['dbbackup'])){
        switch ($valid['submit']){
            case $LANG_INM06[76]:
                //perform scan
            case $LANG_INM06[90]:
                //perform repair
                inm_scan1($valid,$T);
                break;
            case $LANG_INM06[77]:
                //perform scan
            case $LANG_INM06[91]:
                //repair
                inm_scan2($valid,$T);
                break;
            case $LANG_INM06[78]:
                //perform scan
            case $LANG_INM06[92]:
                //repair
                inm_scan3($valid,$T);
                break;
            case $LANG_INM06[79]:
                //perform scan
            case $LANG_INM06[93]:
                //repair
                inm_scan4($valid,$T);
                break;
            case $LANG_INM06[84]:
                //perform backup
                //display result
                $backup = inm_backup();//this needs to change in order to output possible errors
                $T->set_var('bkresult', sprintf($LANG_INM06[88], $backup));
                break;
        }
    }

    $T->parse('output','page');
    $retval = $T->finish($T->get_var('output'));
    return $retval;
}

function inm_staticForm(){
    global $_CONF, $LANG_INM06;

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array ('page' => 'static-form.thtml'));
    
    $T->set_var('action', $_CONF['site_admin_url'] . '/plugins/inmemoriam/index.php');
    $T->set_var('generatethumbs', $LANG_INM06[68]);
    $T->set_var('generatescaled', $LANG_INM06[69]);
    $T->set_var('delete', $LANG_INM06[70]);
    $T->set_var('langstatic', $LANG_INM06[71]);

    $T->parse('output','page');
    $retval = $T->finish($T->get_var('output'));
    return $retval;
}

//generates static thumbs
function inm_generateStatic($type){//not that kind of static :P
    global $INM_CONF, $LANG_INM06, $INM_TABLES;

    //get all albums
    $result = DB_query("SELECT id, path FROM {$INM_TABLES['albums']}");
    if (DB_numRows($result) < 1){
        //no albums exist
        return $LANG_INM06[73];
    }
    //loop thru albums
    $i = 0;
    $t = 0;
    while ($A = DB_fetchArray($result)){
        $mres = DB_query("SELECT aid, filename FROM {$INM_TABLES['media']} WHERE aid='{$A['id']}'");
        if (DB_numRows($mres) < 1){
            continue;
        }
        //loop thru media
        while ($M = DB_fetchArray($mres)){
            if (inm_isFile($A['path'] . $M['filename'])){
                if ($type == 'thumb'){
                    if (!inm_isDir($INM_CONF['path_thumbs'])){
                        if (!@mkdir ($INM_CONF['path_thumbs'])){
                            //permissions error
                            return $LANG_INM06[74];
                        }
                    }
                    if (!inm_isDir($INM_CONF['path_thumbs'] . $M['aid'])){
                        if (!@mkdir ($INM_CONF['path_thumbs'] . $M['aid'])){
                            //permissions error
                            return $LANG_INM06[74];
                        }
                    }
                    $j = inm_makeThumb($A['path'], $M['filename'], $M['aid']);
                    $t = $t + $j;
                } elseif ($type == 'scale'){
                    if (!inm_isDir($INM_CONF['path_scaled'])){
                        if (!@mkdir ($INM_CONF['path_scaled'])){
                            //permissions error
                            return $LANG_INM06[74];
                        }
                    }
                    if (!inm_isDir($INM_CONF['path_scaled'] . $M['aid'])){
                        if (!@mkdir ($INM_CONF['path_scaled'] . $M['aid'])){
                            //permissions error
                            return $LANG_INM06[74];
                        }
                    }
                    $j = inm_makeScaled($A['path'], $M['filename'], $M['aid']);
                    if ($j == 1){
                        $i = $i + $j;
                    }
                }
            } else {
                //else msg: file doesn't exist, check your database
            }
            if ($t >= 300){
                break 2;
            }
            if ($i >= 200){
                break 2;
            }
        }
    }
    if ($i > 0){
        $n = $i;
    }
    if ($t > 0){
        $n = $t;
    }
    //success
    return sprintf($LANG_INM06[75], $n);
}

//creates and saves a static thumbnail
function inm_makeThumb($oldpath, $filename, $adir){
    global $INM_CONF, $_CONF;

    $oldpath = $oldpath . $filename;
    $newpath = array (
        1 => $INM_CONF['path_thumbs'] . $adir . '/' . $INM_CONF['thumb_prefix'][1] . $filename,//small
        2 => $INM_CONF['path_thumbs'] . $adir . '/' . $INM_CONF['thumb_prefix'][2] . $filename,//medium
        3 => $INM_CONF['path_thumbs'] . $adir . '/' . $INM_CONF['thumb_prefix'][3] . $filename//large
       );

    require_once ($_CONF['path'] . 'plugins/inmemoriam/image-functions.inc');
    $library = inm_imageLib('');
    $i = 0;
    foreach ($newpath as $key => $value){
        if (!inm_isFile($value)){
            $thumb = Image_Transform::factory($library);
            $thumb->load($oldpath);
            // next will resize so that the longest edge equals $size preserving aspect ratio
            $thumb->scale($INM_CONF['thn_auto_size'][$key]);
            //save the resized image
            $extension = substr(strrchr($value, '.'),1);
            $thumb->save($value, $extension, $INM_CONF['thumb_quality']);
            // Now free the memory
            $thumb->free();
            $i++;
        }
    }
    return $i;
}

//creates and saves a static image according to an album's max x & y
function inm_makeScaled($oldpath, $filename, $adir){
    global $INM_CONF, $_CONF, $INM_TABLES;

    $oldpath = $oldpath . $filename;
    $newpath = $INM_CONF['path_scaled'] . $adir . '/' . $filename;
    $result = DB_query("SELECT maxw, maxh FROM {$INM_TABLES['albums']} WHERE id='$adir' LIMIT 1");
    list($maxX,$maxY) = DB_fetchArray($result);

    require_once ($_CONF['path'] . 'plugins/inmemoriam/image-functions.inc');
    $library = inm_imageLib('');

    $i = 0;
    if (!inm_isFile($newpath)){
        $image = Image_Transform::factory($library);
        $image->load($oldpath);
        // resize so that image remains constrained by max width and height while preserving aspect ratio
        // if image smaller then restrictions--then no resize
        $image->fit($maxX,$maxY);
        //save the resized image
        $extension = substr(strrchr($filename, '.'),1);
        $image->save($newpath, $extension, $INM_CONF['scaled_quality']);
        // Now free the memory
        $image->free();
        $i++;
    }
    return $i;
}

/**
* Main 
*/

$pagetitle = $LANG_INM06[27];
$display = inm_siteHeader($pagetitle);

$display .= COM_startBlock($LANG_INM01[11] . ' -- ' . $LANG_INM01[12]);
$display .= inm_menurow();

if ($_POST['submit'] == $LANG_INM06[13]){
    // update config
    $display .= inm_showintro($LANG_INM06[26]);
    $display .= COM_endBlock();
    $display .= COM_startBlock($LANG_INM06[23]);
    $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
    $valid = inm_validateInput('admin');
    if (is_array($valid)){
        $display .= inm_updateConfig($valid) . '<br />';
    } else {
        // input error
        $display .= $LANG_INM04[1] . '<br />';
    }
    $display .= inm_configForm();

} elseif ($_POST['submit'] == $LANG_INM06[15]){
    // apply default config
    $display .= inm_showintro($LANG_INM06[26]);
    $display .= COM_endBlock();
    $display .= COM_startBlock($LANG_INM06[23]);
    $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
    $display .= inm_defaultConfig() . '<br />';
    $display .= inm_configForm();

} elseif ($_POST['submit'] == $LANG_INM06[37]){
    // update db according to scan results--no review
    $display .= inm_showintro($LANG_INM06[42]);
    $display .= COM_endBlock();
    $display .= COM_startBlock($LANG_INM06[41]);
    $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
    $valid = inm_validateInput('ftp');
    if (is_array($valid)){
        $display .= inm_autoUpdate($valid);
        // autoUpdate scans first, updates db immediately using album defaults accross the board,
        // (for now these defaults can be changed via your database too, e.g., phpmyadmin)
        // and returns successes and errors
    } else {
        // input error
        $display .= $LANG_INM04[1];
        $display .= inm_ftpForm();
    }

} elseif ($_POST['submit'] == $LANG_INM06[38]){
    // review scan results
    $display .= inm_showintro($LANG_INM06[42]);
    $display .= COM_endBlock();
    $display .= COM_startBlock($LANG_INM06[41]);
    $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
    $display .= inm_manualUpdate();

} elseif (isset($_POST['applychecked'])){
    // manualUpdate updates db according to user input, and returns successes and errors
    $display .= inm_showintro($LANG_INM06[42]);
    $display .= COM_endBlock();
    $display .= COM_startBlock($LANG_INM06[41]);
    $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
    $valid = inm_validateInput('ftp');
    if (is_array($valid)){
        $display .= inm_dbUpdate($valid);
    } else {
        // input error
        $display .= $LANG_INM04[1];
        $display .= inm_ftpForm();
    }

} elseif (isset($_POST['dbscan']) || isset($_POST['dbbackup'])){
    // update db according to db check results
    $display .= inm_showintro($LANG_INM06[43]);
    $display .= COM_endBlock();
    $display .= COM_startBlock($LANG_INM06[40]);
    $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
    $valid = inm_validatePost();
    if (is_array($valid)){
        $display .= inm_dbForm($valid);
    } else {
        //input error
        $display .= $LANG_INM04[1];
    }

} elseif (isset($_POST['static'])){
    // process static images
    $display .= inm_showintro($LANG_INM06[72]);
    $display .= COM_endBlock();
    $display .= COM_startBlock($LANG_INM06[41]);
    $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
    $valid = inm_validatePost();
    $display .= inm_staticForm();
    if (is_array($valid)){
        switch ($_POST['submit']){
            case $LANG_INM06[68]:
                $display .= inm_generateStatic('thumb');
                break;
            case $LANG_INM06[69]:
                $display .= inm_generateStatic('scale');
                break;
            case $LANG_INM06[70]:
                $display .= inm_deleteStatic();
                break;
        }
    } else {
        //input error
        $display .= $LANG_INM04[1];
    }

} elseif (!empty($_GET['cfg'])){
    $cfg = $_GET['cfg'];
    switch ($cfg){
        case 'manftp':
            //display album management console
            $display .= inm_showintro($LANG_INM06[42]);
            $display .= COM_endBlock();
            $display .= COM_startBlock($LANG_INM06[39]);
            $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
            $display .= inm_ftpForm();
            break;
        case 'database':
            //display database management console
            $display .= inm_showintro($LANG_INM06[43]);
            $display .= COM_endBlock();
            $display .= COM_startBlock($LANG_INM06[40]);
            $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
            $display .= inm_dbForm();
            break;
        case 'static':
            //display static image generation console
            $display .= inm_showintro($LANG_INM06[72]);
            $display .= COM_endBlock();
            $display .= COM_startBlock($LANG_INM06[66]);
            $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
            $display .= inm_staticForm();
            break;
        case 'general':
            //display config editor
        default:
            //display config editor
            $display .= inm_showintro($LANG_INM06[26]);
            $display .= COM_endBlock();
            $display .= COM_startBlock($LANG_INM06[23]);
            $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
            $display .= inm_configForm();
    }
} else {
    //default to general admin
    $display .= inm_showintro($LANG_INM06[26]);
    $display .= COM_endBlock();
    $display .= COM_startBlock($LANG_INM06[23]);
    $display .= '<p class="inm-linkrow">' . inm_adminMenu() . '</p>';
    $display .= inm_configForm();
}

$display .= COM_endBlock();
$display .= inm_poweredBy();
$display .= inm_siteFooter();

echo $display;
?>