<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | config.php                                                                |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

$INM_CONF['version'] = '1.0.1';
$INM_CONF['pi_name'] = 'inmemoriam';


// Tables to define as Global
$INM_TABLES['albums']         = $_DB_table_prefix . 'inm_albums';
$INM_TABLES['media']          = $_DB_table_prefix . 'inm_media';
$INM_TABLES['settings']       = $_DB_table_prefix . 'inm_settings';
$INM_TABLES['watermarks']     = $_DB_table_prefix . 'inm_watermarks';
//$INM_TABLES['exif']           = $_DB_table_prefix . 'inm_exif';
$INM_TABLES['favorites']      = $_DB_table_prefix . 'inm_favorites';

// default public_html/inmemoriam path and url.
// if you are going to change this path, do it before your install
// or make sure that you move your files to match.
// also, ensure that you change both lines.
$INM_CONF['path_html']      = $_CONF['path_html'] . 'inmemoriam/';
$INM_CONF['url_html']       = $_CONF['site_url'] . '/inmemoriam';

// default album, watermark, and log paths
// hopefully this is above the doc root
$INM_CONF['path_albums']    = $_CONF['path'] . 'plugins/inmemoriam/albums/';
$INM_CONF['path_wm']        = $_CONF['path'] . 'plugins/inmemoriam/watermarks/';
$INM_CONF['path_logs']      = $_CONF['path'] . 'plugins/inmemoriam/logs/';

// specify the name of your default watermark image.
// ensure that this image can be found in your $INM_CONF['path_wm'].
// Inmemoriam will only accept png images
$INM_CONF['default_wm']     = 'gray_copyright.png';

// specify the font to use in your text watermarks
$INM_CONF['font']           = $_CONF['path'] . 'plugins/inmemoriam/fonts/arial.ttf';

// default paths to static images if any
$INM_CONF['path_thumbs']    = $_CONF['path'] . 'plugins/inmemoriam/thumbnails/';
$INM_CONF['path_scaled']    = $_CONF['path'] . 'plugins/inmemoriam/scaled/';

//compression defaults
//these values apply to static images as well as those created on the fly.
//the full size view is 100% quality by default and is hard coded.
$INM_CONF['thumb_quality']     = '75';
$INM_CONF['scaled_quality']    = '85';


//static thumbnail prefix
$INM_CONF['thumb_prefix']    = array
(
    1 => 'TH1_',// small thumbnail
    2 => 'TH2_',// medium thumbnail
    3 => 'TH3_'// large thumbnail
);

/*
 * the whats new settings should go in the db for next version
 * making them adjustable from the admin panel.
 */

// Number of days to show new media in WhatsNewBlock
$INM_CONF['whatsnewperioddays'] = 14;//number of days
// String length for media titles in WhatsNewBlock
$INM_CONF['whatsnewnamelength'] = 20;

// minimum time interval for submitting a rating
$INM_CONF['ratingspeedlimit'] = '45';//time is in seconds

//available themes
$INM_CONF['themes'] = array
(
    'default',
    'shade',
    'light',
    'rose',
    'bluethunder',
    'yellowcascade'
);

//available frames
$INM_CONF['frames'] = array
(
    'default',
    'shade',
    'polaroid',
    'wood',
    'copper',
    'steel'
);

//allowable watermark extensions
$INM_CONF['wm_ext'] = array
(
    '.png'
);

/*
 * All these allowable extensions can go in the database for v.2.
 * They can then be marked allowed/disallowed from the admin panel.
 * MimeTypes will be preset.
 */

//allowable image extensions
$INM_CONF['image_ext'] = array
(
    '.jpg'  => 'image/jpeg',
    '.jpeg' => 'image/jpeg',
    //'.gif'  => 'image/gif',//requires GD version < 1.6 or > 2.0.28
    '.png'  => 'image/png'
);

//allowable audio extensions
$INM_CONF['aud_ext'] = array
(
    '.mp3'  => 'audio/mpeg3',
    '.wav'  => 'audio/wav',
    '.ogg'  => 'application/ogg'
);

//allowable video extensions
$INM_CONF['vid_ext'] = array
(
    '.mov'  => 'video/quicktime',
    '.wmv'  => 'video/x-ms-wmv',
    '.avi'  => 'video/avi',
    '.mpeg' => 'video/mpeg'
);

//allowable document formats
$INM_CONF['cod_ext'] = array
(
    '.php'  => 'application/plain',
    '.html' => 'application/plain',
    '.htm'  => 'application/plain',
    '.css'  => 'application/plain',
    '.txt'  => 'application/plain',
    '.pdf'  => 'application/pdf',
    '.rtf'  => 'application/rtf',
    '.xlc'  => 'application/excel',
    '.doc'  => 'application/msword'
);

//default thumbnail div sizes in pixels
$INM_CONF['thd_width'] = array
(
    1 => '125',
    2 => '158',
    3 => '220'
);
$INM_CONF['thd_height'] = array
(
    1 => '193',
    2 => '236',
    3 => '300'
);

//default thumbnail sizes in pixels
//not in use atm except for auto size
/*
$INM_CONF['thn_width'] = array
(
    1 => '',
    2 => '',
    3 => '',
);
$INM_CONF['thn_height'] = array
(
    1 => '',
    2 => '',
    3 => '',
);
*/
$INM_CONF['thn_auto_size'] = array
(
    1 => '85',
    2 => '128',
    3 => '192',
);


if (!defined ('LB')) {
    define('LB',"\n");
}

?>