<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | functions.inc                                                             |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

/*
* Include inmemoriam upload class file
*/
require_once ($_CONF['path'] . 'plugins/inmemoriam/classes/inmUpload.class1.php');

/*
* Include inmemoriam image functions file
*/
require_once ($_CONF['path'] . 'plugins/inmemoriam/image-functions.inc');

/*
* Include inmemoriam config file
*/
require_once ($_CONF['path'] . 'plugins/inmemoriam/config.php');

/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/inmemoriam/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) 
{
    include_once ($langfile);
}
else 
{
    include_once ($_CONF['path'] . 'plugins/inmemoriam/language/english.php');
}


// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* @return    array   Associative array of menu items to be added to menu
*
*/
function plugin_getmenuitems_inmemoriam()
{
    global $_USER, $LANG_INM01, $INM_TABLES, $INM_CONF;

    // Retrieve access Settings
/*
    $result = DB_query("SELECT anonview, enable_splash, enable_menuitem FROM {$INM_TABLES['settings']}");
    list($anonview,$splash,$menuitem) = DB_fetchArray($result);

    if ((($anonview == '1' && $_USER['uid'] < 2) || ($_USER['uid'] > 1)) && ($menuitem == 1)) {
*/

/* if you want the admin option to turn on/off the menuitem, then you need to replace the next 3 lines
*  with the 3 lines that are currently commented out above.
*/

    $result = DB_query("SELECT anonview, enable_splash FROM {$INM_TABLES['settings']}");//replace this line***
    list($anonview,$splash) = DB_fetchArray($result);//replace this line***

    if (($anonview == '1' && $_USER['uid'] < 2) || $_USER['uid'] > 1) {//replace this line***
        $menulabel = $LANG_INM01[1];//menu label
        $menuurl = $INM_CONF['url_html'] . '/index.php';  //menu url

        if ($splash == 1) {
            $menuurl .= '?splash=1';
        }

        $menuitems = array();
        $menuitems[$menulabel] = $menuurl;
    }
    return $menuitems;
}

/**
  * Whats New Block API Support
*/
function plugin_whatsnewsupported_inmemoriam(){
    global $INM_TABLES, $LANG_INM01, $INM_CONF, $_USER;

    $result = DB_query("SELECT anonview, whatsnew FROM {$INM_TABLES['settings']}");
    list($anonview, $enabled) = DB_fetchArray($result);

    if ($enabled == '1'){
        if ($anonview == '0' && $_USER['uid'] < 2){
            return;
        } else {
            return array($LANG_INM01[33],sprintf($LANG_INM01[34], $INM_CONF['whatsnewperioddays']));
        }
    } else return;
}

/**
  * API function provides the content of our "What's New" feed
  * This will return a list of media items or albums with a new media count
  * depending on the admin setting.
*/
function plugin_getwhatsnew_inmemoriam(){
    global $INM_TABLES, $_CONF, $LANG_INM01, $INM_CONF;

    $result = DB_query("SELECT whatsnew, listtype FROM {$INM_TABLES['settings']}");
    list($enabled,$listtype) = DB_fetchArray($result);

    if ($enabled == '1'){
        $option = DB_getItem($INM_TABLES['settings'], 'whatsnew');
        if ($listtype == '2'){
            //returns a count of new media items per album.
            $sql = "SELECT aid, COUNT(*) as count FROM {$INM_TABLES['media']} WHERE date >= DATE_SUB(NOW(), INTERVAL {$INM_CONF['whatsnewperioddays']} DAY ) AND status='0'" . COM_getPermSQL('and') . " GROUP BY aid ORDER BY Date DESC LIMIT 15";
            $result = DB_query($sql);
            $nrows = DB_numRows($result);
            if( $nrows == 0 ) {
                $items = $LANG_INM01[35] . LB;
            } else {
                $items = array();
                for( $i = 0; $i < $nrows; $i++ ) {
                    list($id, $count) = DB_fetchArray( $result );
                    if (inm_hasAlbumAccess($id) >= 2){
                        $name = DB_getItem($INM_TABLES['albums'], 'name', "id='$id'");
                        $str = "<a href=\"{$INM_CONF['url_html']}/browse.php?id=$id\">";
                        if(!empty($name)){
                            $str .= stripslashes(substr($name,0,$INM_CONF['whatsnewnamelength']));
                        } else {
                            $str .= 'album #' . $id;
                        }
                        $str .= '</a> (' . $count . ')' . LB;
                        $items[] = $str;
                    }
                }
            }
        } elseif ($listtype = '1'){
            //returns a list of new media items
            $sql = "SELECT mid, filename, title FROM {$INM_TABLES['media']} WHERE date >= DATE_SUB(NOW(), INTERVAL {$INM_CONF['whatsnewperioddays']} DAY ) AND status='0'" . COM_getPermSQL('and') . " ORDER BY Date DESC LIMIT 15";
            $result = DB_query($sql);
            $nrows = DB_numRows($result);
            if( $nrows == 0 ) {
                $items = $LANG_INM01[35] . '<br />' . LB;
            } else {
                $items = array();
                for( $i = 0; $i < $nrows; $i++ ) {
                    list($mid, $title, $filename) = DB_fetchArray( $result );
                    if (inm_hasMediaAccess($mid) >= 2){
                        $str = "<a href=\"{$INM_CONF['url_html']}/browse.php?mid=$mid\">";
                        if(!empty($title)){
                            $str .= COM_stripslashes(substr($title,0,$INM_CONF['whatsnewnamelength']));
                        } else {
                            $str .= COM_stripslashes(substr($filename,0,$INM_CONF['whatsnewnamelength']));
                        }
                        $str .= '</a>' . LB;
                        $items[] = $str;
                    }
                }
            }
        }

        return $items;
    } else return '';
}

/**
 * Include if plugin will be supporting comments
*/
function plugin_commentsupport_inmemoriam()
{
    // Inmemoriam's use of comments is disabled pending Geeklog 1.3.12
    // after which time this particular function will be obselete it seems.
    return false;
}


//reassigns media, if any, to admin upon user delete
function plugin_user_delete_inmemoriam($uid){
    global $INM_TABLES, $_TABLES;

    //new owner will be uid=2, site admin.

    //check if media owned by uid
    $result = DB_query("SELECT mid FROM {$INM_TABLES['media']} WHERE owner_id='$uid'");
    //reassign media
    if(DB_numRows($result) >= 1){
        DB_query("UPDATE {$INM_TABLES['media']} SET owner_id='2' WHERE owner_id='$uid'");
        //uncomment the following if you would rather delete this media than update it
        //don't forget to comment out the update line
        //DB_delete({$INM_TABLES['media']}, 'owner_id', "$uid");
    }

    //check if albums owned by uid
    $result = DB_query("SELECT id FROM {$INM_TABLES['albums']} WHERE owner_id='$uid'");
    //reassign albums and disable regular access
    if(DB_numRows($result) >= 1){
        DB_query("UPDATE {$INM_TABLES['albums']} SET owner_id='2', perm_members='0', perm_anon='0' WHERE owner_id='$uid'");
        //uncomment the following if you would rather delete this media than update it.
        //don't forget to comment out the update line
        //DB_delete({$INM_TABLES['albums']}, 'owner_id', "$uid");
    }

    //delete any favorite belonging to user
    DB_query("DELETE FROM {$INM_TABLES['favorites']} WHERE uid='$uid'");
}

//displays a block of last 10 by uid on the relevant profile page
function plugin_profileblocksdisplay_inmemoriam($uid){
    global $_CONF, $INM_TABLES, $LANG_INM01, $_TABLES, $INM_CONF;
    $result = DB_query("SELECT mid, filename, title FROM {$INM_TABLES['media']} WHERE owner_id='$uid'" . COM_getPermSQL('and') . " ORDER BY date DESC LIMIT 10");
    if (DB_numRows($result) < 1){
        return;
    }
    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file('profile','profile.thtml');
    $username = DB_getItem($_TABLES['users'], 'username', "uid='$uid'");
    $retval = COM_startBlock(sprintf($LANG_INM01[44], $username));
    while ($M = DB_fetchArray($result)){
        $T->set_var('url', $INM_CONF['url_html'] . '/browse.php?mid=' . $M['mid']);
        $extension = strtolower(strrchr($M['filename'],"."));
        if (array_key_exists($extension, $INM_CONF['image_ext'])){
            $src = $INM_CONF['url_html'] . '/image.php?mid=' . $M['mid'] . '&amp;thumb=1&amp;size=1';
        } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
            $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;aud=1&amp;size=1';
        } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
            $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;vid=1&amp;size=1';
        } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
            $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;cod=1&amp;size=1';
        }
        $T->set_var('src', $src);
        if (!empty($M['title'])){
            $title = COM_stripslashes($M['title']);
        } else $title = COM_stripslashes($M['filename']);
        $T->set_var('title', $title);
        $T->parse('output', 'profile', true);
    }
    $retval .= $T->finish($T->get_var('output'));
    $retval .= '<div class="inm-clear">&nbsp;</div>';
    $retval .= COM_endBlock();
    return $retval;
}

/**
* Shows the statistics for the plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the plugin
*
* @param    int showsitestate   Flag to let us know which stats to get
* @return   string  returns formatted HTML to insert in stats page
*
*/
function plugin_showstats_inmemoriam($showsitestats)
{
    global $_CONF, $_USER, $INM_TABLES, $LANG_INM01, $_TABLES, $INM_CONF;

    // Retrieve access Settings
    $query = DB_query("SELECT anonview FROM {$INM_TABLES['settings']}");
    list($anonview) = DB_fetchArray($query);

    // Check user has rights to view this cb, if so, do it.
    if ((($anonview == '1') && ($_USER['uid'] < 2)) || ($_USER['uid'] > 1)) {

        if ($showsitestats == 1) {
            $result = DB_query("SELECT COUNT(*) as count FROM {$INM_TABLES['media']} WHERE status='0'" . COM_getPermSQL('and'));
            list($total) = DB_fetchArray($result);
            $retval = "<table border = '0' width='100%' cellspacing='0' cellpadding='0'>";
            $retval .= "<tr><td>" . $LANG_INM01['numitems'] . "</td>";
            $retval .= "<td align='right'>" . $total . "&nbsp;&nbsp </td></tr></table>";
        } else {
            //show top ten media
            $result = DB_query("SELECT mid, filename, hits, title FROM {$INM_TABLES['media']} WHERE hits<>'0' AND status='0'" . COM_getPermSQL('and') . " ORDER BY hits DESC LIMIT 10");
            $numrows = DB_numRows($result);
            $retval .= COM_startBlock($LANG_INM01[22]);
            if ($numrows > 0) {
                $stat_templates = new Template($_CONF['path_layout'] . 'stats');
                $stat_templates->set_file(array('itemstats'=>'itemstatistics.thtml',
                                        'statrow'=>'singlestat.thtml'));
                $stat_templates->set_var('item_label', $LANG_INM01[42]);
                $stat_templates->set_var('stat_name', $LANG_INM01[23]);
                for ($i = 0; $i < $numrows; $i++) {
                    $A = DB_fetchArray($result);
                    $stat_templates->set_var('item_url', $INM_CONF['url_html'] . '/browse.php?mid=' . $A['mid']);
                    if (!empty($A['title'])){
                        $title = COM_stripslashes($A['title']);
                    } else $title = COM_stripslashes($A['filename']);
                    $stat_templates->set_var('item_text', $title);
                    $stat_templates->set_var('item_stat', $A['hits']);
                    $stat_templates->parse('stat_row','statrow',true); 
                }
                $stat_templates->parse('output','itemstats');
                $retval .= $stat_templates->finish($stat_templates->get_var('output'));
            } else {
                $retval .= $LANG_INM01[24];
            }
            $retval .= COM_endBlock();

            //show top ten rated media
            $result = DB_query("SELECT mid, filename, title, totalrating/numvotes as rate FROM {$INM_TABLES['media']} WHERE status='0' AND totalrating<>'0'" . COM_getPermSQL('and') . " ORDER BY rate DESC LIMIT 10");
            $numrows = DB_numRows($result);
            $retval .= COM_startBlock($LANG_INM01[27]);
            if ($numrows > 0) {
                $stat_templates = new Template($_CONF['path_layout'] . 'stats');
                $stat_templates->set_file(array('itemstats'=>'itemstatistics.thtml',
                                        'statrow'=>'singlestat.thtml'));
                //$stat_templates->clear_var('stat_row');
                $stat_templates->set_var('item_label', $LANG_INM01[42]);
                $stat_templates->set_var('stat_name', $LANG_INM01[28]);
                for ($i = 0; $i < $numrows; $i++) {
                    $A = DB_fetchArray($result);
                    $stat_templates->set_var('item_url', $INM_CONF['url_html'] . '/browse.php?mid=' . $A['mid']);
                    if (!empty($A['title'])){
                        $title = COM_stripslashes($A['title']);
                    } else $title = COM_stripslashes($A['filename']);
                    $stat_templates->set_var('item_text', $title);
                    $stat_templates->set_var('item_stat', $A['rate'] . '/10');
                    $stat_templates->parse('stat_row','statrow',true); 
                }
                $stat_templates->parse('output','itemstats', true);
                $retval .= $stat_templates->finish($stat_templates->get_var('output'));
            } else {
                $retval .= $LANG_INM01[30];
            }
            $retval .= COM_endBlock();

            //show top ten users
            $result = DB_query("SELECT owner_id, COUNT(*) as count FROM {$INM_TABLES['media']} WHERE status='0'" . COM_getPermSQL('and') . " GROUP BY owner_id ORDER BY count DESC LIMIT 10");
            $numrows = DB_numRows($result);
            $retval .= COM_startBlock($LANG_INM01[25]);
            if ($numrows > 0) {
                $stat_templates = new Template($_CONF['path_layout'] . 'stats');
                $stat_templates->set_file(array('itemstats'=>'itemstatistics.thtml',
                                        'statrow'=>'singlestat.thtml'));
                //$stat_templates->clear_var('stat_row');
                $stat_templates->set_var('item_label', $LANG_INM01[43]);
                $stat_templates->set_var('stat_name', $LANG_INM01[26]);
                for ($i = 0; $i < $numrows; $i++) {
                    $A = DB_fetchArray($result);
                    $stat_templates->set_var('item_url', $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $A['owner_id']);
                    $username = DB_getItem($_TABLES['users'], 'username', "uid='{$A['owner_id']}'");
                    $stat_templates->set_var('item_text', COM_stripslashes($username));
                    $stat_templates->set_var('item_stat', $A['count']);
                    $stat_templates->parse('stat_row','statrow',true); 
                }
                $stat_templates->parse('output','itemstats', true);
                $retval .= $stat_templates->finish($stat_templates->get_var('output'));
            } else {
                $retval .= $LANG_INM01[29];
            }

            //$retval .= $stat_templates->finish($stat_templates->get_var('output'));
            $retval .= COM_endBlock();
        }
        return $retval;
    }
}

/**
* This will put an option for the plugin in the command and control block on moderation.php
*
* @return   array   Array containing (plugin name, admin url, url of plugin icon)
*
*/
function plugin_cclabel_inmemoriam()
{
    global $_CONF, $LANG_INM01, $INM_CONF;

    return array($LANG_INM01[11],$_CONF['site_admin_url'] . '/plugins/inmemoriam/index.php',$INM_CONF['url_html'] . '/images/inmemoriamsingle.gif');
}

/**
* Returns the administrative option for this plugin
*
* @return   array   Array containing (plugin name, plugin admin url, # of items in plugin or '')
*
*/
function plugin_getadminoption_inmemoriam()
{
    global $_CONF, $INM_TABLES, $LANG_INM01;

    if (SEC_inGroup('Root')) {
        $result = DB_query("SELECT COUNT(*) FROM {$INM_TABLES['media']} WHERE status='0'");
        list($media) = DB_fetchArray($result);
        return array($LANG_INM01[4], $_CONF['site_admin_url'] . '/plugins/inmemoriam/index.php', $media);
    }
}

/**
* Returns the user option for this plugin
*
* @return   array   Array containing (plugin name, plugin user url, 0)
*
*/
function plugin_getuseroption_inmemoriam()
{
    global $_CONF, $_USER, $LANG_INM01, $INM_TABLES, $INM_CONF;

    // Retrieve access settings
    $query = DB_query("SELECT loginadd FROM {$INM_TABLES['settings']}");
    list($loginadd) = DB_fetchArray($query);

    if (SEC_hasRights('inmemoriam.admin')){
        $where = " WHERE";
    } else $where = "WHERE a.owner_id='{$_USER['uid']}' AND";

    $result = DB_query("SELECT STRAIGHT_JOIN COUNT(*) as queued FROM {$INM_TABLES['albums']} a, {$INM_TABLES['media']} m " . $where . " m.status='1' AND m.aid=a.id");
    list($queued) = DB_fetchArray($result);

    if ($queued >= 1 || ($queued >= 1 && SEC_hasRights('inmemoriam.admin'))){
        //return moderation link
        return array($LANG_INM01[9], $INM_CONF['url_html'] . '/queue.php', $queued);
    }
    if (($loginadd == '1' && $_USER['uid'] > 2) || SEC_hasRights('inmemoriam.add') || SEC_hasRights('inmemoriam.admin')){
        //return add media link
        if (SEC_hasRights('inmemoriam.admin')){
            $where = '';
        } else {
            $where = " WHERE allow_submit='1' OR owner_id='{$_USER['uid']}'";
        }
        $result = DB_query("SELECT id FROM {$INM_TABLES['albums']}" . $where);
        if (DB_numRows($result) >= 1){
            return array($LANG_INM01[5], $INM_CONF['url_html'] . '/media.php', 0);
        } else return;
    }
}

//adds variables to the user's profile
//function plugin_profilevariablesdisplay_inmemoriam($uid, &$template)
//{
//}


//adds total stats to the user's profile
//function plugin_profilestatsvariablesdisplay_inmemoriam ($uid, &$template)
//{
//}

/**
* Geeklog is asking us to provide any new items that show up in the type drop-down
* on search.php.
*
*/
function plugin_searchtypes_inmemoriam() 
{
    global $LANG_INM01;

    $ret['inmemoriam'] = $LANG_INM01[19];
    return $ret;
}

/**
* this searches for pages matching the user query and returns an array of 
* for the header and table rows back to search.php where it will be formated and
* printed 
*
* @query            string          Keywords user is looking for
* @datestart        date/time       Start date to get results for
* @dateend          date/time       End date to get results for
* @topic            string          The topic they were searching in
* @type             string          Type of items they are searching
* @author           string          Get all results by this author
*
*/
function plugin_dopluginsearch_inmemoriam($query, $datestart, $dateend, $topic, $type, $author) 
{
    global $_TABLES, $_CONF, $_USER, $LANG_INM00, $LANG_INM01, $LANG_INM08, $LANG_INM10, $INM_TABLES, $INM_CONF;

    // Retrieve access Settings
    $access = DB_query("SELECT anonview FROM {$INM_TABLES['settings']}");
    list($anonview) = DB_fetchArray($access);

    // Check user has rights to view this results, if so, do it.
    if ((($anonview == '1') && ($_USER['uid'] < 2)) || ($_USER['uid'] > 1)) {
        if (empty($type)) {
            $type = 'all';
        }

        // Bail if we aren't supppose to do our search
        if ($type <> 'all' AND $type <> 'inmemoriam') {
            $plugin_results = new Plugin();
            $plugin_results->plugin_name = $INM_CONF['pi_name'];
            $plugin_results->searchlabel = $LANG_INM01[19] . $LANG_INM01[20];
            return $plugin_results;
        }

        $query = addslashes($query);
        //if (empty($query)){
        //    return;
        //}

        // Build search SQL
        $sql = "SELECT DISTINCT aid, mid, filename, title, caption, owner_id, username";
        $sql .= " FROM {$INM_TABLES['media']} m, {$_TABLES['users']}";
        $sql .= " WHERE (m.status='0' AND uid=owner_id)";
        $sql .= " AND (keywords like '%$query%'";
        $sql .= " OR title like '%$query%'";
        $sql .= " OR caption like '%$query%'";
        $sql .= " OR username like '%$query%')";

        if (!empty($datestart) && !empty($dateend)) {
            $delim = substr($datestart, 4, 1);
            $DS = explode($delim,$datestart);
            $DE = explode($delim,$dateend);
            $startdate = mktime(0,0,0,$DS[1],$DS[2],$DS[0]);
            $enddate = mktime(0,0,0,$DE[1],$DE[2],$DE[0]) + 3600;
            $sql .= " AND (UNIX_TIMESTAMP(date) BETWEEN '$startdate' AND '$enddate')";
        }

        if (!empty($author)) {
            $sql .= " AND owner_id='$author'";
        }

        $sql .= " ORDER BY date DESC, mid DESC";
        COM_errorLOG("inmemoriam Search: ".$sql);

        // Perform search
        $result = DB_query($sql);

        // OK, now create new plugin object and insert table header labels
        require_once($_CONF['path_system'] . 'classes/plugin.class.php');
        $plugin_results = new Plugin();
        $plugin_results->plugin_name = $INM_CONF['pi_name'];
        $plugin_results->searchlabel = $LANG_INM01[20];//lang results
        $plugin_results->addSearchHeading($LANG_INM08[28]);//title
        $plugin_results->addSearchHeading($LANG_INM08[27]);//caption
        $plugin_results->addSearchHeading($LANG_INM10[4]);//photographer
        $mycount = DB_numRows($result);

        // NOTE if any of your data items need to be links then add them here! 
        // make sure data elements are in an array and in the same order as your
        // headings above!
        for ($i = 1; $i <= $mycount; $i++) {
            $A = DB_fetchArray($result);
            //check access to media and container albums
            $pid = DB_getItem($INM_TABLES['albums'], 'pid', "aid='{$A['aid']}'");
            if (!empty($pid)) {
                $access = min(inm_hasAlbumAccess($pid),inm_hasAlbumAccess($A['aid']),inm_hasMediaAccess($A['mid']));
            } else {
                $access = min(inm_hasAlbumAccess($A['aid']),inm_hasMediaAccess($A['mid']));
            }
            if ($access >= 2){
                if (strlen($A['title']) > 64){
                    $title = substr(COM_stripslashes($A['title']), 0, 64) . '...';
                } elseif (!empty($A['title'])){
                    $title = COM_stripslashes($A['title']);
                } else $title = COM_stripslashes($A['filename']);
                if (strlen($A['caption']) > 64){
                    $caption = substr(COM_stripslashes($A['caption']), 0, 24) . '...';
                } elseif (empty($A['caption'])){
                    $caption = 'N/A';
                } else $caption = COM_stripslashes($A['caption']);
                $searchcount++;

                $imgurl = $INM_CONF['url_html'] . '/browse.php?mid=' . $A['mid'];
                $profile = $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $A['owner_id'];
                $row = array("<a href=\"{$imgurl}\">{$title}</a>", $caption, "<a href=\"{$profile}\">{$A['username']}</a>");
                $plugin_results->addSearchResult($row);
            }
        }
        
        $plugin_results->num_searchresults = $searchcount;
        $plugin_results->num_itemssearched = DB_count($INM_TABLES['media']);

        return $plugin_results;
    }
}

/**
* Return the current version of code. 
* Used in the Plugin Editor to show the registered version and code version
*/
function plugin_chkVersion_inmemoriam()
{
    global $INM_CONF;

    return $INM_CONF['version'];
}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_inmemoriam($installCheck='')
{
    global $_TABLES, $INM_CONF, $INM_TABLES, $LANG_INM00;

    $pi_name = $INM_CONF['pi_name'];
    $FEATURES = array ( 'inmemoriam.admin', 'inmemoriam.view', 'inmemoriam.add', 'inmemoriam.create', 'inmemoriam.fullview');
    $TABLES = array ('albums','media','settings','watermarks','favorites');
    
    // Check and see if plugin is still enabled - if so display warning and exit
    if ($installCheck != '' && DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
        COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
        $display = COM_siteHeader();
        $display .= COM_startBlock($LANG_INM00['warning']);
        $display .= $LANG_INM00['enabled'];
        $display .= COM_endBlock();
        $display .= COM_siteFooter();
        echo $display;
        exit;
    }
        
    // Ok to proceed and delete plugin -- Unregister the plugin with Geeklog
    COM_errorLog("Attempting to unregister the $pi_name plugin from Geeklog",1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = '{$pi_name}'",1);

    //delete any static images created by the plugin
    COM_errorLog("Removing static media",1);
    inm_deleteStatic();

    // Drop plugin tables
    foreach($TABLES as $table) {
        $t = $INM_TABLES["$table"];
        COM_errorLog("Removing Table $t",1);
        DB_query("DROP TABLE $t",1);
    }

    //remove plugin's blocks created by install
    COM_errorLog("Removing $pi_name blocks",1);
    DB_query("DELETE FROM {$_TABLES['blocks']} WHERE name='inmrandom' LIMIT 1",1);

    // Remove Security for this plugin
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_gid'");
    
    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_gid'");
    COM_errorLog("Removing root users from admin of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
    
    // Remove all the associated features -- access rights
    foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
    }
        
    COM_errorLog('...success',1);
    return true;
}

/**
* Called by the plugin editor to run the SQL update for a plugin update
*/
function plugin_upgrade_inmemoriam() {
    global $_TABLES, $INM_CONF;
    include ('upgrade.inc');        // Include the upgrade functions

    $curversion = DB_getItem($_TABLES['plugins'], 'pi_version', "pi_name='inmemoriam'");
    switch ($curversion) {
        case "0.8.5" :
            //database changes from 0.8.5 to 0.9.0
            if (inm_upgrade_090() == 0){
                //no database changes from 0.9.0 to 1.0cvs
                //database changes from 1.0cvs to 1.0
                if (inm_upgrade_10() == 0 ){
                    DB_query("UPDATE {$_TABLES['plugins']} SET pi_version='1.0.0' WHERE pi_name='inmemoriam' LIMIT 1");
                }
            }
            break;

        case "0.9.0" :
            //no database changes from 0.9.0 to 1.0cvs
        case "1.0cvs" :
            //database changes from 1.0cvs to 1.0
            if (inm_upgrade_10() == 0 ){
                DB_query("UPDATE {$_TABLES['plugins']} SET pi_version='1.0.0' WHERE pi_name='inmemoriam' LIMIT 1");
            }
            break;
    }
    
    /* Check if update completed and return a message number to be shown */
    if (DB_getItem($_TABLES['plugins'],'pi_version',"pi_name = 'inmemoriam'") == $INM_CONF['version']){
        return 1;
    } else {
        return 3;
    }

}

//creates a centerblock on the index page
function plugin_centerblock_inmemoriam($where=1,$page=1,$topic =''){
    global $INM_CONF, $_TABLES, $INM_TABLES, $_USER;

    $pi_name = $INM_CONF['pi_name'];     // Plugin name
    $retval = '';

    if (DB_getItem($INM_TABLES['settings'], 'anonview') == 0 && $_USER['uid'] <= 1){
        return '';
    }
    // Retrieve Centerblock Settings
    $result = DB_query("SELECT id, cntrblktype, cntrblkpage, cntrblkpos FROM {$INM_TABLES['albums']} WHERE featured='1'" . COM_getPermSQL('and'));

    // Check user has rights to view this cb, if so, do it.
    if (DB_numRows($result) == 1) {
        list($id,$type,$cntrblkpage,$cntrblkpos) = DB_fetchArray($result);
        // If enabled only for homepage and this is not page 1 or a topic page, then set disable flag
        if ($cntrblkpage == 'none' && ($page > 1 OR $topic != "")){
            $cntrblkenable = 0;
        } elseif ($cntrblkpage == 'all' && $page > 1 ){
            $cntrblkenable = 0;
        } else $cntrblkenable = 1;

        // Check if there are no featured articles in this topic and if so then place it at the top of the page
        if ($topic != "") {
            $wheresql = "WHERE tid='$topic' AND featured > 0";
        } else {
            $wheresql = "WHERE featured = 1";
        }
        $query = DB_query("SELECT count(*) as count FROM {$_TABLES['stories']} $wheresql");
        $result = DB_fetchArray($query);
        if ($result['count'] == 0 && $cntrblkpos == 2) {
            $cntrblkpos = 1;//top of page
        }

        if ($cntrblkenable AND $cntrblkpos == $where) {
            if (DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')){
                $retval = inm_featuredAlbum($id,$type);
                return $retval;
            }
        }
    }
}

/**
* This function is called from COM_siteHeader and will return additional Header information
* This can be Javascript functions required for the plugin or extra Metatags
*
* @return   string      returns a concatenated string of all plugins extra header code
*/
function plugin_getheadercode_inmemoriam()
{
    global $_CONF, $INM_TABLES, $_GET, $INM_CONF;
    $retval = '';
    //deliver custom style sheet
    $retval .= LB . '<link rel="stylesheet" type="text/css" href="'.$INM_CONF['url_html'] . '/inmemoriam.css" />' . LB;
    $valid = inm_validateInput('get');
    if (!empty($valid['id'])){
        $id = $valid['id'];
    } elseif (!empty($valid['mid'])){
        $id = DB_getItem($INM_TABLES['media'], 'aid', "mid='{$valid['mid']}'");
    }
    $theme = DB_getItem($INM_TABLES['albums'], 'theme', "id='$id'");
    if (!empty($theme)){
        if (@file_exists($INM_CONF['path_html'].$INM_CONF['themes'][$theme].'.css')){
            $retval .= '<link rel="stylesheet" type="text/css" href="'.$INM_CONF['url_html'].'/'.$INM_CONF['themes'][$theme].'.css" />' . LB;
        } else {
            $retval .= '<link rel="stylesheet" type="text/css" href="'.$INM_CONF['url_html'].'/'.$INM_CONF['themes'][0].'.css" />' . LB;
        }
    } else $retval .= '<link rel="stylesheet" type="text/css" href="'.$INM_CONF['url_html'].'/'.$INM_CONF['themes'][0].'.css" />' . LB;
    return $retval;
}

/*
 * feed #1: new media - all albums
 * feed #2: new comments - all albums
 * feed #3[,#4,#5,etc]: new media - per album
 */
function plugin_getfeednames_inmemoriam ()
{
    global $INM_TABLES, $_TABLES, $LANG_INM01;
    $feeds = array ();

    $result = DB_query ("SELECT id,name FROM {$INM_TABLES['albums']} ORDER BY name ASC");
    $num = DB_numRows ($result);

    //one feed for all
    if ($num > 0) {
        $feeds[] = array ('id' => 'allalbums', 'name' => $LANG_INM01[49]);
    }

    //new comments feed
    if (DB_count($_TABLES['comments'], 'type', 'inmemoriam') >= 1){
        $feeds[] = array ('id' => 'comments', 'name' => $LANG_INM01[50]);
    }

    //one feed per album
    for ($i = 0; $i < $num; $i++) {
        $A = DB_fetchArray ($result);
        $feeds[] = array ('id' => $A['id'], 'name' => $A['name']);
    }

    return $feeds;
}

function inm_feed_buildSql ($topic, $limits)
{
    $where = '';
    if ($topic == 'allalbums'){
        $where = "status='0'" . COM_getPermSQL('and');
    } elseif ($topic == 'comments'){
        $where = "type='inmemoriam'";
    } else {
        $where .= "status='0' AND aid='" . $topic . "'" . COM_getPermSQL('and');
    }

    $limitsql = '';
    if (!empty ($limits)) {
        if (substr ($limits, -1) == 'h') { // last xx hours
            $limitsql = '';
            $hours = substr ($limits, 0, -1);
            if (!empty ($where)) {
                $where .= ' AND ';
            }
            $where .= "date >= DATE_SUB(NOW(),INTERVAL $hours HOUR)";
        } else {
            $limitsql = ' ORDER BY date DESC LIMIT ' . $limits;
        }
    }
    else
    {
        $limitsql = ' ORDER BY date DESC LIMIT 10';
    }

    if (!empty ($where)) {
        $where = ' WHERE ' . $where;
    }

    $sql = $where . $perms . $limitsql;

    return $sql;
}

function plugin_getfeedcontent_inmemoriam ($feed, &$link, &$update)
{
    global $_CONF, $_TABLES, $INM_TABLES, $INM_CONF;

    $content = array ();
    $mids = array ();

    $result = DB_query ("SELECT topic,limits FROM {$_TABLES['syndication']} WHERE fid = $feed");
    $F = DB_fetchArray ($result);

    if ($F['topic'] != 'comments'){
        $content = array ();
        $mids = array ();
        $sql = "SELECT mid,filename,title,caption,owner_id,date FROM {$INM_TABLES['media']}" . inm_feed_buildSql ($F['topic'], $F['limits']);
        $result = DB_query ($sql);
        $num = DB_numRows ($result);
        for ($i = 0; $i < $num; $i++) {
            $A = DB_fetchArray ($result);
            $filelink = $INM_CONF['url_html'] . "/browse.php?mid=" . $A['mid'];
            if (!empty($A['title'])){
                $title = COM_stripslashes($A['title']);
            } else $title = COM_stripslashes($A['filename']);
            $caption = COM_stripslashes($A['caption']);
            $content[] = array ('title'  => $title,
                                'text'   => $caption,
                                'link'   => $filelink,
                                'uid'    => $A['owner_id'],
                                'date'   => $A['date'],
                                'format' => 'text'
                               );
            $mids[] = $A['mid'];
        }

        if ($F['topic'] == 'allalbums') {
            $link = $INM_CONF['url_html'] . "/index.php";
        } else {
            $link = $INM_CONF['url_html'] . "/browse.php?id=" . $F['topic'];
        }
        $update = implode (',', $mids);
    }
    if ($F['topic'] == 'comments'){
        $content = array ();
        $cids = array ();
        $sql = "SELECT cid, date, title, comment, uid FROM {$_TABLES['comments']}" . inm_feed_buildSql ($F['topic'], $F['limits']);
        $result = DB_query ($sql);
        $num = DB_numRows ($result);
        for ($i = 0; $i < $num; $i++) {
            $A = DB_fetchArray ($result);
            $filelink = $_CONF['site_url'] . "/comment.php?mode=view&cid=" . $A['cid'];
            $title = COM_stripslashes($A['title']);
            $comment = COM_stripslashes($A['comment']);
            $content[] = array ('title'  => $title,
                                'text'   => $comment,
                                'link'   => $filelink,
                                'uid'    => $A['uid'],
                                'date'   => $A['date'],
                                'format' => 'text'
                               );
            $cids[] = $A['cid'];
        }
        $link = $_CONF['site_url'] . "/comment.php?mode=view&cid=" . $A['cid'];
        $update = implode (',', $cids);
    }

    return $content;
}

function plugin_feedupdatecheck_inmemoriam ($feed, $topic, $update_data, $limit)
{
    global $INM_TABLES, $_TABLES;

    $is_current = true;
    if ($topic != 'comments'){
        $sql = "SELECT mid FROM {$INM_TABLES['media']}" . inm_feed_buildSql ($topic, $limits);
        $result = DB_query ($sql);
        $num = DB_numRows ($result);

        $mids = array ();
        for ($i = 0; $i < $num; $i++) {
            $A = DB_fetchArray ($result);
            $mids[] = $A['mid'];
        }
        $current = implode (',', $mids);

        //COM_errorLog ("Update check for media: comparing new list ($current) with old list ($update_data)", 1);
    } elseif ($topic == 'comments'){
        $sql = "SELECT cid FROM {$_TABLES['comments']}" . inm_feed_buildSql ($topic, $limits);
        $result = DB_query ($sql);
        $num = DB_numRows ($result);

        $cids = array ();
        for ($i = 0; $i < $num; $i++) {
            $A = DB_fetchArray ($result);
            $cids[] = $A['cid'];
        }
        $current = implode (',', $cids);

        //COM_errorLog ("Update check for media: comparing new list ($current) with old list ($update_data)", 1);
    }

    return ( $current != $update_data ) ? false : true;
}

/*
*
* [thumb:35 check out this pic] will display a clickable thumbnail.
* [image:35 check out this pic] will display a text link.
* [album:5 browse this album] will display a text link to page 1 of an album's thumbnail page.
*
* Inmemoriam supports autolinks in it's own content, specifically, in the caption,
* e.g., you can put a forum autotag in an image's caption and it will be parsed.
*
**/
function plugin_autotags_inmemoriam($mode = 'parse', $content = '', $autotag = ''){
    global $INM_TABLES, $_CONF, $LANG_INM01, $INM_CONF;

    if ($mode == 'parse' && $autotag['tag'] == 'album'){
        $autotag['parm1'] = COM_applyFilter ($autotag['parm1']);
        $url = $INM_CONF['url_html'] . '/browse.php?id=' . $autotag['parm1'];
        if (empty ($autotag['parm2'])) {
            $albumname = DB_getItem ($INM_TABLES['albums'], 'name', "id = '{$autotag['parm1']}'");
            if (!empty($albumname)){
                $linktext = stripslashes ($albumname);
            } else $linktext = $LANG_INM01[46] . $autotag['parm1'];
        } else $linktext = $autotag['parm2'];
        if (!empty ($url)){
            $filelink = '<a href="' . $url . '">' . $linktext . '</a>';
            $content = str_replace ($autotag['tagstr'], $filelink, $content);
        }
    }elseif ($mode == 'parse' && $autotag['tag'] == 'thumb'){
        $autotag['parm1'] = COM_applyFilter ($autotag['parm1']);
        $url = $INM_CONF['url_html'] . '/browse.php?mid=' . $autotag['parm1'];
        $result = DB_query("SELECT filename, title FROM {$INM_TABLES['media']} WHERE mid='{$autotag['parm1']}'");
        list($filename, $mediatitle) = DB_fetchArray($result);
        if (empty ($autotag['parm2'])) {
            if (!empty($mediatitle)){
                $linktext = stripslashes ($mediatitle);
            } else $linktext = $LANG_INM01[45] . $autotag['parm1'];
        } else $linktext = $autotag['parm2'];
        if (!empty ($url)){
            $extension = strtolower(strrchr($filename,"."));
            if (array_key_exists($extension, $INM_CONF['image_ext'])){
                $src = $INM_CONF['url_html'] . '/image.php?prt=1&amp;mid=' . $autotag['parm1'];
            } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
                $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;aud=1';
            } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
                $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;vid=1';
            } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
                $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;cod=1';
            }
            $filelink = '<a href="' . $url . '"><img class="inm-autoThumb" src="' . $src . '" alt="" title="' . $linktext . '" /></a>';
            $content = str_replace ($autotag['tagstr'], $filelink, $content);
        }
    } elseif ($mode == 'parse' && $autotag['tag'] == 'image'){
        $autotag['parm1'] = COM_applyFilter ($autotag['parm1']);
        $url = $INM_CONF['url_html'] . '/browse.php?mid=' . $autotag['parm1'];
        if (empty ($autotag['parm2'])) {
            $mediatitle = DB_getItem ($INM_TABLES['media'], 'title', "mid = '{$autotag['parm1']}'");
            if (!empty($mediatitle)){
                $linktext = stripslashes ($mediatitle);
            } else $linktext = $LANG_INM01[45] . $autotag['parm1'];
        } else $linktext = $autotag['parm2'];
        if (!empty ($url)){
            //$filelink = '<a href="' . $url . '"><img src="' . $INM_CONF['url_html'] 
            //    . '/image.php?prt=1&amp;mid=' 
            //    . $autotag['parm1'] . '" alt="" title="' . $linktext . '" /></a>';
            $filelink = '<a href="' . $url . '">' . $linktext . '</a>';
            $content = str_replace ($autotag['tagstr'], $filelink, $content);
        }
    } elseif ($mode == 'tagname'){
        $content = array('thumb','album','image');
    }

    return $content;
}

// +---------------------------------------------------------------------------+
// | Inmemoriam Specific functions                                             |
// +---------------------------------------------------------------------------+


//returns a summary for media
//display summ after editing mid as well as on the moderation page
function inm_showMediaSumm($mid, $queued = false){
    global $INM_TABLES, $_TABLES, $INM_CONF, $LANG_INM10, $LANG_INM11, $_CONF, $_USER;

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array('albumsumm' => 'media-summ.thtml', 'queue' => 'queue-form.thtml'));

    if ($queued){
        //add property vars for the moderation summary
        //original file size and image x/y
        $T->set_var('queueaction', $INM_CONF['url_html'] . '/queue.php');
        $T->set_var('langapprove',$LANG_INM11[4]);
        $T->set_var('langdelete',$LANG_INM11[5]);
        //$T->set_var('fullsizelink', '<a href="' . $INM_CONF['url_html'] . '/browse.php?full=1&amp;mid=' . $mid . '">' . $LANG_INM10[34] . '</a>');
        $T->set_var('mid', $mid);
        $T->set_var('status', '1');
        $T->set_var('editlink', '<a href="' . $INM_CONF['url_html'] . '/media.php?mid=' . $mid . '&amp;status=1">' . $LANG_INM10[40] . '</a>');

        $T->parse('queueform', 'queue');
        $status = " AND status='1'";
    } else $status = " AND status='0'";

    $T->set_var('class', 'inm-mediasumm');
    $T->set_var('langowner',$LANG_INM10[4]);
    $T->set_var('langadded', $LANG_INM10[24]);
    $T->set_var('langviews', $LANG_INM10[25]);

    $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE mid='$mid'" . $status . " LIMIT 1");
    $M = DB_fetchArray($result);

    $blocktitle = inm_buildBrowseTitle($mid, false);
    $display .= COM_startBlock($blocktitle);

    if (!empty($M['title'])){
        $title = COM_stripslashes($M['title']);
    } else $title = COM_stripslashes($M['filename']);

    $T->set_var('alt', $title);
    $T->set_var('title', $title);

    if (!empty($A['wid'])){
        $wid = '&amp;wid=' . $A['wid'];
    }
    $extension = strtolower(strrchr($M['filename'],"."));
    if (array_key_exists($extension, $INM_CONF['image_ext'])){
        $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;size=3&amp;mid=' . $mid;
        //display link to exif if enabled
        if ($M['enable_exif'] == 1){
            $T->set_var('exiflink', "<li><a href=\"" . $INM_CONF['url_html'] . "/browse.php?exif=1&amp;mid=" . $mid . "\" onclick=\"window.open('" . $INM_CONF['url_html'] . "/browse.php?exif=1&amp;mid=" . $mid . "','popup','width=260,height=300,scrollbars=yes,resizable=yes,toolbar=no,directories=no,location=no,menubar=no,status=no,left=0,top=0'); return false\">" . $LANG_INM10[28] . "</a></li>" . LB);
        }

        //display link to full image if enabled
        $ares = DB_query("SELECT dispfullimg, limitfullimg FROM {$INM_TABLES['albums']} WHERE id='{$M['aid']}'");
        list($dispfullimg,$limitfullimg) = DB_fetchArray($ares);
        if (($dispfullimg == 1 && ($limitfullimg == 1 || ($limitfullimg == 2 && $_USER['uid'] >= 2) || ($limitfullimg == 3 && SEC_hasRights('inmemoriam.fullview')))) || SEC_hasRights('inmemoriam.admin') || $_USER['uid'] == $A['owner_id']) {
            $T->set_var('fullimagelink', '<li><a href="' . $INM_CONF['url_html'] . '/browse.php?full=1&amp;mid=' . $mid . $wid . '" target="_blank">' . $LANG_INM10[34] . '</a></li>' . LB);
        }
    } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
        $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;aud=1';
    } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
        $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;vid=1';
    } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
        $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;cod=1';
    }
    $T->set_var('src', $src);
    $T->set_var('alt', $LANG_INM10[17] . COM_stripslashes($M['name']));
    $M['caption'] = PLG_replaceTags(COM_stripslashes($M['caption']));
    $T->set_var('caption', $M['caption']);
    $T->set_var('keywords', COM_stripslashes($M['keywords']));
    $gldate = inm_getUserDateTimeFormat($M['date']);
    $T->set_var('dateadd', $gldate[0]);
    $T->set_var('hits',$M['hits']);
    $T->set_var('medialink', $INM_CONF['url_html'] . '/browse.php?mid=' . $mid);
    $owner = DB_getItem($_TABLES['users'], 'username', "uid='{$M['owner_id']}'");
    $T->set_var('owner', inm_prflink($M['owner_id'], COM_stripslashes($owner)));
    if (inm_hasMediaAccess($mid) == 3 && !$queued) {
        $T->set_var('editlink', '<li><a href="' . $INM_CONF['url_html'] . '/media.php?mid=' . $mid . '">' . $LANG_INM10[5] . '</a></li>');
    }

    $T->parse('output','albumsumm',true);
    $display .= $T->finish($T->get_var('output'));
    $display .= COM_endblock();

    return $display;
}

//converts usernames to clickable links leading to user profiles
function inm_prflink($uid){
    global $_CONF, $LANG_INM05, $_TABLES;

    $retval = '';
    if($uid > '1'){
        $username = DB_getItem($_TABLES['users'], 'username', "uid='$uid'");
        $retval = '<a href="' . $_CONF['site_url'];
        $retval .= '/users.php?mode=profile&amp;uid=' . $uid . '">';
        $retval .= $username . '</a>';
    } else {
        $retval = $LANG_INM05[6];
    }
    return $retval;
}

//converts albums to clickable links leading to the search page
//which will list all media in that album
//not in use
/*function inm_catlink($aid,$albumname){
    global $_CONF, $INM_TABLES;

    $retval = '';
    $retval = '<a href="' . $INM_CONF['url_html'];
    $retval .= '/search.php?aid=' . $aid;
    $retval .= '">' . $albumname . '</a>';
    return $retval;
}*/

//displays a row of links
function inm_menurow(){
    global $_TABLES, $_CONF, $_USER, $INM_TABLES, $LANG_INM01, $_GET, $INM_CONF;

    // Retrieve access settings
    $query = DB_query("SELECT anonview, loginadd, logincreate FROM {$INM_TABLES['settings']}");
    list($anonview,$loginadd,$logincreate) = DB_fetchArray($query);

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file('page', 'linkrow.thtml');

    if (!empty($_GET)){
        $valid = inm_validateInput('get');
    }

    //$thisurl = COM_getCurrentURL();
    $index = "&nbsp;&nbsp;<a href=\"" . $INM_CONF['url_html'] . "/index.php\">";
    //$index .= "<img src=\"" . $INM_CONF['url_html'] . "/images/index.gif" . "\" alt=\"";
    $index .= $LANG_INM01[17];
    //$index .= "\" border=\"0\" />";
    $index .= "</a>&nbsp;&nbsp;";

    //links to the add/create forms
    if (($loginadd == '1' && $_USER['uid'] > 2) || SEC_hasRights('inmemoriam.add') || SEC_hasRights('inmemoriam.admin')) {
        if (SEC_hasRights('inmemoriam.admin')){
            $where = '';
        } else {
            $where = " WHERE allow_submit='1' OR owner_id='{$_USER['uid']}'";
        }
        $result = DB_query("SELECT id FROM {$INM_TABLES['albums']}" . $where . " LIMIT 1");
        if (DB_numRows($result) >= 1){
            $add = "&nbsp;&nbsp;<a href=\"" . $INM_CONF['url_html'] . "/media.php";
            if (!empty($valid['id'])){
                //if allowed to submit to album
                $result = DB_query("SELECT allow_submit, owner_id FROM {$INM_TABLES['albums']} WHERE id='{$valid['id']}'");
                list($allow_submit, $owner_id) = DB_fetchArray($result);
                if ($allow_submit == '1' || $owner_id == $_USER['uid'] || SEC_hasRights('inmemoriam.admin')){
                    $add .= '?id=' . $valid['id'];
                }
            } elseif (!empty($valid['mid'])){
                $aid = DB_getItem($INM_TABLES['media'], 'aid', "mid='{$valid['mid']}'");
                //if allowed to submit to album
                $result = DB_query("SELECT allow_submit, owner_id FROM {$INM_TABLES['albums']} WHERE id='$aid'");
                list($allow_submit, $owner_id) = DB_fetchArray($result);
                if ($allow_submit == '1' || $owner_id == $_USER['uid'] || SEC_hasRights('inmemoriam.admin')){
                    $add .= '?id=' . $aid;
                }
            }
            $add .= "\">";
            //$add .= "<img src=\"" . $INM_CONF['url_html'] . "/images/add.gif" . "\" alt=\"";
            $add .= $LANG_INM01[5];
            //$add .= "\" border=\"0\" />";
            $add .= "</a>&nbsp;&nbsp;";
            $T ->set_var('addlink', $add);
        }
    }
    if (($logincreate == '1' && $_USER['uid'] >= 2) || SEC_hasRights('inmemoriam.create') || SEC_hasRights('inmemoriam.admin')) {
        //if (!eregi('albums.php', $thisurl)){
            $create = "&nbsp;&nbsp;<a href=\"" . $INM_CONF['url_html'] . "/albums.php\">";
            //$create .= "<img src=\"" . $INM_CONF['url_html'] . "/images/create.gif" . "\" alt=\"";
            $create .= $LANG_INM01[6];
            //$create .= "\" border=\"0\" />";
            $create .= "</a>&nbsp;&nbsp;";
            $T ->set_var('createlink', $create);
        //}
    }
    //if (!eregi('index.php', $thisurl)){
    //    $T->set_var('indexlink', $index);
    //} elseif (eregi('splash', $thisurl)){
    //    $T->set_var('indexlink', $index);
    //} else {
        $T->set_var('indexlink', $index);
    //}

    $T->parse('output','page');
    $retval = $T->finish($T->get_var('output'));
    return $retval;
}

// function that displays random media
// plugin installed.
function phpblock_inm_randommedia(){
    global $_CONF, $INM_TABLES, $LANG_INM01, $_USER, $INM_CONF;

    $result = DB_query("SELECT anonview, enable_splash FROM {$INM_TABLES['settings']}");
    list($anonview, $splash) = DB_fetchArray($result);
    if ($anonview == 0 && $_USER['uid'] < 2){
        return '';
    }

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array('block' => 'random-block.thtml'));
    //get image and random media and media info
    if (inm_getRandomMedia($T) === false){
        return;
    }

    if ($splash == 1){
        $splash = '?splash=1';
    } else $splash = '';
    $T->set_var('browselink', '<li><a href="' . $INM_CONF['url_html'] . '/index.php' . $splash . '">' . $LANG_INM01[17] . '</a></li>');

    if ($_USER['uid'] >= 2){
        $fav = DB_count($INM_TABLES['favorites'], 'uid', $_USER['uid']);
        if ($fav >= 1){
            $T->set_var('favoritelink', '<li><a href="' . $INM_CONF['url_html'] . '/browse.php?fav=' . $_USER['uid'] . '">' . $LANG_INM01[38] . '</a></li>');
        }
    }

    $feat = DB_getItem($INM_TABLES['albums'], 'id', "featured='1'" . COM_getPermSQL('and'));
    if (!empty($feat)){
        $T->set_var('featuredlink', '<li><a href="' . $INM_CONF['url_html'] . '/browse.php?id=' . $feat . '">' . $LANG_INM01[39] . '</a></li>');
    }

    $existPop = DB_getItem($INM_TABLES['media'], 'COUNT(*) as count', "hits<>'0'");
    if ($existPop >= 1){
        $T->set_var('popularlink', '<li><a href="' . $INM_CONF['url_html'] . '/browse.php?pop=1">' . $LANG_INM01[40] . '</a></li>');
    }
    //top rated not implemented
    //$T->set_var('topratedlink', '<li><a href="' . $INM_CONF['url_html'] . '/browse.php?top=1">' . $LANG_INM01[41] . '</a></li>');

    $T->parse('output','block');
    $display = $T->finish($T->get_var('output'));
    return $display;
}

// function that displays random media from a featured album
// plugin installed.
function inm_featuredAlbum($id = '',$type = '1'){
    global $LANG_INM01, $INM_TABLES;
    if ($id == ''){
        $result = DB_query("SELECT id, cntrblktype FROM {$INM_TABLES['albums']} WHERE featured='1'" . COM_getPermSQL('and'));
        if (DB_numRows($result) < 1){
            return '';
        }
        list ($id,$type) = DB_fetchArray($result);
    }

    //album summary
    if ($type == '1'){
        //is parent or sub
        $pid = DB_getItem($INM_TABLES['albums'], 'pid', "id='$id'");
        if (!empty($pid)){
            $summary = inm_showSubAlbumSummary($id, true);
        } else {
            $summary = inm_showAlbumSummary($id);
        }
        //display results
        $retval = COM_startBlock($LANG_INM01[18]);
        $retval .= '<div id="inm-centerblock">';
        if (!empty($summary)){
            $retval .= $summary;
        } else return '';
        $retval .= '';//throw a byline or advert or something here if you want...
        $retval .= '</div>';
        $retval .= COM_endBlock();
        return $retval;

    //latest n thumbs
    } elseif ($type == '2'){
        $retval = COM_startBlock($LANG_INM01[37]);
        $retval .= '<div id="inm-thumbreview">';
        $thumbs = inm_showRecentThumbs($id);
        if (!empty($thumbs)){
            $retval .= $thumbs;
        } else return '';
        $retval .= '';//throw a byline or advert or something here if you want...
        $retval .= '</div>';
        $retval .= COM_endBlock();
        return $retval;
    }
}

function inm_showRecentThumbs($id){
    global $INM_TABLES, $_CONF, $INM_CONF;
    $numthumbs = '3';//set this to the number of thumbs you want in the row
    $result = DB_query("SELECT mid, title FROM {$INM_TABLES['media']} WHERE aid='$id' AND status='0'" . COM_getPermSQL('and') . " ORDER BY date DESC LIMIT $numthumbs");

    $style= ' style="margin:5px 20px; border:0;"';
    $retval = '';
    while ($A = DB_fetchArray($result)){
        //
        $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;size=2&amp;mid=' . $A['mid'];
        $url = $INM_CONF['url_html'] . '/browse.php?mid=' . $A['mid'];
        $alt = stripslashes($A['title']);
        $retval .= '<a href="' . $url . '">';
        $retval .= '<img' . $style . ' src="' . $src . '" alt="' . $alt . '" title="' . $alt . '" />';
        $retval .= '</a>';
    }
    return $retval;
}

//returns "powered by"
function inm_poweredBy(){
    global $LANG_INM01;
    $retval = '<p style="text-align: center; font-size: .8em;">';
    $retval .= $LANG_INM01[31];
    $retval .= '</p>';

    //uncomment the next line in order to turn off the powered by statement
    //return '';
    return $retval;
}

//returns an array with an mid, title, and a caption per that album id.
function inm_getAlbumRandomMedia($id = ''){
    global $INM_TABLES;

    if (!empty($id)){
        if (inm_hasAlbumAccess($id)){
            $A = array();
            $result = DB_query("SELECT mid, filename, title, caption FROM {$INM_TABLES['media']} WHERE aid='$id' AND status='0'" . COM_getPermSQL('and') . " ORDER BY RAND() LIMIT 1");
            list($A['mid'],$A['filename'],$A['title'],$A['caption']) = DB_fetchArray($result);
            return $A;
        } else {
            return '';
        }
    }
}

//retrieve random media
//modifies random-block.thtml
function inm_getRandomMedia(&$T){
    global $INM_TABLES, $_CONF, $INM_CONF, $LANG_INM01;

    //get random mid
    $result = DB_query("SELECT mid, filename, title, caption, aid FROM {$INM_TABLES['media']} WHERE status='0'" . COM_getPermSQL('and') . " ORDER BY RAND()");
    if (DB_numRows($result) < 1){
        return false;
    }
    while ($A = DB_fetchArray($result)){
        if (inm_hasMediaAccess($A['mid']) >= 2){
            if(!empty($A['title'])){
                $alt = $LANG_INM01[51] . ': ' . COM_stripslashes($A['title']);
                $title = COM_stripslashes($A['title']);
            } else {
                $alt = $LANG_INM01[51] . ' ' . COM_stripslashes($A['filename']);
                $title = COM_stripslashes($A['filename']);
            }
            $thumbsize = DB_getItem($INM_TABLES['settings'], 'thumbsize', "thumbsize<>''");
            $extension = strtolower(strrchr($A['filename'],"."));
            if (array_key_exists($extension, $INM_CONF['image_ext'])){
                $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;size=' . $thumbsize . '&amp;mid=' . $A['mid'];
            } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
                $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;size=' . $thumbsize . '&amp;aud=1';
            } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
                $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;size=' . $thumbsize . '&amp;vid=1';
            } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
                $src = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;size=' . $thumbsize . '&amp;cod=1';
            }

            $imageurl = $INM_CONF['url_html'] . '/browse.php?mid=' . $A['mid'];
            $ares = DB_query("SELECT name, description FROM {$INM_TABLES['albums']} WHERE id='{$A['aid']}'");
            list($albumname, $description) = DB_fetchArray($ares);
            if (!empty($albumname)){
                $albumname = '<p><a href="' . $INM_CONF['url_html'] . '/browse.php?id=' . $A['aid'] . '" title="' . COM_stripslashes($description) . '">' . COM_stripslashes($albumname) . '</a></p>';
            } else {
                $albumname = '';
            }
            if (!empty($A['caption'])){
                if (strlen(COM_stripslashes($A['caption'])) > 64){
                    $caption = '<p>' . substr(COM_stripslashes($A['caption']), 0, 64) . '...</p>';
                } else $caption = '<p>' . COM_stripslashes($A['caption']) . '</p>';
            } else {
                $caption = '';
            }
            $T->set_var('imageurl', $imageurl);
            $T->set_var('src', $src);
            $T->set_var('title', $title);
            $T->set_var('alt', $alt);
            $T->set_var('caption', $caption);
            $T->set_var('albumlink', $albumname);
            break;
        } else {
            continue;
        }
    }
}

//displays the intro para
//takes optional page = current page and intro = parms that can be passed to another function
function inm_showintro($intro = ''){
    global $_CONF, $INM_TABLES, $LANG_INM01, $LANG_INM02, $LANG_INM06, $LANG_INM11, $LANG_INM10, $_USER, $INM_CONF;

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file('page', 'para.thtml');
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('url_html', $INM_CONF['url_html']);

    //jump to album link--use javascript
    $T->set_var('jumptoaction', $INM_CONF['url_html'] . '/browse.php');
    $T->set_var('langjumpto', $LANG_INM01[7]);

    //while..output albums names up to 24 characters
    $result = DB_query("SELECT id, aid, name, pid FROM {$INM_TABLES['albums']} " . COM_getPermSQL('where') . " ORDER BY name ASC");
    if (DB_numRows($result) > 0 ){
        $albumoptions = '';
        while ($A = DB_fetchArray($result)){
            $cresult = DB_query("SELECT id, aid, name FROM {$INM_TABLES['albums']} WHERE pid='{$A['id']}'" . COM_getPermSQL('and') . "ORDER BY name ASC");
            if (DB_numRows($cresult) > 0){
                $subalbumoptions = '';
                while ($C = DB_fetchArray($cresult)){
                    $subalbumoptions .= '<option value="' . $C['id'] . '">';
                    $subalbum = stripslashes($C['name']);
                    if (strlen($subalbum) > 26){
                        $subalbum = substr($subalbum, 0, 26) . '...';
                    }
                    $subalbumoptions .= '--' . $subalbum . '</option>' . LB;
                }
            }
            if ($A['pid'] == ''){
                $album = stripslashes($A['name']);
                if (strlen($album) > 24){
                    $album = substr($album, 0, 24) . '...';
                }
                $albumoptions .= '<option class="inm-jumptoparent" value="' . $A['id'] . '">' . $album . '</option>' . LB;
            }
            $albumoptions .= $subalbumoptions;
            $subalbumoptions = '';
        }
        $T->set_var('albumoptions', $albumoptions);
    } else {
        $T->set_var('albumoptions', '');
    }

    //add link to user's favorites album if it exists
    if ($_USER['uid'] >= 2){
        $fav = DB_count($INM_TABLES['favorites'], 'uid', $_USER['uid']);
        if ($fav >= 1){
            $T->set_var('favoritelink', '<a href="' . $INM_CONF['url_html'] . '/browse.php?fav=' . $_USER['uid'] . '">' . $LANG_INM01[38] . '</a>&nbsp;&nbsp;');
        }
    }

    //search form
    $T->set_var('searchaction', $INM_CONF['url_html'] . '/browse.php');
    $T->set_var('langsearch', $LANG_INM01[8]);

    if ($page == 'index'){
        //$T->set_var('para', $LANG_INM01[15]);
        $result = DB_query("SELECT loginadd FROM {$INM_TABLES['settings']}");
        list($loginadd) = DB_fetchArray($result);
        if (($_USER['uid'] <= 1) && ($loginadd == '1')){
            $T->set_var('langlogin', $LANG_INM01[16]);
        } else {
            $T->set_var('langlogin', '');
        }
    }
    $T->set_var('para', $intro);
    $T->set_var('heading', $LANG_INM01[11]);
    $T->set_var('slogan', $LANG_INM01[12]);
    $T->parse('output','page');

    $display = $T->finish($T->get_var('output'));
    return $display;
}

//validates user input from post prior to use in mysql queries
//$required is an array of input names whose values must not be empty
//returns an error message or an array of validated data
function inm_validatePost($required = ''){
    global $LANG_INM04, $_POST;
    $valid = array();
    foreach ($_POST as $key => $value){
        if (!is_array($value)){
            $value = trim($value);
            if (!empty($required)){
                if (in_array($key, $required) && empty($value)){
                    $retval = $LANG_INM04['1'];
                    return $retval;
                }
            }
            //foreach ($required as $rev){
            //    if(!isset($_POST[$rev])){
            //        $retval = $LANG_INM04['1'];
            //        return $retval;
            //    }
            //}
            if (get_magic_quotes_gpc()){
                $value = trim(stripslashes($value));
            }
            if (!is_numeric($value)){
                if ($key == 'caption'){
                    $value = mysql_real_escape_string(trim(strip_tags($value, '<br><br /><a>')));
                } else {
                    $value = mysql_real_escape_string(trim(strip_tags($value)));
                }
            }
            $valid[$key] = $value;
        } else {
            foreach ($value as $Akey => $Avalue){
                if (!is_array($Avalue)){
                    $Avalue = trim($Avalue);
                    if (!empty($required)){
                        if (in_array($Akey, $required) && empty($Avalue)){
                            $retval = $LANG_INM04['1'];
                            return $retval;
                        }
                    }
                    if (get_magic_quotes_gpc()){
                        $Avalue = trim(stripslashes($Avalue));
                    }
                    if (!is_numeric($Avalue)){
                        if ($Akey == 'caption'){
                            $Avalue = mysql_real_escape_string(trim(strip_tags($Avalue, '<br><br /><a>')));
                        } else {
                            $Avalue = mysql_real_escape_string(trim(strip_tags($Avalue)));
                        }
                    }
                    $value[$Akey] = $Avalue;
                $valid[$key][$value[$Akey]] = $Avalue;
                } else {
                    //no array posted by inmemoriam is deeper than this
                    $retval = $LANG_INM04['1'];
                    return $retval;
                }
            }
        }
    }
    return $valid;
}

//validates user input from get prior to use in mysql queries
//nothing more than alpha/numeric is passed via get so this will suffice
//returns an array of validated data
function inm_validateGet(){
    global $_GET;
    $valid = array();
    foreach ($_GET as $key => $value){
        if (get_magic_quotes_gpc()){
            $value = stripslashes($value);
        }
        if (!is_numeric($value)){
            $value = mysql_real_escape_string(strip_tags($value));
        }
        $valid[$key] = $value;
    }
    return $valid;
}

//wrapper for inm_validation functions
//$type is album, media, watermark, management, admin, file, get
//returns an array of validated data or a relevant error message
function inm_validateInput($type = ''){
    //global $INM_TABLES;
    $retval = '';
    switch ($type) {
        case 'album':
            $required = array('name','aid','ownerid','groupid');
            $retval = inm_validatePost($required);
            break;
        case 'media':
            $required = array('aid','ownderid','groupid');
            $retval = inm_validatePost($required);
            //images validated by upload and image classes
            break;
        case 'get':
            $retval = inm_validateGet();
            break;
        case 'queue':
            $required = array('mid','status');
            $retval = inm_validatePost($required);
            break;
        case 'ftp':
            $retval = inm_validatePost();
            break;
        case 'dbcheck':
            $retval = inm_validatePost();
            break;
        case 'rate':
            $required = array('mid');
            $retval = inm_validatePost($required);
            break;
        case 'admin':
            $required = array('maxfile','maxw','maxh');
            $retval = inm_validatePost($required);
            break;
    }
    return $retval;
}

//takes an album id and returns a formatted album summary block
//if no id specified then all summs are returned
function inm_showAlbumSummary($id = ''){
    global $INM_TABLES, $INM_CONF, $LANG_INM05, $_CONF, $_TABLES, $_USER, $_GET;

    //retrieve album db
    if ($id == ''){
        if(!isset($_GET['page'])){
            $page = '1';
        } else $page = $_GET['page'];
        $perpage = DB_getItem($INM_TABLES['settings'], 'albums_perpage');
        $limit = ($perpage * $page) - $perpage;
        $offset = " LIMIT $limit, $perpage";
        $result = DB_query("SELECT * FROM {$INM_TABLES['albums']} WHERE (pid='' OR pid IS NULL)" . COM_getPermSQL('and') . " ORDER BY date_created DESC" . $offset);
    } else {
        $result = DB_query("SELECT * FROM {$INM_TABLES['albums']} WHERE id='$id' AND (pid='' OR pid IS NULL)" . COM_getPermSQL('and') . " LIMIT 1");
    }

    $summary = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $summary->set_file(array('albumsumm' => 'album-summ.thtml'));

    while ($A = DB_fetchArray($result)){
        $albumaccess = inm_hasAlbumAccess($A['id']);

        //if user has access display album summ
        //if ( $albumaccess >= 2){
            if (empty($A['pid'])){
                //top level albums
                if (!empty($A['thumb']) && file_exists($INM_CONF['path_albums'] . $A['thumb'])){
                //get album thumb
                    $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=2&amp;id=' . $A['id'];
                } else {
                    //get rand thumb
                    $albumthumb = inm_getAlbumRandomMedia($A['id']);
                    if(is_array($albumthumb) && !empty($albumthumb['mid']) && file_exists($INM_CONF['path_albums'] . $A['aid'] . '/' . $albumthumb['filename'])){
                        $extension = strtolower(strrchr($albumthumb['filename'],"."));
                        if (array_key_exists($extension, $INM_CONF['image_ext'])){
                            $albumthumb = $INM_CONF['url_html'] . '/image.php?mid=' . $albumthumb['mid'] . '&amp;thumb=1';
                        } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
                            $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;aud=1';
                        } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
                            $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;vid=1';
                        } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
                            $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;cod=1';
                        }
                    } else {
                        //check sub-albums for a random pic if necessary
                        $sR = DB_query("SELECT id, aid FROM {$INM_TABLES['albums']} WHERE pid='{$A['id']}'" . COM_getPermSQL('and'));
                        //loop thru sub-albums until a random image is returned
                        while ($sRA = DB_fetchArray($sR)){
                            $albumthumb = inm_getAlbumRandomMedia($sRA['id']);
                            if(is_array($albumthumb) && !empty($albumthumb['mid']) && file_exists($INM_CONF['path_albums'] . $A['aid'] . '/' . $sRA['aid'] . '/' . $albumthumb['filename'])){
                                $adir = $A['aid'] . '/' . $sRA['aid'];
                                break;
                            }
                        }
                        if (is_array($albumthumb) && !empty($albumthumb['mid']) && file_exists($INM_CONF['path_albums'] . $adir . '/' . $albumthumb['filename'])){
                            $extension = strtolower(strrchr($albumthumb['filename'],"."));
                            if (array_key_exists($extension, $INM_CONF['image_ext'])){
                            $albumthumb = $INM_CONF['url_html'] . '/image.php?mid=' . $albumthumb['mid'] . '&amp;thumb=1';
                            } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
                                $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;aud=1';
                            } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
                                $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;vid=1';
                            } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
                                $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;cod=1';
                            }
                        } else {
                            //use default thumb
                            $albumthumb = $INM_CONF['url_html'] . '/image.php?default=1';
                        }
                    }
                }
                $summary->set_var('alt', $LANG_INM05[5] . stripslashes($A['name']));
                $summary->set_var('src', $albumthumb);
                $summary->set_var('albumlink', $INM_CONF['url_html'] . '/browse.php?id=' . $A['id']);
                $summary->set_var('albumname', stripslashes($A['name']));
                if (!empty($A['description'])){
                    $A['description'] = PLG_replaceTags(stripslashes($A['description']));
                    $summary->set_var('description', $A['description']);
                } else {
                    $gldate = inm_getUserDateTimeFormat($A['date_created']);
                    $summary->set_var('description', sprintf($LANG_INM05[13], $gldate[0]));
                }
                $theme = 'inm-' . $INM_CONF['themes'][$A['theme']];
                if ($A['pid'] != ''){
                    $class = $theme . '-summ inm-subalbum';
                    $numsubs = $LANG_INM05[8];
                } else {
                    $class = $theme . '-summ inm-album';
                    $numsubs = DB_count($INM_TABLES['albums'], 'pid', "{$A['id']}");
                }
                $summary->set_var('class', $class);
                $summary->set_var('title', $LANG_INM05[5] . stripslashes($A['name']));
                $summary->set_var('langowner',$LANG_INM05[2]);
                $owner = DB_getItem($_TABLES['users'], 'username', "uid='{$A['owner_id']}'");
                $summary->set_var('owner', inm_prflink($A['owner_id'], stripslashes($owner)));
                $summary->set_var('langimages',$LANG_INM05[3]);
                $summary->set_var('langtotalimages',$LANG_INM05[15]);
                $summary->set_var('langsubalbums', $LANG_INM05[7]);
                $summary->set_var('subalbums', $numsubs);
                $numimages = DB_query("SELECT mid FROM {$INM_TABLES['media']} WHERE aid='{$A['id']}'" . COM_getPermSQL('and'));
                $numimages = DB_numRows($numimages);
                //add number of images from any subalbums to $numimages
                if ($numsubs >= 1){
                    //this query needs to change to reflect inaccessible media
                    $t = DB_query("SELECT m.mid FROM {$INM_TABLES['albums']} a, {$INM_TABLES['media']} m WHERE m.aid=a.id AND a.pid='{$A['id']}'");
                    $subnumimages = DB_numRows($t);
                } else $subnumimages = '0';
                $numimages = $numimages + $subnumimages;
                $summary->set_var('images', $numimages);
                //$summary->set_var('langviews',$LANG_INM05[4]);
                $summary->set_var('langalbumviews',$LANG_INM05[16]);
                $hits = $A['hits'];
                //add number of hits from any subalbums to $hits.
                //this is actually a bit redundant cuz you have to go thru the parent to get to the sub anyway
                //if ($numsubs > 0){
                //    $t = DB_query("SELECT SUM(hits) AS hits FROM {$INM_TABLES['albums']} WHERE pid='{$A['id']}'");
                //}
                //list($subhits) = DB_fetchArray($t);
                //$hits = $hits + $subhits;
                $summary->set_var('hits',$hits);
                $addresult = DB_query("SELECT loginadd FROM {$INM_TABLES['settings']}");
                list($loginadd) = DB_fetchArray($addresult);
                //add to album link
                if ((($loginadd == '1' && $_USER['uid'] > 2 || SEC_hasRights('inmemoriam.add')) && $A['allow_submit'] == '1') || $_USER['uid'] == $A['owner_id'] || SEC_hasRights('inmemoriam.admin')) {
                    $addlink = '&nbsp;&nbsp;<a href="' . $INM_CONF['url_html'] . '/media.php?id=' . $A['id'] . '">' . $LANG_INM05[11] . '</a>&nbsp;&nbsp;';
                    $summary->set_var('addlink', $addlink);
                }
                //edit media link
                if ($albumaccess == 3 && $_USER['uid'] > 1){
                    $editlink = '&nbsp;&nbsp;<a href="' . $INM_CONF['url_html'] . '/albums.php?id=' . $A['id'] . '"/>' . $LANG_INM05[10] . '</a>&nbsp;&nbsp;';
                    $summary->set_var('editlink', $editlink);
                }
                //browse album link
                $viewlink = '&nbsp;&nbsp;<a href="' . $INM_CONF['url_html'] . '/browse.php?id=' . $A['id'] . '"/>' . $LANG_INM05[12] . '</a>&nbsp;&nbsp;';
                $summary->set_var('viewlink', $viewlink);

                $summary->parse('output','albumsumm',true);
                $summary->clear_var(array('addlink','editlink','images','hits','subalbums'));
            }
        //}
    }

    $display = $summary->finish($summary->get_var('output'));
    return $display;
}

//takes a parent album id and returns a formatted album summary block for any subalbums
//if no id specified then all summs are returned
function inm_showSubAlbumSummary($id, $ed = false){
    global $INM_TABLES, $INM_CONF, $LANG_INM05, $_CONF, $_TABLES, $_USER, $_GET;

    $access = inm_hasAlbumAccess($id);
    if ($access < 2){
        return '';
    }
    if ($ed == true){
        $whereID = "WHERE id='$id'";
    } else {
        $whereID = "WHERE pid='$id'";
    }
    $bresult = DB_query("SELECT * FROM {$INM_TABLES['albums']} " . $whereID . COM_getPermSQL('and') . " ORDER BY date_created DESC");// . $offset);

    $summary = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $summary->set_file(array('albumsumm' => 'album-summ.thtml'));

    if (DB_numRows($bresult) >= 1){
        while($B = DB_fetchArray($bresult)){
            if (!empty($B['pid'])){
                $subalbumaccess = inm_hasAlbumAccess($B['id']);

                //if user has access display album summ
                //if ( $subalbumaccess >= 2){
                    if (!empty($B['thumb']) && file_exists($INM_CONF['path_albums'] . $B['thumb'])){
                    //get album thumb
                        $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=2&amp;id=' . $B['id'];
                    } else {
                        //get rand thumb
                        $adir = DB_getItem($INM_TABLES['albums'], 'aid', "id='{$B['pid']}'");
                        $albumthumb = inm_getAlbumRandomMedia($B['id']);
                        if(is_array($albumthumb) && !empty($albumthumb['mid']) && file_exists($INM_CONF['path_albums'] . $adir . '/' . $B['aid'] . '/' . $albumthumb['filename'])){
                            $extension = strtolower(strrchr($albumthumb['filename'],"."));
                            if (array_key_exists($extension, $INM_CONF['image_ext'])){
                            $albumthumb = $INM_CONF['url_html'] . '/image.php?mid=' . $albumthumb['mid'] . '&amp;thumb=1';
                            } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
                                $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;aud=1';
                            } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
                                $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;vid=1';
                            } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
                                $albumthumb = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;cod=1';
                            }
                        } else {
                            //use default thumb
                            $albumthumb = $INM_CONF['url_html'] . '/image.php?default=1';
                        }
                    }
                    $summary->set_var('alt', $LANG_INM05[5] . stripslashes($B['name']));
                    $summary->set_var('src', $albumthumb);
                    $summary->set_var('albumlink', $INM_CONF['url_html'] . '/browse.php?id=' . $B['id']);
                    $summary->set_var('albumname', stripslashes($B['name']));
                    if (!empty($B['description'])){
                        $B['description'] = PLG_replaceTags(stripslashes($B['description']));
                        $summary->set_var('description', $B['description']);
                    } else {
                        $gldate = inm_getUserDateTimeFormat($B['date_created']);
                        $summary->set_var('description', sprintf($LANG_INM05[13], $gldate[0]));
                    }
                    $theme = 'inm-' . $INM_CONF['themes'][$B['theme']];
                    if ($B['pid'] != ''){
                        $class = $theme . '-summ inm-subalbum';
                        $numsubs = $LANG_INM05[8];
                    } else {
                        $class = $theme . '-summ inm-album';
                        $numsubs = DB_count($INM_TABLES['albums'], 'pid', "{$B['id']}");
                    }
                    $summary->set_var('class', $class);
                    $summary->set_var('title', $LANG_INM05[5] . stripslashes($B['name']));
                    $summary->set_var('langowner',$LANG_INM05[2]);
                    $owner = DB_getItem($_TABLES['users'], 'username', "uid='{$B['owner_id']}'");
                    $summary->set_var('owner', inm_prflink($B['owner_id'], stripslashes($owner)));
                    $summary->set_var('langimages',$LANG_INM05[3]);
                    $summary->set_var('langtotalimages',$LANG_INM05[3]);
                    $numimages = DB_count($INM_TABLES['media'], 'aid', "{$B['id']}");
                    $summary->set_var('images', $numimages);
                    $summary->set_var('langsubalbums', $LANG_INM05[7]);
                    $summary->set_var('subalbums', $numsubs);
                    $summary->set_var('langviews',$LANG_INM05[4]);
                    $summary->set_var('langalbumviews',$LANG_INM05[4]);
                    $summary->set_var('hits',$B['hits']);
                    //add to album link
                    if ((($loginadd == '1' && $_USER['uid'] > 2 || SEC_hasRights('inmemoriam.add')) && $B['allow_submit'] == '1') || $_USER['uid'] == $A['owner_id'] || SEC_hasRights('inmemoriam.admin')){
                        $addlink = '&nbsp;&nbsp;<a href="' . $INM_CONF['url_html'] . '/media.php?id=' . $B['id'] . '">' . $LANG_INM05[11] . '</a>&nbsp;&nbsp;';
                        $summary->set_var('addlink', $addlink);
                    }
                    //edit media link
                    if ($subalbumaccess == 3 && $_USER['uid'] > 1){
                        $editlink = '&nbsp;&nbsp;<a href="' . $INM_CONF['url_html'] . '/albums.php?id=' . $B['id'] . '"/>' . $LANG_INM05[10] . '</a>&nbsp;&nbsp;';
                        $summary->set_var('editlink', $editlink);
                    }
                    //browse album link
                    $viewlink = '&nbsp;&nbsp;<a href="' . $INM_CONF['url_html'] . '/browse.php?id=' . $B['id'] . '"/>' . $LANG_INM05[12] . '</a>&nbsp;&nbsp;';
                    $summary->set_var('viewlink', $viewlink);

                    $summary->parse('output','albumsumm',true);
                    $summary->clear_var(array('addlink','editlink','images','hits','subalbums'));

                //}
            }
        }
        $display = $summary->finish($summary->get_var('output'));
        return $display;
    } else {
        return '';
    }
}

//Checks to see if current user has access to an album
//takes an album id
//returns 3 for read/edit 2 for read only 0 for no access
function inm_hasAlbumAccess($id){
    global $INM_TABLES;
    if (empty($id)) {
        return 0;
    }
    if (SEC_hasRights('inmemoriam.admin')){
        return 3;
    }
    $result = DB_query("SELECT pid, owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$INM_TABLES['albums']} WHERE id = '$id'");
    $A = DB_fetchArray($result);
    $album = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);
    if (!empty($A['pid'])){
        $bresult = DB_query("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$INM_TABLES['albums']} WHERE id = '{$A['pid']}'");
        $B = DB_fetchArray($bresult);
        $parent = SEC_hasAccess($B['owner_id'],$B['group_id'],$B['perm_owner'],$B['perm_group'],$B['perm_members'],$B['perm_anon']);
        $access = min($album, $parent);
    } else {
        $access = $album;
    }
    return $access;
}

//Checks to see if current user has access to media
//takes into account parent album
//returns 3 for read/edit 2 for read only 0 for no access
function inm_hasMediaAccess($mid){
    global $INM_TABLES;
    if (empty($mid)) {
        return 0;
    }
    if (SEC_hasRights('inmemoriam.admin')){
        return 3;
    }
    $albumID = DB_getItem($INM_TABLES['media'], 'aid', "mid='$mid'");
    $albumaccess = inm_hasAlbumAccess($albumID);
    $result = DB_query("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$INM_TABLES['media']} WHERE mid = '$mid'");
    $A = DB_fetchArray($result);
    $mediaaccess = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);
    return min($albumaccess, $mediaaccess);
}

//controls whether left blocks are displayed or not
function inm_siteHeader($pagetitle = ''){
    global $INM_TABLES;
    $blocks = DB_getItem($INM_TABLES['settings'], 'lr_blocks');
    if ($blocks == 1 || $blocks == 3){
        return COM_siteHeader('menu',$pagetitle);
    } else {
        return COM_siteHeader('none',$pagetitle);
    }
}

//controls whether right blocks are displayed or not
function inm_siteFooter(){
    global $INM_TABLES;
    $blocks = DB_getItem($INM_TABLES['settings'], 'lr_blocks');
    if ($blocks == 2 || $blocks == 3){
        return COM_siteFooter(true);
    } else {
        return COM_siteFooter(false);
    }
}


//put file sizes into readable form
//returns readable form or false
function inm_readbytes($bytes){
    $bytes = trim($bytes);
    $kb = 1024;
    $mb = 1024 * $kb;
    $gb = 1024 * $mb;
    $tb = 1024 * $gb;

    if ($bytes < $kb) {
        $bytes = "$max_file_size Bytes";
    } elseif ($bytes < $mb) {
        $final = round($bytes/$kb,2);
        $bytes = "$final KB";
    } elseif ($bytes < $gb) {
        $final = round($bytes/$mb,2);
        $bytes = "$final MB";
    } elseif($bytes < $tb) {
        $final = round($bytes/$gb,2);
            $bytes = "$final GB";
    } else {
        $final = round($bytes/$tb,2);
        $bytes = "$final TB";
    }
    return $bytes;
}

//converts M to bytes
function inm_returnBytes($val) {
   $val = trim($val);
   $last = strtolower($val{strlen($val)-1});
   switch($last) {
       // The 'G' modifier is available since PHP 5.1.0
       case 'g':
           $val *= 1024;
       case 'm':
           $val *= 1024;
       case 'k':
           $val *= 1024;
   }
   return $val;
}

//returns x and y dimensions for an image (not for an img tag)
function inm_reportImageSize($path,$filename){
    $path = $path . $filename;
    list($width, $height, $type, $attr) = @getimagesize($path);
    $size = array ($width, $height);
    return $size;
}

//returns x and y dimensions for an image tag
function inm_imageSizeAttr($path,$filename){
    $path = $path . $filename;
    list($width, $height, $type, $attr) = @getimagesize($path);
    return $attr;
}

//modified COM_printPageNavigation to accommodate images
function inm_printPageNavigation( $base_url, $curpage, $num_pages )
{
    global $LANG05, $_CONF, $_GET, $INM_TABLES, $INM_CONF, $LANG_INM10;

    $hasargs = strstr( $base_url, '?' );
    if( $num_pages < 2 ){
        return;
    }

    if (isset($_GET['id'])){
        $theme = DB_getItem($INM_TABLES['albums'], 'theme', "id='{$_GET['id']}'");
        if (empty($theme)){
            $theme = $INM_CONF['themes'][0];
        } else {
            $theme = $INM_CONF['themes'][$theme];
        }
    } else $theme = $INM_CONF['themes'][0];

    $retval = '';
    if( $curpage > 1 ){
        if( $hasargs ){
            $retval .= '<a href="' . $base_url . '&amp;page=1"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-first.gif" alt="'  . $LANG05[7] . '" /></a>&nbsp;&nbsp;';
            $retval .= '<a href="' . $base_url . '&amp;page=' . ( $curpage - 1 ) . '"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-prev.gif" alt="' . $LANG05[6] . '" /></a>&nbsp;&nbsp;';
        } else {
            $retval .= '<a href="' . $base_url . '?page=1"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-first.gif" alt="'  . $LANG05[7] . '" /></a>&nbsp;&nbsp;';
            $retval .= '<a href="' . $base_url . '?page=' . ( $curpage - 1 ) . '"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-prev.gif" alt="' . $LANG05[6] . '" /></a>&nbsp;&nbsp;';
        }
    } else {
        //$retval .= $LANG05[7] . ' | ' ;
        //$retval .= $LANG05[6] . ' | ' ;
    }

    for( $pgcount = ( $curpage - 10 ); ( $pgcount <= ( $curpage + 9 )) AND ( $pgcount <= $num_pages ); $pgcount++ ){
        if( $pgcount <= 0 ){
            $pgcount = 1;
        }
        if( $pgcount == $curpage ){
            $retval .= '<b>' . $pgcount . '</b> ';
        } else {
            if( $hasargs ){
                $retval .= '<a href="' . $base_url . '&amp;page=' . $pgcount . '">' . $pgcount . '</a> ';
            } else {
                $retval .= '<a href="' . $base_url . '?page=' . $pgcount . '">' . $pgcount . '</a> ';
            }
        }
    }

    if( $curpage == $num_pages ){
        //$retval .= '| ' . $LANG05[5] . ' ';
        //$retval .= '| ' . $LANG05[8];
    } else {
        if( $hasargs ) {
            $retval .= '&nbsp;&nbsp;<a href="' . $base_url . '&amp;page=' . ( $curpage + 1 ) . '"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-next.gif" alt="'  . $LANG05[5] . '" /></a>';
            $retval .= '&nbsp;&nbsp;<a href="' . $base_url . '&amp;page=' . $num_pages . '"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-last.gif" alt="'  . $LANG05[8] . '" /></a>';
        } else {
            $retval .= '&nbsp;&nbsp;<a href="' . $base_url . '?page=' . ( $curpage + 1 ) . '"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-next.gif" alt="'  . $LANG05[5] . '" /></a>';
            $retval .= '&nbsp;&nbsp;<a href="' . $base_url . '?page=' . $num_pages . '"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-last.gif" alt="'  . $LANG05[8] . '" /></a>';
        }
    }

    if (!empty($_GET['id'])){
        $slide = '&nbsp;&nbsp;&nbsp;<a href="' . $INM_CONF['url_html'] . '/slide.php?id=' . $_GET['id'] . '&amp;delay=5">' . $LANG_INM10[62] . '</a>';
    } else {
        $slide = '';
    }
    if( !empty( $retval )){
        $retval = '<div class="inm-browsenav">' . $retval . $slide . '</div>';
    }

    return $retval;
}

function inm_buildBrowseTitle($id, $isalbum = true){
    global $INM_TABLES, $LANG_INM10, $_CONF, $_GET, $INM_CONF;
    
    $valid = inm_validateInput('get');
    if (!empty($_GET) && is_array($valid)){
        if (!empty($valid['sort'])){
            $linksort = '&amp;sort=' . $valid['sort'];
        }
        if (!empty($valid['size'])){
            $linksize = '&amp;size=' . $valid['size'];
        }
        if (!empty($valid['page'])){
            $linkpage = '&amp;page=' . $valid['page'];
        } else $linkpage = '&amp;page=1';
        $get = $linksort . $linksize . $linkpage;
    }

    $indexlink = '<a href="' . $INM_CONF['url_html'] . '/browse.php">' . $LANG_INM10[61] . '</a>&nbsp;&gt;&nbsp;';

    if (!empty($id) && $isalbum){
        if (inm_hasAlbumAccess($id) == 3){
            $editlink = '&nbsp;&nbsp;<a href="' . $INM_CONF['url_html'] . '/albums.php?id=' . $id . '">' . $LANG_INM10[40] . '</a>';
        }
        $result = DB_query("SELECT name, pid FROM {$INM_TABLES['albums']} WHERE id='$id'");
        list ($name,$pid) = DB_fetchArray($result);
        if (!empty($pid)){
            $parent = DB_getItem($INM_TABLES['albums'], 'name', "id='$pid'");
            $parent = trim(stripslashes($parent));
            if (strlen($parent) > 24){
                $parent = '<a href="'. $INM_CONF['url_html'] . '/browse.php?id=' . $pid . '">' . substr($parent, 0, 24) . '...</a>&nbsp;&gt;&nbsp;';
                //$parent = substr($parent, 0, 24) . '...&nbsp;&gt;&nbsp;';
            } else {
                $parent = '<a href="'. $INM_CONF['url_html'] . '/browse.php?id=' . $pid . '">' . $parent . '</a>&nbsp;&gt;&nbsp;';
                //$parent = $parent . '&nbsp;&gt;&nbsp;';
            }
        }
        $name = trim(stripslashes($name));
        if (strlen($name) > 24){
            $name = '<a href="'. $INM_CONF['url_html'] . '/browse.php?id=' . $id . $get . '">' . substr($name, 0, 24) . '</a>';
            //$name = substr($name, 0, 24);
        } else {
            $name = '<a href="'. $INM_CONF['url_html'] . '/browse.php?id=' . $id . $get . '">' . $name . '</a>';
            //$name = $name;
        }
        $blocktitle = '<span class="inm-bread">' . $indexlink . $parent . $name . '</span>' . $editlink;
    } elseif (!empty($id) && !$isalbum){
        if (inm_hasMediaAccess($id) == 3){
            $editlink = '&nbsp;&nbsp;<a href="' . $INM_CONF['url_html'] . '/media.php?mid=' . $id . '">' . $LANG_INM10[40] . '</a>';
        }
        $result = DB_query("SELECT title, filename, aid FROM {$INM_TABLES['media']} WHERE mid='$id'");
        list ($title,$filename,$aid) = DB_fetchArray($result);
        $result = DB_query("SELECT id, name, pid FROM {$INM_TABLES['albums']} WHERE id='$aid'");
        list ($aid,$album,$pid) = DB_fetchArray($result);
        if (!empty($pid)){
            $parent = DB_getItem($INM_TABLES['albums'], 'name', "id='$pid'");

            $parent = COM_stripslashes($parent);
            if (strlen($parent) > 24){
                $parent = '<a href="'. $INM_CONF['url_html'] . '/browse.php?id=' . $pid . '">' . substr($parent, 0, 24) . '...</a>&nbsp;&gt;&nbsp;';
                //$parent = substr($parent, 0, 24) . '...&nbsp;&gt;&nbsp;';
            } else {
                $parent = '<a href="'. $INM_CONF['url_html'] . '/browse.php?id=' . $pid . '">' . $parent . '</a>&nbsp;&gt;&nbsp;';
                //$parent = $parent . '&nbsp;&gt;&nbsp;';
            }
        }

        $album = COM_stripslashes($album);
        if (strlen($album) > 24){
            $album = '<a href="'. $INM_CONF['url_html'] . '/browse.php?id=' . $aid . $get . '">' . substr($album, 0, 24) . '...</a>&nbsp;&gt;&nbsp;';
            //$album = substr($album, 0, 24) . '...&nbsp;&gt;&nbsp;';
        } else {
            $album = '<a href="'. $INM_CONF['url_html'] . '/browse.php?id=' . $aid . $get . '">' . $album . '</a>&nbsp;&gt;&nbsp;';
            //$album = $album . '&nbsp;&gt;&nbsp;';
        }

        if (!empty($title)){
            $title = COM_stripslashes($title);
        } else {
            $title = COM_stripslashes($filename);
        }
        $blocktitle = '<span class="inm-bread">' . $indexlink . $parent . $album . $title . '</span>' . $editlink;
    }
    return $blocktitle;
}

//testing something
function inm_iniTest(){
    $retval = ini_get ('disable_functions');
    //$retval = ini_get_all ();
    return print_r($retval);
}

//check perms
function inm_isWritable($path){
    if (is_file($path) && is_writable($path)){
        clearstatcache();
        return true;
    } elseif (is_dir($path) && is_writable($path)){
        clearstatcache();
        return true;
    } else {
        clearstatcache();
        return false;
    }
}

function inm_isFile($path){
    if (is_file($path)){
        clearstatcache();
        return true;
    } else {
        clearstatcache();
        return false;
    }
}

function inm_isDir($path){
    if (is_dir($path)){
        clearstatcache();
        return true;
    } else {
        clearstatcache();
        return false;
    }
}

//deletes any static images generated from admin
//id is album id or media id or if empty, all static images are deleted
function inm_deleteStatic($id = '', $type = ''){
    global $INM_CONF, $LANG_INM06, $INM_TABLES;

    if (!empty($id) && $type == 'media'){
        $result = DB_query("SELECT aid, filename FROM {$INM_TABLES['media']} WHERE mid='$id'");
        list($album, $filename) = DB_fetchArray($result);
        $paths = array(
            $INM_CONF['path_scaled'] . $album . '/' . $filename,
            $INM_CONF['path_thumbs'] . $album . '/' . $INM_CONF['thumb_prefix'][1] . $filename,
            $INM_CONF['path_thumbs'] . $album . '/' . $INM_CONF['thumb_prefix'][2] . $filename,
            $INM_CONF['path_thumbs'] . $album . '/' . $INM_CONF['thumb_prefix'][3] . $filename
            );
    } elseif (!empty($id) && $type == 'album'){
        $paths = array($INM_CONF['path_scaled'] . $id . '/', $INM_CONF['path_thumbs'] . $id . '/');
    } elseif (empty($id)){
        $paths = array($INM_CONF['path_scaled'], $INM_CONF['path_thumbs']);
    }

    /* my preference here would be to use the pear system class, but it requires a  *
    *  non existant file, atm. It will have to wait for gl 1.3.12.                  *
    */
    foreach($paths as $value){
        if (inm_isFile($value)){
            unlink($value);
        } elseif (inm_isDir($value)){
            $dh = opendir($value);
            while (($filename = readdir($dh)) !== false){
                if ($filename != '.' && $filename != '..'){
                    if (inm_isFile($value . $filename)){
                        unlink($value . $filename);
                    } elseif (inm_isDir($value . $filename)){
                        $sdh = opendir($value . $filename);
                        //return $value . $filename;
                        while (($sfile = readdir($sdh)) !== false){
                            if ($sfile != '.' && $sfile != '..'){
                                //return $value. $filename . '/' . $sfile;
                                if (inm_isFile($value . $filename . '/' . $sfile)){
                                    unlink($value . $filename . '/' . $sfile);
                                } else {
                                    //nothing should've been created past this
                                }
                            }
                        }
                        closedir($sdh);
                        //the potential exists that these directories cannot be removed--no biggy
                        @rmdir($value . $filename . '/');
                    }
                }
            }
            closedir($dh);
            //the potential exists that these directories cannot be removed--no biggy
            @rmdir($value);
        }
    }
    if (empty($id)){
        return $LANG_INM06[107];
    }
}

//remove a media item from favorites
function inm_deleteFav($mid = '',$uid = ''){
    global $INM_TABLES;
    if (!empty($mid)){
        DB_query("DELETE FROM {$INM_TABLES['favorites']} WHERE mid='$mid' LIMIT 1");
    }
    if (!empty($uid)){
        DB_query("DELETE FROM {$INM_TABLES['favorites']} WHERE uid='$uid'");
    }
}

//modified COM_getUserDateTimeFormat to accommodate a separate format for the gallery
function inm_getUserDateTimeFormat($date = ''){
    global $_TABLES, $INM_TABLES, $_CONF;

    // Get display format for time
    $dfid = DB_getItem($INM_TABLES['settings'], 'dfid');
    if ($dfid == '0'){
        $dateformat = $_CONF['date'];
    } else {
        $dateformat = DB_getItem($_TABLES['dateformats'], 'format', "dfid='$dfid'");
    }

    if(empty($date)){
        // Date is empty, get current date/time
        $stamp = time();
    } elseif (is_numeric($date)){
        // This is a timestamp
        $stamp = $date;
    } else {
        // This is a string representation of a date/time
        $stamp = strtotime($date);
    }

    // Format the date
    $date = strftime($dateformat, $stamp);

    return array( $date, $stamp );
}

?>