<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | media.php                                                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Retrieve access settings
$result = DB_query("SELECT logincreate FROM {$INM_TABLES['settings']}");
list($logincreate) = DB_fetchArray($result);

// Check user has rights to access this page
if (SEC_hasRights('inmemoriam.admin') || SEC_hasRights('inmemoriam.create')){
    //allow
} elseif (($_USER['uid'] < 2) || (($logincreate == '0') && ($_USER['uid'] >= 2))) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the inmemoriam page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_INM00['access_denied']);
    $display .= $LANG_INM00['access_denied_msg1'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

//displays the album editor
function inm_albumEditor($id = ''){
    global $_CONF, $INM_CONF, $_USER, $_GROUPS, $_TABLES, $INM_TABLES, $LANG_INM02, $LANG_INM03;

    if (!empty($id)){
        $result = DB_query("SELECT * FROM {$INM_TABLES['albums']} WHERE id='$id' LIMIT 1");
        if (DB_numRows($result) < 1){
            //no album exists by that id
            //but let's shoot a msg and log the attempt
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[12];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally edit not extant album: $id.");
            return $display;
        }
        $A = DB_fetchArray($result);
        $access = inm_hasAlbumAccess($id);
        if (empty($access) || $access < 3) {
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[12];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally edit album: $id.");
            return $display;
        }
    }

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array('page' => 'album-editor.thtml', 'perms' => 'perm-editor.thtml', 'albumsel' => 'album-select.thtml', 'parentsel' => 'parent-select.thtml', 'subalbum' => 'subalbum-app.thtml', 'parenttext' => 'parent-text.thtml', 'makeparent' => 'make-parent.thtml', 'featured' => 'featured-chk.thtml', 'clearwm' => 'clearwm.thtml', 'sizetype' => 'sizetype.thtml'));
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('url_html', $INM_CONF['url_html']);

    //dropdown of accessible albums
    if (SEC_hasRights('inmemoriam.admin')){
        $bresult = DB_query("SELECT id, name, pid FROM {$INM_TABLES['albums']}  ORDER BY name ASC");
    } else {
        $bresult = DB_query("SELECT id, name, pid FROM {$INM_TABLES['albums']} WHERE owner_id='{$_USER['uid']}' ORDER BY name ASC");
    }
    if (DB_numRows($bresult) > 0){
        $albumoptions = '';
        while ($B = DB_fetchArray($bresult)){
            $cresult = DB_query("SELECT id, name FROM {$INM_TABLES['albums']} WHERE owner_id='{$_USER['uid']}' AND pid='{$B['id']}' ORDER BY name ASC");
            if (DB_numRows($cresult) > 0){
                $subalbumoptions = '';
                while ($C = DB_fetchArray($cresult)){
                    $subalbumoptions .= '<option value="' . $C['id'] . '">';
                    $subalbumoptions .= '--' . stripslashes($C['name']) . '</option>' . LB;
                }
            }
            if ($B['pid'] == ''){
                $albumoptions .= '<option value="' . $B['id'] . '">';
                $albumoptions .= stripslashes($B['name']) . '</option>' . LB;
            }
            $albumoptions .= $subalbumoptions;
            $subalbumoptions = '';
        }
        $T->set_var('langselect', $LANG_INM02[4]);
        $T->set_var('albumoptions', $albumoptions);
        $T->parse('albumselect', 'albumsel');
        if (empty($id)){
            $T->set_var('langcreate', $LANG_INM02[5]);
        } else {
            $T->set_var('langcreate', $LANG_INM02[44]);
        }
    } else {
        //don't display album dropdown
        if (empty($id)){
            $T->set_var('langcreate', $LANG_INM02[39]);
        } else {
            $T->set_var('langcreate', $LANG_INM02[44]);
        }
    }

    $T->set_var('langname', $LANG_INM02[6]);
    $T->set_var('langid', $LANG_INM02[7]);
    $T->set_var('nospaces', $LANG_INM02[11]);

    //dropdown of potential parent albums
    if (SEC_hasRights('inmemoriam.admin')){
        $presult = DB_query("SELECT id, name, pid FROM {$INM_TABLES['albums']} WHERE (pid='' OR pid IS NULL)");
    } else {
        $presult = DB_query("SELECT id, name, pid FROM {$INM_TABLES['albums']} WHERE owner_id='{$_USER['uid']}' AND (pid='' OR pid IS NULL)");
    }
    if (DB_numRows($presult) >= 1){
        $parentoptions = '';
        $parentA = array();
        $toplevel = array();
        while ($P = DB_fetchArray($presult)){
            //array of all top level albums
            $toplevel[] = $P['id'];
            if (!empty($id) && $id == $P['id']){
                //array of top level albums except for current aid
                $parentA[] = $P['id'];
            } else {
                //allowable parent options
                $parentoptions .= '<option value="' . $P['id'];
                if ($P['id'] == $A['pid']){
                    $parentoptions .= '" selected="selected"';
                }
                $parentoptions .= '">';
                $parentoptions .= stripslashes($P['name']) . '</option>' . LB;
            }
        }
        $T->set_var('parentoptions', $parentoptions);
        $T->set_var('parentdisabled', ' disabled="disabled"');
        if (empty($id)){
            //new album
            $T->set_var('langsubalbum', $LANG_INM02[9]);
            $T->set_var('langparent', $LANG_INM02[10]);
            $T->parse('parentselect', 'parentsel');
        } elseif (!empty($id) && in_array($id, $toplevel)){
            //parent-album
            if ((count($toplevel) >= 2) && (DB_count($INM_TABLES['albums'], 'pid', $id) <= 0)){
                $T->set_var('langsubalbum', $LANG_INM02[9]);
                $T->set_var('langparent', $LANG_INM02[10]);
                $T->parse('parentselect', 'parentsel');
            }
        } elseif (!empty($id) && !in_array($id, $toplevel)){
            //sub-album
            $T->set_var('langcurrentparent', $LANG_INM02[51]);
            $currentparent = DB_getItem($INM_TABLES['albums'], 'name', "id='{$A['pid']}'");
            $T->set_var('currentparent', $currentparent);
            $T->parse('parenttext', 'parenttext');
            if (count($toplevel) >= 2){
                $T->set_var('langsubalbum', $LANG_INM02[9]);
                $T->set_var('langparent', $LANG_INM02[10]);
                $T->parse('parentselect', 'parentsel');
            }
            $T->set_var('langmakeparent', $LANG_INM02[57]);
            $T->parse('makeparent', 'makeparent');
        }
    }

    $selected = ' selected="selected"';
    $checked = ' checked="checked"';

    if (SEC_hasRights('inmemoriam.admin')){
        //display options for allowable max file size and file types.
        $globalmax = DB_getItem($INM_TABLES['settings'], 'max_filesize');
        $globalmaxM = inm_readbytes($globalmax);
        $T->set_var('lang_global_max', sprintf($LANG_INM02[90], $globalmax, $globalmaxM));
        $T->set_var('langmaxfile', $LANG_INM02[89]);
        $T->set_var('langfiletype', $LANG_INM02[88]);
        $T->set_var('image', $LANG_INM02[84]);
        $T->set_var('audio', $LANG_INM02[85]);
        $T->set_var('video', $LANG_INM02[86]);
        $T->set_var('code', $LANG_INM02[87]);

        if ($A['max_filesize'] > $globalmax){
            $A['max_filesize'] = $globalmax;
        }
        $T->set_var('maxsize', '');

        $globalmax = DB_getItem($INM_TABLES['settings'], 'max_filesize');
        if (empty($id)){
            $globalmax = DB_getItem($INM_TABLES['settings'], 'max_filesize');
            $T->set_var('maxsize', $globalmax);
            $T->set_var('itchecked', $checked);
            $T->set_var('atchecked', '');
            $T->set_var('vtchecked', '');
            $T->set_var('ctchecked', '');
        } elseif (!empty($id)){
            if ($A['max_filesize'] > $globalmax){
                $A['max_filesize'] = $globalmax;
            }
            $T->set_var('maxsize', $A['max_filesize']);
            if ($A['enable_image'] == 1){
                $T->set_var('itchecked', $checked);
            } else {
                $T->set_var('itchecked', '');
            }
            if ($A['enable_audio'] == 1){
                $T->set_var('atchecked', $checked);
            } else {
                $T->set_var('atchecked', '');
            }
            if ($A['enable_video'] == 1){
                $T->set_var('vtchecked', $checked);
            } else {
                $T->set_var('vtchecked', '');
            }
            if ($A['enable_code'] == 1){
                $T->set_var('ctchecked', $checked);
            } else {
                $T->set_var('ctchecked', '');
            }
        }
        $T->parse('allowable_size_type', 'sizetype');
    }
    $T->set_var('langaccessrights', $LANG_INM03[1]);
    $T->set_var('accessdocs', sprintf($LANG_INM02[8], 'albumaccess'));


    $T->set_var('langallowsubmit', $LANG_INM02[58]);
    $T->set_var('langqueue', $LANG_INM02[50]);

    $T->set_var('langowner', $LANG_INM03[3]);
    $T->set_var('langgroup', $LANG_INM03[4]);
    $T->set_var('langpermkey', $LANG_INM03[8]);
    $T->set_var('langmembers', $LANG_INM03[5]);
    $T->set_var('langanon', $LANG_INM03[6]);
    $T->set_var('perm_note', $LANG_INM03[7]);

    if (empty($id)){
        //default perms/access
        $T->set_var('ownerid', $_USER['uid']);
        $T->set_var('ownerusername', $_USER['username']);
        if (isset ($_GROUPS['inmemoriam Admin'])) {
            $A['group_id'] = $_GROUPS['inmemoriam Admin'];
        } else {
            $A['group_id'] = SEC_getFeatureGroup ('inmemoriam.create');
        }
        $access = 3;//if it were not so, we wouldn't be in the editor
        $T->set_var('ownchecked2', $checked);
        $T->set_var('ownchecked1', $checked);
        $T->set_var('grpchecked2', $checked);
        $T->set_var('grpchecked1', '');
        $T->set_var('memchecked', $checked);
        $T->set_var('anonchecked', $checked);

        $T->set_var('queuechk', $checked);
        $T->set_var('queuedisabled', ' disabled="disabled"');
    } elseif (!empty($id)){
        //album perms/access
        $username = DB_getItem($_TABLES['users'], 'username', "uid='{$A['owner_id']}'");
        $T->set_var('ownerid', $A['owner_id']);
        $T->set_var('ownerusername', $username);
        if ($A['perm_owner'] >= 2){
            $T->set_var('ownchecked2', $checked);
        }
        if ($A['perm_owner'] == 3){
            $T->set_var('ownchecked1', $checked);
        } else $T->set_var('ownchecked1', '');
        if ($A['perm_group'] >= 2){
            $T->set_var('grpchecked2', $checked);
        }
        if ($A['perm_group'] == 3){
            $T->set_var('grpchecked1', $checked);
        }
        if ($A['perm_members'] == 2){
            $T->set_var('memchecked', $checked);
        } else $T->set_var('memchecked', '');
        if ($A['perm_anon'] == 2){
            $T->set_var('anonchecked', $checked);
        } else $T->set_var('anonchecked', '');
        if ($A['allow_submit'] == 1){
            $T->set_var('allowsubchk', $checked);
            $T->set_var('queuedisabled', '');
        } else {
            $T->set_var('allowsubchk', '');
            $T->set_var('queuedisabled', ' disabled="disabled"');
        }
        if ($A['queue'] == 1){
            $T->set_var('queuechk', $checked);
        } else $T->set_var('queuechk', '');
    }
    $usergroups = SEC_getUserGroups();
    $groupoptions = '';
    if ($access == 3) {//this check is really unecessary atm
        $groupoptions .= '<select name="groupid">';
        for ($i = 0; $i < count($usergroups); $i++) {
            $groupoptions .= '<option value="' . $usergroups[key($usergroups)] . '"';
            if ($A['group_id'] == $usergroups[key($usergroups)]) {
                $groupoptions .= $selected;
            }
            $groupoptions .= '>' . key($usergroups) . '</option>' . LB;
            next($usergroups);
        }
        $groupoptions .= '</select>';
        $T->set_var('groupoptions', $groupoptions);
    } else {
        // they can't set the group then
        $groupoptions .= '<span style="vertical-align: top;">' . DB_getItem ($_TABLES['groups'],
            'grp_name', "grp_id = {$A['group_id']}") . '</span>';
        $groupoptions .= '<input type="hidden" name="group_id" value="' . $A['group_id'] . '">' . LB;
    }
/***********************Permissions editor only for inmemoriam.admin/edit*************/
//perhaps, after a while of feedback, allowing the permissions
//editor for album owners will be made an option from the admin panel.
    if (SEC_hasRights('inmemoriam.admin')){
        $T->parse('permissions_editor', 'perms');
    }

/**********************************************************/

    $T->set_var('langalbumsettings', $LANG_INM02[42]);
    $T->set_var('langmediasettings', $LANG_INM02[43]);
    $T->set_var('adisplaydocs', sprintf($LANG_INM02[8], 'albumdisplay'));
    $T->set_var('mdisplaydocs', sprintf($LANG_INM02[8], 'mediadisplay'));
    $T->set_var('langdesc', $LANG_INM02[12]);
    $T->set_var('langthumb', $LANG_INM02[13]);
    $T->set_var('langrandthumb', $LANG_INM02[14]);
    $T->set_var('langthumbsize', $LANG_INM02[46]);
    $T->set_var('small', $LANG_INM02[47]);
    $T->set_var('medium', $LANG_INM02[48]);
    $T->set_var('large', $LANG_INM02[49]);
    $T->set_var('langcomments', $LANG_INM02[40]);
    $T->set_var('langrating', $LANG_INM02[41]);
    $T->set_var('langframe', $LANG_INM02[15]);
    $T->set_var('langtheme', $LANG_INM02[16]);
    $T->set_var('langorder', $LANG_INM02[17]);
    $T->set_var('ascending', $LANG_INM02[18]);
    $T->set_var('descending', $LANG_INM02[19]);
    $wmres = DB_query("SELECT wid FROM {$INM_TABLES['media']} WHERE aid='$id' AND (wid<>'' or wid<>NULL) LIMIT 1");
    if (DB_numRows($wmres) >= 1){
        $T->set_var('langclearwm', $LANG_INM02[83]);
        $T->parse('clearwatermarks', 'clearwm');
    }
    $T->set_var('langwidth', $LANG_INM02[20]);
    $T->set_var('langheight', $LANG_INM02[21]);
    $T->set_var('langorig', $LANG_INM02[22]);
    $T->set_var('langrestrict', $LANG_INM02[78]);
    $T->set_var('norestrict', $LANG_INM02[79]);
    $T->set_var('members', $LANG_INM02[76]);
    $T->set_var('group', $LANG_INM02[77]);

    //add additional themes via the themes dir and config.php--see docs
    $themeoptions = '';
    $i = 0;
    foreach ($INM_CONF['themes'] as $theme){
        $themeoptions .= '<option value="' . $i . '"{theme' . $i . '}">' . $theme . '</option>' . LB;
        $i++;
    }
    $T->set_var('themeoptions', $themeoptions);

    //add additional frames via the frames dir and config.php--see docs
    $frameoptions = '';
    $i = 0;
    foreach ($INM_CONF['frames'] as $frame){
        $frameoptions .= '<option value="' . $i . '"{frame' . $i . '}">' . $frame . '</option>' . LB;
        $i++;
    }
    $T->set_var('frameoptions', $frameoptions);

    $T->set_var('framedoc', $LANG_INM02[25]);
    $T->set_var('themedoc', $LANG_INM02[26]);
    $T->set_var('datedesc', $LANG_INM02[59]);
    $T->set_var('dateasc', $LANG_INM02[60]);
    $T->set_var('hitsdesc', $LANG_INM02[61]);
    $T->set_var('hitsasc', $LANG_INM02[62]);
    $T->set_var('ratedesc', $LANG_INM02[63]);
    $T->set_var('rateasc', $LANG_INM02[64]);
    $T->set_var('langperpage', $LANG_INM02[30]);
    $T->set_var('none', $LANG_INM02[36]);
    $T->set_var('default', $LANG_INM02[37]);

    if (SEC_hasRights('inmemoriam.admin')){
        $T->set_var('langfeat', $LANG_INM02[65]);
        $T->set_var('featnote', $LANG_INM02[68]);
        $T->set_var('langfeatpos', $LANG_INM02[66]);
        $T->set_var('langfeatpage', $LANG_INM02[67]);
        $T->set_var('top', $LANG_INM02[69]);
        $T->set_var('after', $LANG_INM02[70]);
        $T->set_var('bottom', $LANG_INM02[71]);
        $T->set_var('all', $LANG_INM02[72]);
        $T->set_var('homeonly', $LANG_INM02[73]);
        $T->set_var('langfeattype', $LANG_INM02[80]);
        $T->set_var('albumsummary', $LANG_INM02[81]);
        $T->set_var('thumbreview', $LANG_INM02[82]);
        $T->set_var('topicoptions', COM_topicList('tid,topic',$A['cntrblkpage']));
        if (!empty($A['featured'])){
            $T->set_var('featchk', $checked);
            $T->set_var('featpos' . $A['cntrblkpos'], $selected);
            $T->set_var('feattype' . $A['cntrblktype'], $selected);
            $T->set_var($A['cntrblkpage'] . 'sel', $selected);
        } else {
            $T->set_var('featdisabled', ' disabled="disabled"');
        }
        $T->parse('featuredinput', 'featured');
    }

    if (empty($id)){
        //defaults
        $newaid = '<input type="hidden" name="newaid" value="1" />';
        $T->set_var('newaid', $newaid);
        $T->set_var('aid', COM_makesid());
        $T->set_var('randchk', $checked);
        $T->set_var('thsize2', $selected);
        $T->set_var('en_comments', $checked);
        $T->set_var('en_rating', '');
        $T->set_var('frame0', $selected);
        $T->set_var('theme0', $selected);
        $T->set_var('order1', $selected);
        $T->set_var('maxw', '480');
        $T->set_var('maxh', '480');
        $T->set_var('perpage24', $selected);
        $T->set_var('restrict1', $selected);
        $T->set_var('origchk', $checked);
    } elseif (!empty($id)){
        //db
        $oldaid = '<input type="hidden" name="oldaid" value="' . $A['id'] . '" />';
        $T->set_var('oldaid', $oldaid);
        $T->set_var('name', $A['name']);
        $T->set_var('aid', $A['aid']);
        $ownername = DB_getItem($_TABLES['users'], 'username', "uid='{$A['owner_id']}'");
        $T->set_var('ownerusername', $ownername);
        $T->set_var('desc', stripslashes($A['description']));
        if (empty($A['thumb'])){
            $T->set_var('thumb', '');
            $T->set_var('randchk', $checked);
        } else {
            $T->set_var('thumb', $A['thumb']);
            $T->set_var('randchk', '');
        }
        $T->set_var('thsize' . $A['thumbsize'], $selected);
        if ($A['enable_comments'] == 1){
            $T->set_var('en_comments', $checked);
        } else {
            $T->set_var('en_comments', '');
        }
        if ($A['enable_rating'] == 1){
            $T->set_var('en_rating', $checked);
        } else {
            $T->set_var('en_rating', '');
        }
        $T->set_var('theme' . $A['theme'], $selected);
        $T->set_var('frame' . $A['frame'], $selected);
        $T->set_var('order' . $A['orderby'], $selected);
        $T->set_var('maxw', $A['maxw']);
        $T->set_var('maxh', $A['maxh']);
        if ($A['dispfullimg'] == 1){
            $T->set_var('origchk', $checked);
        } else {
            $T->set_var('origchk', '');
        }
        $T->set_var('restrict' . $A['limitfullimg'], $selected);
        $T->set_var('perpage' . $A['thumbs_perpage'], $selected);
        //$T->set_var('', $A['']);
        //$T->set_var('', $A['']);
        $pidres = DB_query("SELECT id FROM {$INM_TABLES['albums']} WHERE pid='$id' LIMIT 1");
        if (DB_numRows($pidres) > 0){
            $T->set_var('langapplytoall', $LANG_INM02[38]);
            $T->parse('applytosubalbums', 'subalbum');
        }
    }

    $T->set_var('save', $LANG_INM02[31]);
    $T->set_var('reset', $LANG_INM02[32]);
    if (!empty($id) && $access == 3){
        $T->set_var('delete', '<input type="submit" name="submit" value="'.$LANG_INM02[33].'" />' . LB);
    }
    $T->set_var('cancel', $LANG_INM02[34]);

    $T->parse('output','page');
    $display = $T->finish($T->get_var('output'));
    return $display;
}

//creates an album
//$valid is an array of validated post data
//returns a success or error msg
function inm_createAlbum($valid){
    global $LANG_INM04, $INM_TABLES, $_CONF, $_TABLES, $INM_CONF, $_USER, $_FILES;

    //create new album
    if (!empty($valid['newaid'])){
        //check if exists album by aid
        //but first remove spaces
        $valid['aid'] = eregi_replace(' ', '_', $valid['aid']);
        //and ensure it is alphanumeric
        if (!eregi('^[a-zA-Z0-9\._-]+$', $valid['aid'])) {
            return $LANG_INM04[1];
        }
        if (empty($valid['aid'])){
            //should never happen but you never know
            $valid['aid'] = COM_makesid();
        }
        $result = DB_getItem($INM_TABLES['albums'], 'id', "id='{$valid['aid']}'");
        if ($result == $valid['aid']){
            //wasn't that the most useless query :P
            //ID not unique error
            return $LANG_INM04[5];
        }
        //check for pid
        if (!empty($valid['parent'])){
            $pid = DB_getItem($INM_TABLES['albums'], 'id', "id='{$valid['parent']}'");
            if ($pid != $valid['aid'] || !empty($pid)){
                $pdir = DB_getItem($INM_TABLES['albums'], 'aid', "id='$pid'");
            } else {
                $pdir = '';
                $pid = '';
            }
        }
        //check if parent album is writable
        if (!@is_writable($INM_CONF['path_albums'] . $pdir)){
            //not writable error
            return $LANG_INM04[3];
        }
        //create dir
        if ($pdir == ''){
            $path = $INM_CONF['path_albums'] . $valid['aid'];
        } else {
            $path = $INM_CONF['path_albums'] . $pdir . '/' . $valid['aid'];
        }
        if (!is_dir($path)){
            if (!@mkdir($path)){
                //error
                return $LANG_INM04[6];
            }
            $dbpath = $path . '/';
        }
        //insert sql
        $insert = "INSERT INTO {$INM_TABLES['albums']} SET"
            . " aid='{$valid['aid']}', name='{$valid['name']}',"
            . " description='{$valid['description']}', hits='0',"
            . " frame='{$valid['frame']}', theme='{$valid['theme']}',"
            . " thumbsize='{$valid['thumbsize']}', thumbs_perpage='{$valid['perpage']}',"
            . " maxw='{$valid['maxw']}', maxh='{$valid['maxh']}',"
            . " dispfullimg='{$valid['origsize']}', limitfullimg='{$valid['limitfull']}',"
            . " enable_rating='{$valid['rating']}', enable_comments='{$valid['comments']}',"
            . " orderby='{$valid['order']}', group_id='{$valid['groupid']}', owner_id='{$valid['ownerid']}',"
            . " path='$dbpath', pid='$pid', date_created=NOW()";
        if ($valid['queue'] == '1' && $valid['allowsubmit'] == '1'){
            $insert .= ", allow_submit='1'";
            $insert .= ", queue='1'";
        } elseif ($valid['allowsubmit'] == '1'){
            $insert .= ", allow_submit='1'";
            $insert .= ", queue='0'";
        } else {
            $insert .= ", allow_submit='0'";
            $insert .= ", queue='1'";
        }
/************permissins editor only available for inmemoriam.admin******/
        if (SEC_hasRights('inmemoriam.admin')){
            // Convert array values to numeric permission values
            list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($valid['perm_owner'],$valid['perm_group'],$valid['perm_members'],$valid['perm_anon']);
            $insert .= ", perm_owner='$perm_owner', perm_group='$perm_group', perm_members='$perm_members', perm_anon='$perm_anon'";
        }
/*****************/
        //if !randthumb then $_files and store path;
        if (!empty($_FILES['thumb']['name'])){exit;
            //upload thumb
            $albumthumb = new inmUpload;
            $albumthumb->temp_file_name = trim($_FILES['thumb']['tmp_name']);
            $pos = strrpos(trim(strtolower($_FILES['thumb']['name'])),'.') + 1;
            $fextension = substr($_FILES['thumb']['name'], $pos);
            $filename = 'th' . '_' . $valid['aid'] . '.' . $fextension;
            $albumthumb->file_name = $filename;
            $albumthumb->upload_dir = $INM_CONF['path_albums'];
            $albumthumb->upload_log_dir = $INM_CONF['path_logs'];
            //  size and allowable extensions will be moved
            //  and will be configurable in a later release
            $albumthumb->max_file_size = 65536; // 65536 = 64KB  //more than enuf
            $albumthumb->ext_array = array(".jpg",".gif",".jpeg",".png");
            $uploaded = $albumthumb->upload_file_with_validation();
            if (!$uploaded) {
                //backing out
                if(is_dir($path)){
                    @rmdir($path);
                }
                return $LANG_INM04[8];
            } else {
                $insert .= ", thumb='$filename'";
            }
        }

        if (SEC_hasRights('inmemoriam.admin')){
            if (!empty($valid['featured'])){
                $insert .= ", featured='1', cntrblkpos='{$valid['featpos']}'";
                $insert .= ", cntrblkpage='{$valid['featpage']}', cntrblktype='{$valid['feattype']}'";
                DB_query("UPDATE {$INM_TABLES['albums']} SET featured='0', cntrblkpos='', cntrblkpage='', cntrblktype='' WHERE featured='1'");
            }
            $globalmax = DB_getItem($INM_TABLES['settings'], 'max_filesize');
            if ($valid['max_filesize'] > $globalmax){
                $valid['max_filesize'] = $globalmax;
            }
            $insert .= ", max_filesize='{$valid['maxsize']}'";
            if ($valid['imagetype'] != 1 && $valid['audiotype'] != 1 && $valid['videotype'] != 1 && $valid['codetype'] != 1){
                $inset .= ", enable_image='1'";//because something has to be enabled
            } else {
                if ($valid['imagetype'] == 1){
                    $insert .= ", enable_image='1'";
                }
                if ($valid['audiotype'] == 1){
                    $insert .= ", enable_audio='1'";
                }
                if ($valid['videotype'] == 1){
                    $insert .= ", enable_video='1'";
                }
                if ($valid['codetype'] == 1){
                    $insert .= ", enable_code='1'";
                }
            }
        }

        DB_query($insert);
        $albumID = DB_insertID();
    } else {
        //input error
        return $LANG_INM04[1];
    }
    //success
    $success = sprintf($LANG_INM04[4], stripslashes($valid['name']));
    if (empty($valid['parent'])){
        $success .= inm_showAlbumSummary($albumID);
    } else {
        $success .= inm_showSubAlbumSummary($albumID, true);
    }
    return $success;
}

//deletes an album
function inm_deleteAlbum($oldaid){
    /* the use of pear (system::rm) is preferred here, but a GL 1.3.11 bug prevents it */
    global $INM_TABLES, $INM_CONF, $_CONF, $LANG_INM02, $LANG_INM03;
    //is exist aid
    $result = DB_query("SELECT path, thumb FROM {$INM_TABLES['albums']} WHERE id='$oldaid'");
    if (DB_numRows($result) >= 1){
        //check access
        $A = DB_fetchArray($result);
        $access = inm_hasAlbumAccess ($oldaid);
        if (empty($access) || $access < 3){
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[12];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally delete album: $oldaid.");
            return $display;
        }
        $thumb = $A['thumb'];//for use later
        $path = $A['path'];
        $error = '';

        //get subalbums
        $result = DB_query("SELECT id, aid FROM {$INM_TABLES['albums']} WHERE pid='$oldaid'");
        while ($A = DB_fetchArray($result)){
            //remove subalbum files
            $bresult = DB_query("SELECT mid, filename, wid FROM {$INM_TABLES['media']} WHERE aid='{$A['id']}'");
            while ($B = DB_fetchArray($bresult)){

                //unlink associated watermark if not being used otherwise
                if (!empty($B['wid'])){
                    $usedres = DB_query("SELECT wid FROM {$INM_TABLES['media']} WHERE aid<>'{$A['id']}' LIMIT 1");
                    if (DB_numRows($usedres) < 1){
                        $wmimg = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$B['wid']}'");
                        if (!empty($wmimg) && $wmimg != $INM_CONF['default_wm']){
                            $wmpath = $INM_CONF['path_wm'] . $wmimg;
                            if (!file_exists($wmpath) || !@unlink($wmpath)){
                                //log this for now
                                $error .= sprintf($LANG_INM02[74], $wmimg) . '<br />';
                            }
                        }
                        //remove wm from database
                        DB_delete($INM_TABLES['watermarks'], 'wid', "{$B['wid']}");
                    }
                }

                $filename = $path . $A['aid'] . '/' . $B['filename'];
                if (!file_exists($filename) || !@unlink($filename)){
                    //halt process
                    //return sprintf($LANG_INM02[54], stripslashes($B['filename']));
                    //log this for now
                    $error .= sprintf($LANG_INM02[54], stripslashes($B['filename'])) . '<br />';
                    //remove it from db anyway???--undecided
                } else {
                    DB_delete($INM_TABLES['media'], 'mid', "{$B['mid']}");
                    //delete static images
                    inm_deleteStatic($B['mid'],'media');
                    //delete favorite
                    inm_deleteFav($B['mid']);
                }
            }
            //remove subalbum dirs
            $subalbum = $path . $A['aid'];
            if (!file_exists($subalbum) || !@rmdir($subalbum)){
                //halt process
                //return sprintf($LANG_INM02[55], stripslashes($A['aid']));
                //log this for now
                //$error .= sprintf($LANG_INM02[55], stripslashes($A['aid'])) . '<br />';
                $error .= sprintf($LANG_INM02[55], $subalbum) . '<br />';
                //remove it from db anyway???--undecided
            } else {
                DB_delete($INM_TABLES['albums'], 'id', "{$A['id']}");
            }
        }

        //remove parent album media
        $result = DB_query("SELECT mid, filename, wid FROM {$INM_TABLES['media']} WHERE aid='$oldaid'");
        while ($A = DB_fetchArray($result)){

            //unlink associated watermark if not being used otherwise
            if (!empty($A['wid'])){
                $usedres = DB_query("SELECT wid FROM {$INM_TABLES['media']} WHERE aid<>'{$A['id']}' LIMIT 1");
                if (DB_numRows($usedres) < 1){
                    $wmimg = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$A['wid']}'");
                    if (!empty($wmimg) && $wmimg != $INM_CONF['default_wm']){
                        $wmpath = $INM_CONF['path_wm'] . $wmimg;
                        if (!file_exists($wmpath) || !@unlink($wmpath)){
                            //log this for now
                            $error .= sprintf($LANG_INM02[74], $wmimg) . '<br />';
                        }
                    }
                    //remove wm from database
                    DB_delete($INM_TABLES['watermarks'], 'wid', "{$A['wid']}");
                }
            }

            $filename = $path . $A['filename'];
            if (!file_exists($filename) || !@unlink($filename)){
                //halt process
                //return sprintf($LANG_INM02[54], stripslashes($A['filename']));
                //log this for now
                $error .= sprintf($LANG_INM02[54], stripslashes($B['filename'])). '<br />';
                //remove it from db anyway???--undecided
            } else {
                DB_delete($INM_TABLES['media'], 'mid', "{$A['mid']}");
                //delete static images
                inm_deleteStatic($A['mid'],'media');
                //delete favorite
                inm_deleteFav($A['mid']);
            }
        }
        //remove album thumb if any
        if (file_exists($INM_CONF['path_albums'] . $thumb)){
            @unlink($INM_CONF['path_albums'] . $thumb);
        }
        //remove album dir
        //$parent = DB_getItem($INM_TABLES['albums'], 'pid', "id='$oldaid'");
        //if ($parent != ''){
        //    $album = $path . $parent . '/' . $oldaid;
        //} else {
        //    $album = $path;
        //}
        if (!file_exists($path) || !@rmdir($path)){
            //halt process -- actually rogue files may exist causing this to fail
            //return sprintf($LANG_INM02[55], stripslashes($oldaid));
            //log this for now
            //$error .= sprintf($LANG_INM02[55], stripslashes($oldaid)) . '<br />';
            $error .= sprintf($LANG_INM02[55], $path) . '<br />';
            //remove it from db anyway???--undecided
        } else {
            DB_delete($INM_TABLES['albums'], 'id', $oldaid);
        }

        //by this point the following shouldn't be necessary assuming error is empty
        //delete albums from db
        DB_query ("DELETE FROM {$INM_TABLES['albums']} WHERE id='$oldaid' OR pid='$oldaid'");
        //delete images in db
        DB_query ("DELETE FROM {$INM_TABLES['media']} WHERE aid='$oldaid'");

        //delete comments
        //update rss
    } else {
        //$oldaid must have been removed already
        return $LANG_INM02[52];
    }
    //return errors
    if ($error != ''){
        return $LANG_INM02[75] . $error;
    }
    //return success
    return $LANG_INM02[53];
}

//updates an album
function inm_updateAlbum($valid){
    global $INM_TABLES, $INM_CONF, $LANG_INM02, $LANG_INM03, $LANG_INM04;
    //is exist aid
    $result = DB_query("SELECT * FROM {$INM_TABLES['albums']} WHERE id='{$valid['oldaid']}'");
    if (DB_numRows($result) >= 1){
        $A = DB_fetchArray($result);
        //check access
        $access = inm_hasAlbumAccess ($valid['oldaid']);
        if (empty($access) || $access < 3){
            return $LANG_INM03[12];
        }
        //sanatize
        $valid['aid'] = eregi_replace(' ', '_', $valid['aid']);
        if (!eregi('^[a-zA-Z0-9\._-]+$', $valid['aid'])) {
            return $LANG_INM04[1];
        }

        if (empty($valid['aid'])){
            //should never happen but you never know
            $valid['aid'] = $A['aid'];
        }
        if ($valid['aid'] != $A['aid']){
            //have new aid, check if exists album by aid
            if(!empty($A['pid'])){
                $and = "AND (pid='' OR pid IS NULL)";
            } else $and = "AND pid='{$A['pid']}'";
            $exres = DB_query("SELECT aid FROM {$INM_TABLES['albums']} WHERE aid='{$valid['aid']}' " . $and);
            list($extant) = DB_fetchArray($exres);
            //$extant = DB_getItem($INM_TABLES['albums'], 'id', "aid='{$valid['aid']}'");
            if ($extant == $valid['aid']){
                //dir not unique error
                return $LANG_INM04[5];
            }
            //is it a sub album or not
            if ($A['pid'] == ''){
                $oldpath = $INM_CONF['path_albums'] . $A['aid'] . '/';
            } else {
                $pdir = DB_getItem($INM_TABLES['albums'], 'aid', "id='{$A['pid']}'");
                $oldpath = $INM_CONF['path_albums'] . $pdir . '/' . $A['aid'] . '/';
            }
            if (!empty($valid['parent'])){
                $pdir = DB_getItem($INM_TABLES['albums'], 'aid', "id='{$valid['parent']}'");
                $newpath = $INM_CONF['path_albums'] . $pdir . '/' . $valid['aid'] . '/';
                $setpid = " pid='{$valid['parent']}',";
            } elseif (!empty($valid['levelup'])){
                $newpath = $INM_CONF['path_albums'] . $valid['aid'] . '/';
                $setpid = " pid='',";
            } else {
                if ($A['pid'] == ''){
                    $newpath = $INM_CONF['path_albums'] . $valid['aid'] . '/';
                } else {
                    $pdir = DB_getItem($INM_TABLES['albums'], 'aid', "id='{$A['pid']}'");
                    $newpath = $INM_CONF['path_albums'] . $pdir . '/' . $valid['aid'] . '/';
                }
                $setpid = '';
            }

            if (!@file_exists($oldpath) || !@rename($oldpath, $newpath)){
                //halt process
                return sprintf($LANG_INM02[56], $valid['oldaid']);
            }
            $setaid = " aid='{$valid['aid']}',";
            $setpath = ", path='" . $newpath . "'";
        } else {
            //not updating aid
            $setaid = '';
            //is it a sub album or not
            if ($A['pid'] == ''){
                $oldpath = $INM_CONF['path_albums'] . $valid['aid'] . '/';
            } else {
                $pdir = DB_getItem($INM_TABLES['albums'], 'aid', "id='{$A['pid']}'");
                $oldpath = $INM_CONF['path_albums'] . $pdir . '/' . $valid['aid'] . '/';
            }
            if (!empty($valid['parent']) && $valid['parent'] != $A['pid']){
                //make subalbum out of toplevel album or change parent albums on subalbum
                $pdir = DB_getItem($INM_TABLES['albums'], 'aid', "id='{$valid['parent']}'");
                $newpath = $INM_CONF['path_albums'] . $pdir . '/' . $A['aid'] . '/';
                $setpid = ", pid='{$valid['parent']}'";
            } elseif (!empty($valid['levelup']) && !empty($A['pid'])){
                //make subalbum a toplevelalbum
                $newpath = $INM_CONF['path_albums'] . $A['aid'] . '/';
                $setpid = ", pid=''";
            } elseif (!empty($A['pid'])){
                //no change in subalbum
                $pdir = DB_getItem($INM_TABLES['albums'], 'aid', "id='{$A['pid']}'");
                $newpath = $INM_CONF['path_albums'] . $pdir . '/' . $A['aid'] . '/';
                $setpid= '';
            } elseif ($A['pid'] == ''){
                //no change in toplevel album
                $newpath = $oldpath;
                $setpid = '';
            }
            if ($newpath != $oldpath){
                if (!@file_exists($oldpath) || !@rename($oldpath, $newpath)){
                    //halt process
                    return sprintf($LANG_INM02[56], $valid['oldaid']);
                }
                $setpath = ", path='" . $newpath . "'";
            } else {
                $setpath = '';
            }
        }
        if ($valid['queue'] == '1'){
            $setsubmit = ", allow_submit='1'";
            $setqueue = ", queue='1'";
        } elseif ($valid['allowsubmit'] == '1'){
            $setsubmit = ", allow_submit='1'";
            $setqueue = ", queue='0'";
        } else {
            $setsubmit = ", allow_submit='0'";
            $setqueue = ", queue='0'";
        }

        //new uploaded thumbnail
        if (!empty($_FILES['thumb']['name'])){
            //upload thumb
            $albumthumb = new inmUpload;
            $albumthumb->temp_file_name = trim($_FILES['thumb']['tmp_name']);
            $pos = strrpos(trim(strtolower($_FILES['thumb']['name'])),'.') + 1;
            $fextension = substr($_FILES['thumb']['name'], $pos);
            $filename = 'th' . '_' . $valid['aid'] . '.' . $fextension;
            if (file_exists($INM_CONF['path_albums'] . $filename)){
                @unlink($INM_CONF['path_albums'] . $filename);
            }
            $albumthumb->file_name = $filename;
            $albumthumb->upload_dir = $INM_CONF['path_albums'];
            $albumthumb->upload_log_dir = $INM_CONF['path_logs'];
            //  max size and allowable extensions will be moved
            //  and will be configurable in a later release
            $albumthumb->max_file_size = 65536; // 65536 = 64KB  //more than enuf
            $albumthumb->ext_array = array(".jpg",".gif",".jpeg",".png");
            $uploaded = $albumthumb->upload_file_with_validation();
            if (!$uploaded) {
                //should back out here but whatever -- minor
                $setthumb = '';
            } else {
                $setthumb = ", thumb='$filename'";
            }
        } elseif ($A['thumb'] != ''){
            //moving from previously uploaded thumbnail to random thumb
            if ($valid['randthumb'] == 1){
                @unlink($INM_CONF['path_albums'] . $A['thumb']);
                $setthumb = ", thumb=''";
            } else {
                $setthumb = '';
            }
        }

        if (SEC_hasRights('inmemoriam.admin')){
            if (!empty($valid['featured'])){
                $setfeatured = ", featured='1', cntrblkpos='{$valid['featpos']}'";
                $setfeatured .= ", cntrblkpage='{$valid['featpage']}', cntrblktype='{$valid['feattype']}'";
                DB_query("UPDATE {$INM_TABLES['albums']} SET featured='0', cntrblkpos='', cntrblkpage='', cntrblktype='' WHERE featured='1'");
            } else {
                $setfeatured = ", featured='0', cntrblkpos='', cntrblkpage='', cntrblktype=''";
            }
            $globalmax = DB_getItem($INM_TABLES['settings'], 'max_filesize');
            if ($valid['max_filesize'] > $globalmax){
                $valid['max_filesize'] = $globalmax;
            }
            $maxfile = ", max_filesize='{$valid['maxsize']}'";
            if ($valid['imagetype'] != 1 && $valid['audiotype'] != 1 && $valid['videotype'] != 1 && $valid['codetype'] != 1){
                $enimage = ", enable_image='1', enable_audio='0', enable_video='0', enable_code='0'";
            } else {
                if ($valid['imagetype'] == 1){
                    $enimage = ", enable_image='1'";
                } else $enimage = ", enable_image='0'";
                if ($valid['audiotype'] == 1){
                    $enaudio = ", enable_audio='1'";
                } else $enaudio = ", enable_audio='0'";
                if ($valid['videotype'] == 1){
                    $envideo = ", enable_video='1'";
                } else $envideo = ", enable_video='0'";
                if ($valid['codetype'] == 1){
                    $encode = ", enable_code='1'";
                } else $encode = ", enable_code='0'";
            }
        }

        if (SEC_hasRights('inmemoriam.admin')){
            // Convert array values to numeric permission values
            list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($valid['perm_owner'],$valid['perm_group'],$valid['perm_members'],$valid['perm_anon']);
            $setperms = ", perm_owner='$perm_owner', perm_group='$perm_group', perm_members='$perm_members', perm_anon='$perm_anon'";
        }

        if ($valid['clearwm'] == 1){
            //clear watermarks from album if not being used otherwise--this does not include subalbums
            $wmres = DB_query("SELECT wid FROM {$INM_TABLES['media']} WHERE aid<>'{$valid['oldaid']}' AND (wid<>'' or wid<>NULL) LIMIT 1");
            if (DB_numRows($wmres) < 1){
                $wmimg = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$A['wid']}'");
                if (!empty($wmimg) && $wmimg != $INM_CONF['default_wm']){
                    $wmpath = $INM_CONF['path_wm'] . $wmimg;
                    if (!file_exists($wmpath) || !@unlink($wmpath)){
                        //log this for now
                        $error .= sprintf($LANG_INM02[74], $wmimg) . '<br />';
                    }
                }
                //disable on applicable media
                DB_query("UPDATE {$INM_TABLES['media']} SET enable_watermark='0', wid='' WHERE aid='{$valid['oldaid']}'");
                //remove wm from database
                DB_delete($INM_TABLES['watermarks'], 'wid', "{$A['wid']}");
            }
        }

        //must run images first -- no longer necessary since media/aid now refers to album/id and not album/aid
        //$images = DB_query("SELECT mid FROM {$INM_TABLES['media']} LIMIT 1");
        //if (DB_numRows($images) >= 1){
        //    $images = "UPDATE {$INM_TABLES['media']} SET aid='{$valid['aid']}' WHERE aid='{$valid['oldaid']}'";
        //    DB_query($images);
        //}

        //check max x&y against db for change.
        //if changed, delete any static images
        $maxres = DB_query("SELECT maxw, maxh FROM {$INM_TABLES['albums']} WHERE id='{$valid['oldaid']}'");
        list ($maxw, $maxh) = DB_fetchArray($maxres);
        if ($maxw != $valid['maxw'] || $maxy != $valid['maxy']){
            inm_deleteStatic($valid['oldaid'],'album');
            if ($valid['applytoall'] == 1){
                $subres = DB_query("SELECT id FROM {$INM_TABLES['albums']} WHERE pid='{$valid['oldaid']}'");
                if (DB_numRows($subres) > 0){
                    while ($S = DB_fetchArray($subres)){
                        inm_deleteStatic($S['id'],'album');
                    }
                }
            }
        }

        //must run subs second
        if ($valid['applytoall'] == 1){
            $subs = "UPDATE {$INM_TABLES['albums']} SET frame='{$valid['frame']}'"
                . ", theme='{$valid['theme']}', maxw='{$valid['maxw']}'"
                . ", maxh='{$valid['maxh']}', orderby='{$valid['order']}', thumbs_perpage='{$valid['perpage']}'"
                . ", dispfullimg='{$valid['origsize']}', limitfullimg='{$valid['limitfull']}'"
                . ", enable_rating='{$valid['rating']}', enable_comments='{$valid['comments']}'"
                . " WHERE pid='{$valid['oldaid']}'";
            DB_query($subs);
        }

        //must run pids third
        $pids = "UPDATE {$INM_TABLES['albums']} SET pid='{$A['id']}' WHERE pid='{$valid['oldaid']}'";
        DB_query($pids);

        //must run update forth
        $update = "UPDATE {$INM_TABLES['albums']} SET"
             . $setaid . " name='{$valid['name']}'"
             . ", description='{$valid['description']}'"
             . ", frame='{$valid['frame']}', theme='{$valid['theme']}'"
             . ", thumbsize='{$valid['thumbsize']}', thumbs_perpage='{$valid['perpage']}'"
             . ", maxw='{$valid['maxw']}', maxh='{$valid['maxh']}'"
             . ", dispfullimg='{$valid['origsize']}', limitfullimg='{$valid['limitfull']}'"
             . ", enable_rating='{$valid['rating']}', enable_comments='{$valid['comments']}'"
             . ", orderby='{$valid['order']}', group_id='{$valid['groupid']}', owner_id='{$valid['ownerid']}'"
             . $setpath . $setpid . $setsubmit . $setqueue . $setthumb . $setfeatured . $maxfile . $enimage . $enaudio . $envideo . $encode . $setperms
             . " WHERE id='{$valid['oldaid']}' LIMIT 1";
        DB_query($update);
    } else {
        //oldaid doesn't exist
        return $LANG_INM04[1];
    }
    //success
    $success = sprintf($LANG_INM04[7], stripslashes($valid['name']));
    if ($A['pid'] == ''){
        $success .= inm_showAlbumSummary($A['id']);
    } else {
        $success .= inm_showSubAlbumSummary($A['id'],true);
    }
    return $success;
}

/* 
* Main Function
*/

$pagetitle = $LANG_INM01[11] . $LANG_INM01[12];
$display = inm_siteHeader($pagetitle);

if (!empty($_GET['id'])){
    $id = $_GET['id'];
    //display album editor
    $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
    $display .= inm_menurow();
    $display .= inm_showintro($LANG_INM02[2]);
    $display .= COM_endBlock();
    $display .= COM_startBlock($LANG_INM02[3]);
    $display .= inm_albumEditor($id);
    $display .= COM_endBlock();
} elseif (!empty($_POST['albums'])){
    //refresh to edit aid
    $aid = $_POST['albums'];
    $display = COM_refresh($INM_CONF['url_html'] . '/media.php?id=' . $id);
    echo $display;
    exit;
} elseif ((isset($_POST['submit'])) && (!empty($_POST['newaid']))){
    $sumbit = $_POST['submit'];
    switch ($submit){
        case $LANG_INM02[31]:
            //create album
            $valid = inm_validateInput('album');
            if (is_array($valid)){
                //display success message and give links to browse or add more
                $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
                $display .= inm_menurow();
                $display .= inm_showintro();
                $display .= inm_createAlbum($valid);
                $display .= COM_endBlock();
            } else {
                //input validation error
                $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
                $display .= inm_menurow();
                $display .= inm_showintro();
                $display .= COM_endBlock();
                $display .= COM_startBlock($LANG_INM04[2]);
                $display .= $valid;
                $display .= COM_endBlock();
            }
            break;
        case $LANG_INM02[34]:
            //cancels operation
            //refresh to index.php
        default:
            //refresh to index.php
            $display = COM_refresh($INM_CONF['url_html'] . '/index.php');
            echo $display;
            exit;
    }
} elseif ((isset($_POST['submit'])) && (!empty($_POST['oldaid']))){
    $submit = $_POST['submit'];
    $valid = inm_validateInput('album');
    switch ($submit){
        case $LANG_INM02[33]:
            //deletes an existing album
            $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
            //display success message and give links to browse or add more
            $display .= inm_menurow();
            $display .= inm_showintro();
            $display .= inm_deleteAlbum($valid['oldaid']);
            $display .= COM_endBlock();
            break;
        case $LANG_INM02[31]:
            //update album
            $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
            //display success message and give links to browse or add more
            $display .= inm_menurow();
            $display .= inm_showintro();
            $display .= inm_updateAlbum($valid);
            $display .= COM_endBlock();
            break;
        case $LANG_INM02[34]:
            //cancels operation
            //refresh to index.php
        default:
            //refresh to index.php
            $display = COM_refresh($INM_CONF['url_html'] . '/index.php');
            echo $display;
            exit;
    }
} else {
    //display album editor
    $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
    $display .= inm_menurow();
    $display .= inm_showintro($LANG_INM02[2]);
    $display .= COM_endBlock();
    $display .= COM_startBlock($LANG_INM02[3]);
    $display .= inm_albumEditor();
    $display .= COM_endBlock();
}

$display .= inm_poweredBy();
$display .= inm_siteFooter();
echo $display;
?>