<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | browse.php                                                                |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alford Deeley aka machinari - ajdeeley@summitpages.ca             |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Retrieve access settings
$anonview = DB_getItem($INM_TABLES['settings'], 'anonview');
// Check user has rights to access this page
if (($anonview == '0') && ($_USER['uid'] < 2)) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access media.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_INM00['access_denied']);
    $display .= $LANG_INM00['access_denied_msg1'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

//displays the google-like page nav
function inm_pagenav($A, $valid)
{
    global $_CONF, $INM_TABLES, $INM_CONF;

    //print page nav here
    if(!isset($valid['page'])){
        $page = '1';
    } else $page = $valid['page'];
    if (!isset($valid['sort'])){
        $sortvar = '&amp;sort=' . $A['orderby'];
    } else $sortvar = "&amp;sort=" . $valid['sort'];
    if(!isset($valid['size'])){
        $sizevar = '&amp;size=' . $A['thumbsize'];
    } else $sizevar = '&amp;size=' . $valid['size'];

    $result = DB_query ("SELECT COUNT(*) AS thumbs FROM {$INM_TABLES['media']} WHERE status='0' AND aid='{$A['id']}'" . COM_getPermSQL('and'));
    list($thumbs) = DB_fetchArray($result);
    $perpage = $A['thumbs_perpage'];
    if ($thumbs > $perpage) {
        $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
        $T->set_file('page', 'pagenav.thtml');
        $prevpage = $page - 1;
        $nextpage = $page + 1;
        $baseurl = $INM_CONF['url_html'] . '/browse.php?id=' . $A['id'] . $sortvar . $sizevar;
        $numpages = ceil ($thumbs / $perpage);
        $T->set_var ('google_paging',
                inm_printPageNavigation ($baseurl, $page, $numpages));
        $T->parse('output','page');
        $retval = $T->finish($T->get_var('output'));
    }
    return $retval;
}

//displays the google-like page nav
function inm_searchnav($numitems, $valid)
{
    global $_CONF, $INM_TABLES, $INM_CONF;

    if(!isset($valid['page'])){
        $page = '1';
    } else $page = $valid['page'];
    if(isset($valid['searchtxt'])){
        $searchvar = '&amp;searchtxt=' . $valid['searchtxt'];
    }

    $perpage = DB_getItem($INM_TABLES['settings'], 'searchdisplim');
    if ($numitems > $perpage) {
        $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
        $T->set_file('page', 'pagenav.thtml');
        $prevpage = $page - 1;
        $nextpage = $page + 1;
        $baseurl = $INM_CONF['url_html'] . '/browse.php?mode=' . $valid['mode'] . $searchvar;
        $numpages = ceil ($numitems / $perpage);
        $T->set_var ('google_paging',
                inm_printPageNavigation ($baseurl, $page, $numpages));
        $T->parse('output','page');
        $retval = $T->finish($T->get_var('output'));
    }
    return $retval;
}

//displays page nav on fullimage pages
function inm_mediaNav($currentmid, $valid){
    global $_CONF, $INM_TABLES, $LANG_INM10, $_GET, $INM_CONF;

    if (!empty($valid['sort'])){
        $linksort = '&amp;sort=' . $valid['sort'];
        switch ($valid['sort']){
            case 1:
                $orderby = ' ORDER BY date DESC, mid DESC';
                break;
            case 2:
                $orderby = ' ORDER BY date ASC, mid ASC';
                break;
            case 3:
                $orderby = ' ORDER BY hits DESC, date DESC, mid DESC';
                break;
            case 4:
                $orderby = ' ORDER BY hits ASC, date DESC, mid DESC';
                break;
            case 5:
                $orderby = ' ORDER BY rate DESC, numvotes DESC, mid DESC';
                break;
            case 6:
                $orderby = ' ORDER BY rate ASC, numvotes DESC, mid DESC';
                break;
            default:
                $orderby = ' ORDER BY date DESC, mid DESC';
        }
    } else {
        $linksort = '&amp;sort=1';//date desc
        $orderby = ' ORDER BY date DESC, mid DESC';
    }
    if (!empty($valid['size'])){
        $linksize = '&amp;size=' . $valid['size'];
    }
    if (!empty($valid['page'])){
        $linkpage = '&amp;page=' . $valid['page'];
    } else $linkpage = '&amp;page=1';

    $rateExpr = ", totalrating/numvotes as rate";
    $album = DB_getItem($INM_TABLES['media'], 'aid', "mid='$currentmid'");
    $result = DB_query("SELECT mid" . $rateExpr . " FROM {$INM_TABLES['media']} WHERE status='0' AND aid='$album'" . COM_getPermSQL('and') . $orderby);
    if (DB_numRows($result) <= 1){
        return '';
    }
    $media = array();
    while ($A = DB_fetchArray($result)){
        $media[] = $A['mid'];
    }

    $pages = count($media);
    $key = array_search($currentmid, $media);
    $first = $media[0];
    $prev = $media[$key - 1];
    $next = $media[$key + 1];
    $last = $media[$pages - 1];
    //return $last;

    $theme = DB_getItem($INM_TABLES['albums'], 'theme', "id='$album'");
    if (empty($theme)){
        $theme = $INM_CONF['themes'][0];
    } else {
        $theme = $INM_CONF['themes'][$theme];
    }

    if ($key > 0){
        $firstlink = '<a href="' . $INM_CONF['url_html'] . '/browse.php?mid=' . $first . $linksize . $linksort . '"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-first.gif" alt="' . $LANG_INM10[36] . '" /></a>';
        $prevlink = '<a href="' . $INM_CONF['url_html'] . '/browse.php?mid=' . $prev . $linksize . $linksort . '"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-prev.gif" alt="' . $LANG_INM10[37] . '" /></a>';
    } else {
        //$firstlink = $LANG_INM10[36];
        //$prevlink = $LANG_INM10[37];
        $firstlink = '';
        $prevlink = '';
    }
    if ($key < $pages - 1){
        $nextlink = '<a href="' . $INM_CONF['url_html'] . '/browse.php?mid=' . $next . $linksize . $linksort . '"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-next.gif" alt="' . $LANG_INM10[38] . '" /></a>';
        $lastlink = '<a href="' . $INM_CONF['url_html'] . '/browse.php?mid=' . $last . $linksize . $linksort . '"><img src="' . $INM_CONF['url_html'] . '/'. $theme . '/' . $theme . '-last.gif" alt="' . $LANG_INM10[39] . '" /></a>';
    } else {
        //$nextlink = $LANG_INM10[38];
        //$lastlink = $LANG_INM10[39];
        $nextlink = '';
        $lastlink = '';
    }
    $albumlink = '<a href="' . $INM_CONF['url_html'] . '/browse.php?id=' . $album . $linksize . $linksort . $linkpage . '">' . $LANG_INM10[35] . '</a>';

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file('page', 'medianav.thtml');
    $T->set_var('url_html', $INM_CONF['url_html']);
    $T->set_var('langslide', $LANG_INM10[62]);
    $T->set_var('mid', $currentmid);
    $T->set_var('firstlink', $firstlink);
    $T->set_var('prevlink', $prevlink);
    $T->set_var('albumview', $albumlink);
    $T->set_var('nextlink', $nextlink);
    $T->set_var('lastlink', $lastlink);

    $T->parse('output','page');
    return $T->finish($T->get_var('output'));
}

//loops thru all media in specified album
//returns all accessible thumbs
function inm_albumThumbs($A){
    global $INM_TABLES, $INM_CONF, $LANG_INM10, $_CONF, $_TABLES;

    $valid = inm_validateInput('get');
    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array('page' => 'browse.thtml', 'thumbs' => 'thumbs.thtml', 'comcount' => 'comment-count.thtml', 'editli' => 'edit-link.thtml'));
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('url_html', $INM_CONF['url_html']);
    $T->set_var('pagenav', inm_pagenav($A, $valid));
    if (!empty($A['theme'])){
        $T->set_var('class', 'inm-' . $INM_CONF['themes'][$A['theme']]);
    } else $T->set_var('class', 'inm-' . $INM_CONF['themes'][0]);

    $T->set_var('aid', $A['id']);
    $T->set_var('small', $LANG_INM10[6]);
    $T->set_var('medium', $LANG_INM10[7]);
    $T->set_var('large', $LANG_INM10[8]);
    $T->set_var('langsize', $LANG_INM10[9]);
    $T->set_var('langsort', $LANG_INM10[10]);
    $T->set_var('datedesc', $LANG_INM10[11]);
    $T->set_var('dateasc', $LANG_INM10[12]);
    $T->set_var('hitsdesc', $LANG_INM10[13]);
    $T->set_var('hitsasc', $LANG_INM10[14]);
    if ($A['enable_rating'] == 1){
        $T->set_var('ratedesc', '<option value="5"{order5}>' . $LANG_INM10[15] . '</option>');
        $T->set_var('rateasc', '<option value="6"{order6}>' . $LANG_INM10[16] . '</option>');
    }

    if(!empty($valid['sort'])){
        $T->set_var('order' . $valid['sort'], ' selected="selected"');
        $T->set_var('sortinput', '<input type="hidden" name="sort" value="' . $valid['sort'] . '" />');
        if ($valid['sort'] == 1){
            $orderby = ' ORDER BY date DESC, mid DESC';
        } elseif ($valid['sort'] == 2){
            $orderby = ' ORDER BY date ASC, mid ASC';
        } elseif ($valid['sort'] == 3){
            $orderby = ' ORDER BY hits DESC, date DESC, mid DESC';
        } elseif ($valid['sort'] == 4){
            $orderby = ' ORDER BY hits ASC, date DESC, mid DESC';
        } elseif ($valid['sort'] == 5){
            $rateExpr = ', totalrating/numvotes as rate';
            $orderby = ' ORDER BY rate DESC, numvotes DESC, mid DESC';
        } elseif ($valid['sort'] == 6){
            $rateExpr = ', totalrating/numvotes as rate';
            $orderby = ' ORDER BY rate ASC, numvotes DESC, mid DESC';
        }
        //for fullimage source in order that the user can come back to the same page
        $T->set_var('linksort', '&amp;sort=' . $valid['sort']);
    } else {
        $T->set_var('order' . $A['orderby'], ' selected="selected"');
        if ($A['orderby'] ==1){
            $orderby = ' ORDER BY date DESC, mid DESC';
        } elseif ($A['orderby'] == 2){
            $orderby = ' ORDER BY date ASC, mid ASC';
        } elseif ($A['orderby'] == 3){
            $orderby = ' ORDER BY hits DESC, date DESC, mid DESC';
        } elseif ($A['orderby'] == 4){
            $orderby = ' ORDER BY hits ASC, date DESC, mid DESC';
        } elseif ($A['orderby'] == 5){
            $orderby = ' ORDER BY rate DESC, numvotes DESC, mid DESC';
        } elseif ($A['orderby'] == 6){
            $orderby = ' ORDER BY rate ASC, numvotes DESC, mid DESC';
        }
    }
    if (!empty($valid['size'])){
        $T->set_var('size' . $valid['size'], ' selected="selected"');
        $T->set_var('sizeinput', '<input type="hidden" name="size" value="' . $valid['size'] . '" />');
        //for fullimage source in order that the user can come back to the same page
        //i should really use cookies for this -- on the todo list
        $T->set_var('linksize', '&amp;size=' . $valid['size']);
    } else {
        $T->set_var('size' . $A['thumbsize'], ' selected="selected"');
    }


    if(!isset($valid['page'])){
        $page = '1';
    } else {
        $page = $valid['page'];
        $T->set_var('pageinput', '<input type="hidden" name="page" value="' . $valid['page'] . '" />');
        //for fullimage source in order that the user can come back to the same page
        $T->set_var('linkpage', '&amp;page=' . $valid['page']);
    }
    $perpage = $A['thumbs_perpage'];
    $limit = ($perpage * $page) - $perpage;
    $offset = " LIMIT $limit, $perpage";

    $result = DB_query("SELECT *" . $rateExpr . " FROM {$INM_TABLES['media']} WHERE aid='{$A['id']}' AND status='0'" . COM_getPermSQL('and') . $orderby . $offset);
    if (DB_numRows($result) >= 1){
        if (!isset($valid['page']) && !isset($valid['sort']) && !isset($valid['size']) && !isset($valid['mid'])){
            //update album hit counter
            DB_query("UPDATE {$INM_TABLES['albums']} SET hits=hits+1 WHERE id='{$valid['id']}'");
        }

        if (!empty($valid['size'])){
            $height = $INM_CONF['thd_height'][$valid['size']];
            $width = $INM_CONF['thd_width'][$valid['size']];
        } else {
            $height = $INM_CONF['thd_height'][$A['thumbsize']];
            $width = $INM_CONF['thd_width'][$A['thumbsize']];
        }
        $T->set_var('style', ' style="height: ' . $height . 'px; width: ' . $width . 'px;"');

        if (!empty($valid['size'])){
            $size = $valid['size'];
        } else $size = $A['thumbsize'];

        //begin loop
        while ($TH = DB_fetchArray($result)){
            //display thumbnail and related info
            //the check for a static thumb occurs on image.php
            $extension = strtolower(strrchr($TH['filename'],"."));
            if (array_key_exists($extension, $INM_CONF['image_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?mid=' . $TH['mid'] . '&amp;thumb=1&amp;size=' . $size;
                $dimensions = inm_reportImageSize($A['path'],$TH['filename']);
                list($x,$y) = $dimensions;
                $T->set_var('dimensions', $x . 'x' . $y);
            } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?aud=1&amp;thumb=1&amp;size=' . $size;
                $T->set_var('dimensions', $LANG_INM10[75]);
            } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?vid=1&amp;thumb=1&amp;size=' . $size;
                $T->set_var('dimensions', $LANG_INM10[76]);
            } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?cod=1&amp;thumb=1&amp;size=' . $size;
                $T->set_var('dimensions', substr($extension,1) . ' ' . $LANG_INM10[77]);
            }

            $T->set_var('src', $thumb);
            $T->set_var('mid', $TH['mid']);
            if (!empty($TH['title'])){
                if (strlen($TH['title']) > 24){
                    $title = substr(COM_stripslashes($TH['title']), 0, 22) . '...';
                } else $title = COM_stripslashes($TH['title']);
            } else $title = COM_stripslashes($TH['filename']);
            $T->set_var('title', $title);
            $T->set_var('alt', $title);
            $T->set_var('uid', $TH['owner_id']);
            $T->set_var('caption', COM_stripslashes($TH['caption']));
            $T->set_var('langauthor', $LANG_INM10[4]);
            $T->set_var('photographer', inm_prflink($TH['owner_id']));
            $T->set_var('langhits', $LANG_INM10[19]);
            $T->set_var('hits', $TH['hits']);
            if ($A['enable_comments'] == 1){
                $T->set_var('langcomments', $LANG_INM10[64]);
                if ($TH['comments'] < 1){
                    $TH['comments'] = '0';
                }
                $T->set_var('commentcount', $TH['comments']);
                $T->parse('comments', 'comcount');
            }
            $access = inm_hasMediaAccess($TH['mid']);
            if ($access == 3) {
                $T->set_var('editlink', '<a href="' . $INM_CONF['url_html'] . '/media.php?mid=' . $TH['mid'] . '">' . $LANG_INM10[5] . '</a>');
                $T->parse('editlink', 'editli');
            }
            $T->parse('thumbnails', 'thumbs', true);
        }


        $T->parse('output','page');
        return $T->finish($T->get_var('output'));
    } else {
        //check if subalbums exist
        if(DB_numRows(DB_query("SELECT id FROM {$INM_TABLES['albums']} WHERE pid='{$A['id']}' AND status='0'" . COM_getPermSQL('and'))) < 1){
            //return no accessible media
            return $LANG_INM10[3];
        } else {
            //display subs
        }
    }
    //update album views
    if (!isset($valid['page']) && !isset($valid['sort']) && !isset($valid['size']) && !isset($valid['mid'])){
        //update album hit counter
        DB_query("UPDATE {$INM_TABLES['albums']} SET hits=hits+1 WHERE id='{$valid['id']}'");
    }

    return $retval;
}

//saves a rating for an image
function inm_saveRate(){
    global $INM_TABLES, $_CONF, $INM_CONF, $_POST;

    $valid = inm_validatePost();
    if (!empty($valid['rate'])){
        // Check for people breaking the speed limit
        COM_clearSpeedlimit ($INM_CONF['ratingspeedlimit'], 'inmemoriam');
        $last = COM_checkSpeedlimit ('inmemoriam');
        if ($last > 0) {
            //do nothing cuz speed has been exceeded
        } else {
            COM_updateSpeedlimit ('inmemoriam');
            $result = DB_query("SELECT totalrating, numvotes FROM {$INM_TABLES['media']} WHERE mid='{$valid['mid']}'");
            list($total, $numvotes) = DB_fetchArray($result);
            $total = $total + $valid['rate'];
            $numvotes++;
            DB_query("UPDATE {$INM_TABLES['media']} SET totalrating='$total', numvotes='$numvotes' WHERE mid='{$valid['mid']}'");
        }
        if (!empty($valid['sort'])){
            $linksort = '&amp;sort=' . $valid['sort'];
        }
        if (!empty($valid['size'])){
            $linksize = '&amp;size=' . $valid['size'];
        }
        if (!empty($valid['page'])){
            $linkpage = '&amp;page=' . $valid['page'];
        } else $linkpage = '&amp;page=1';
        $get = $linksort . $linksize . $linkpage;
    }
    return COM_refresh($INM_CONF['url_html'] . '/browse.php?mid='. $valid['mid'] . $get);
}

//rates an image
//returns a formatted bar for rating media or seconds since last rate
function inm_rateImage($mid, $vote = ''){
    global $INM_TABLES, $LANG_INM10, $_CONF, $_GET, $INM_CONF, $_USER;

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array('ratebar' => 'rate-bar.thtml', 'form' => 'rate-form.thtml'));
    $result = DB_query("SELECT totalrating, numvotes, owner_id FROM {$INM_TABLES['media']} WHERE mid='$mid'");
    list($total, $numvotes, $owner_id) = DB_fetchArray($result);

    // Check for people breaking the speed limit
    COM_clearSpeedlimit ($INM_CONF['ratingspeedlimit'], 'inmemoriam');
    $last = COM_checkSpeedlimit ('inmemoriam');
    if ($last > 0) {
        //$speeding = sprintf($LANG_INM10[51], $last, $INM_CONF['ratingspeedlimit']);
        $speeding = sprintf($LANG_INM10[51], $INM_CONF['ratingspeedlimit']);
        $T->set_var('speeding', $speeding);
    }
    if (!empty($total) && !empty($numvotes)){
        $rating = $total / $numvotes;
        $rating = number_format($rating, 1);
    } else $rating = '0';

    if($_USER['uid'] != $owner_id){
        $T->set_var('rateaction', $INM_CONF['url_html'] . '/browse.php');
        $T->set_var('langnewrate', $LANG_INM10[30]);
        $valid = inm_validateInput('get');
        if (isset($valid['sort'])){
            $T->set_var('sortinput', '<input type="hidden" name="sort" value="' . $valid['sort'] . '" />');
        }
        if (isset($valid['size'])){
            $T->set_var('sizeinput', '<input type="hidden" name="size" value="' . $valid['size'] . '" />');
        }
        if (isset($valid['page'])){
            $T->set_var('pageinput', '<input type="hidden" name="page" value="' . $valid['page'] . '" />');
        }
        $T->set_var('mid', $mid);
        $T->set_var('please', $LANG_INM10[33]);

        $T->parse('rateform', 'form');
    }
    $T->set_var('langoldrate', $LANG_INM10[31]);
    $T->set_var('langnumvotes', $LANG_INM10[32]);
    if (empty($numvotes)){
        $numvotes = '0';
    }
    $T->set_var('numvotes', $numvotes);
    if (empty($total)){
        $rating = 'N/A';
    } else $rating = $rating . '/10';
    $T->set_var('rate', $rating);

    $T->parse('output','ratebar');
    $display = $T->finish($T->get_var('output'));
    return $display;
}

//returns exif data
function inm_showIPTC($mid){
    global $INM_TABLES, $INM_CONF, $LANG_INM10, $_CONF;
    $result = DB_query("SELECT aid, filename FROM {$INM_TABLES['media']} WHERE mid='$mid' AND status='0'");
    list($aid, $filename) = DB_fetchArray($result);
    //check access to media
    $path = DB_getItem($INM_TABLES['albums'], 'path', "id='$aid'");
    $access = inm_hasMediaAccess($mid);

    if ($access >= 2){
        $path = $path . $filename;
        $exif = exif_read_data($path, 'IFD0');
        if ($exif===false){
            return 'No header data found.';
        } else {
            $retval = '';
            $exif = exif_read_data($path, 0, true);
            $retval .= '<b>Make</b>: ' . $exif['IFD0']['Make'] . '<br />';
            $retval .= '<b>Model</b>: ' . $exif['IFD0']['Model'] . '<br />';
            $retval .= '<b>DateTime</b>: ' . $exif['IFD0']['DateTime'] . '<br /><br />';
            //$retval .= '<b>Copyright</b>: ' . $exif['IFD0']['Copyright'] . '<br /><br />';
            $retval .= '<div align="center"><img src="'. $INM_CONF['url_html'] . '/image.php?thumb=1&amp;mid=' . $mid . '" alt="" />';

/*
            foreach ($exif as $key => $section) {
                if ($key == 'IFD0'){
                    foreach ($section as $name => $val) {
                        $retval .= $name . ': ' . $val . '<br />' . LB;
                    }
                }
            }
*/

            return $retval;
        }
/*
        $result = read_exif_data_raw($path);
        if (empty($result['ValidEXIFData'])){
            $output .= 'No embedded information found.';
        } else {
            $IDF0 = array('Make', 'Model', 'Orientation',
                'xResolution', 'yResolution', 'ResolutionUnit',
                'Software', 'DateTime', 'YCbCrPositioning');
            $SubIDF = array('ExposureTime', 'FNumber', 'ExifVersion', 
                'DateTimeOriginal', 'DateTimedigitized', 'ComponentsConfiguration', 
                'ComponentsConfiguration', 'CompressedBitsPerPixel', 
                'ShutterSpeedValue', 'ApertureValue', 'MeteringMode', 'Flash', 
                'FocalLength', 'UserComment', 'ColorSpace', 'ExifImageWidth', 
                'ExifImageHeight', 'SensingMethod', 'FileSource');
            foreach ($result['IFD0'] as $key => $value){
                if (in_array($key, $IDF0) && trim($value) != '') {
                    $output .= "<b>$key</b>:&nbsp;$value&nbsp;|&nbsp;" . LB;
                }
            }

            foreach ($result['SubIFD'] as $key => $value) {
                if (in_array($key, $SubIDF) && trim($value) != '') {
                    $output .= "<b>$key</b>:&nbsp;$value&nbsp;|&nbsp;" . LB;
                }
            }
        }
        return $output;
*/
    } else {
        return 'no access';
    }

}

//display scaled image
function inm_showImage($A, $valid){
    global $INM_TABLES, $INM_CONF, $_CONF, $LANG_INM10, $_USER;

    //check access to media
    $access = inm_hasMediaAccess($A['mid']);

    if ($access >= 2){
        //update hit counter
        //if (!isset($valid['page']) && !isset($valid['sort']) && !isset($valid['size']) && !isset($valid['id'])){
            //update media hit counter
            DB_query("UPDATE {$INM_TABLES['media']} SET hits=hits+1 WHERE mid='{$valid['mid']}'");
        //}

        $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
        $T->set_file(array('page' => 'scaled-view.thtml', 'vid' => 'scaled-vid.thtml', 'aud' => 'scaled-aud.thtml', 'cod' => 'scaled-cod.thtml', 'rate' => 'rate-bar.thtml', 'nav' => 'pagenav.thtml', 'favform' => 'fav-form.thtml'));
        $T->set_var('site_url', $_CONF['site_url']);
        $T->set_var('url_html', $INM_CONF['url_html']);
        $T->set_var('langauthor', $LANG_INM10[4]);
        $T->set_var('langadded', $LANG_INM10[24]);
        $T->set_var('langviews', $LANG_INM10[25]);
        $navbar = inm_mediaNav($A['mid'], $valid);
        $T->set_var('medianav', $navbar);

        $result = DB_query("SELECT path, theme, dispfullimg, limitfullimg, enable_rating, enable_comments FROM {$INM_TABLES['albums']} WHERE id='{$A['aid']}'");
        list($path, $theme, $dispfullimg, $limitfullimg, $enable_rating, $enable_comments) = DB_fetchArray($result);

        if (!empty($theme)){
            $T->set_var('class', 'inm-' . $INM_CONF['themes'][$theme]);
        } else $T->set_var('class', 'inm-' . $INM_CONF['themes'][0]);
        if (!empty($valid['sort'])){
            $linksort = '&amp;sort=' . $valid['sort'];
            $T->set_var('sortinput', '<input type="hidden" name="sort" value="' . $valid['sort'] . '" />');
        }
        if (!empty($valid['size'])){
            $linksize = '&amp;size=' . $valid['size'];
            $T->set_var('sizeinput', '<input type="hidden" name="size" value="' . $valid['size'] . '" />');
        }
        if (!empty($valid['page'])){
            $linkpage = '&amp;page=' . $valid['page'];
            $T->set_var('pageinput', '<input type="hidden" name="page" value="' . $valid['page'] . '" />');
        } else $linkpage = '&amp;page=1';
        $T->set_var('get', $linksort . $linksize . $linkpage);

        $T->set_var('mid', $A['mid']);
        $T->set_var('aid', $A['aid']);
        if (!empty($A['wid'])){
            $wid = '&amp;wid=' . $A['wid'];
        }

        $extension = strtolower(strrchr($A['filename'],"."));
        if (array_key_exists($extension, $INM_CONF['image_ext'])){
            $src = $INM_CONF['url_html'] . '/image.php?mid=' . $A['mid'] . $wid;

            //display link to exif if enabled
            if ($A['enable_exif'] == 1){
                $T->set_var('exiflink', "<li><a href=\"" . $INM_CONF['url_html'] . "/browse.php?exif=1&amp;mid=" . $A['mid'] . "\" onclick=\"window.open('" . $INM_CONF['url_html'] . "/browse.php?exif=1&amp;mid=" . $A['mid'] . "','popup','width=260,height=300,scrollbars=yes,resizable=yes,toolbar=no,directories=no,location=no,menubar=no,status=no,left=0,top=0'); return false\">" . $LANG_INM10[28] . "</a></li>" . LB);
            }

            //display link to full image if enabled
            if (($dispfullimg == 1 && ($limitfullimg == 1 || ($limitfullimg == 2 && $_USER['uid'] >= 2) || ($limitfullimg == 3 && SEC_hasRights('inmemoriam.fullview')))) || SEC_hasRights('inmemoriam.admin') || $_USER['uid'] == $A['owner_id']) {
                $T->set_var('fullimagelink', '<li><a href="' . $INM_CONF['url_html'] . '/browse.php?full=1&amp;mid=' . $A['mid'] . $wid . '" target="_blank">' . $LANG_INM10[34] . '</a></li>' . LB);
                $full = $INM_CONF['url_html'] . '/browse.php?full=1&amp;mid=' . $A['mid'] . $wid . '" title= "' . $LANG_INM10[68] . '" " target="_blank';
            } else{
                $full = '';
            }
            $clicktoview = $LANG_INM10[68];

        } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
            $src = $INM_CONF['url_html'] . '/image.php?aud=1';
            $full = $src . '&amp;mid=' . $A['mid'];
            $clicktoview = $LANG_INM10[67];
            $T->set_var('langplay', $LANG_INM10[70]);
            $T->set_var('bytesize', inm_readbytes(filesize($path . $A['filename'])));
            $T->set_var('langbytesize', $LANG_INM10[42]);
        } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
            $src = $INM_CONF['url_html'] . '/image.php?vid=1';
            $full = $src .'&amp;mid=' . $A['mid'];
            $clicktoview = $LANG_INM10[67];
            $T->set_var('langplay', $LANG_INM10[70]);
            $T->set_var('bytesize', inm_readbytes(filesize($path . $A['filename'])));
            $T->set_var('langbytesize', $LANG_INM10[42]);
        } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
            $src = $INM_CONF['url_html'] . '/image.php?cod=1';
            $full = $src . '&amp;mid=' . $A['mid'];
            $clicktoview = $LANG_INM10[69];
            $T->set_var('langplay', $LANG_INM10[71]);
            $T->set_var('langdoc', $LANG_INM10[72]);
            $T->set_var('langtype', $LANG_INM10[73]);
            $T->set_var('doctype', substr($extension,1));
        }

        $T->set_var('goback', $LANG_INM10[66]);
        $T->set_var('clicktoview', $clicktoview);
        $T->set_var('full', $full);
        $T->set_var('src', $src);
        if ($dispfullimg == '1'){
            //$T->set_var('attributes', ' ' . inm_imageSizeAttr($path, $A['filename']));
        } else {
            //get resized image dimensions
            //
        }

        //display add to fav form
        if ($_USER['uid'] >= 2){
            $T->set_var('favaction', $INM_CONF['url_html'] . '/browse.php');
            $favlink = '<a href="' . $INM_CONF['url_html'] . '/browse.php?fav=' . $_USER['uid'] . '">' . $LANG_INM10[54] . '</a>';

            $result = DB_query("SELECT uid FROM {$INM_TABLES['favorites']} WHERE uid='{$_USER['uid']}' AND mid='{$A['mid']}'");
            if (DB_numRows($result) >= 1){
                //delete from
                $T->set_var('langfav', sprintf($LANG_INM10[53], $favlink));
                $T->set_var('alter', 'delete');
            } else {
                //add to
                $T->set_var('langfav', sprintf($LANG_INM10[52], $favlink));
                $T->set_var('alter', 'add');
            }
            $T->parse('favoritesform', 'favform');
        }

        if (!empty($A['title'])){
            $title = COM_stripslashes($A['title']);
        } else $title = COM_stripslashes($A['filename']);

        $T->set_var('alt', $title);
        $T->set_var('title', $title);
        $T->set_var('photographer', inm_prflink($A['owner_id']));
        $gldate = inm_getUserDateTimeFormat($A['date']);
        $T->set_var('dateadd', $gldate[0]);
        $T->set_var('hits', $A['hits'] + 1);
        $A['caption'] = PLG_replaceTags(COM_stripslashes($A['caption']));
        $T->set_var('caption', $A['caption']);

        //display rating bar if enabled
        if ($enable_rating == 1){
            if(!empty($valid['rate'])){
                $rate = $valid['rate'];
            } else $rate = '';
            $T->set_var('ratebar', inm_rateImage($A['mid'],$rate));
        }

        //edit link for those who have access
        if ($access == 3) {
            $T->set_var('editlink', '<li><a href="' . $INM_CONF['url_html'] . '/media.php?mid=' . $A['mid'] . '">' . $LANG_INM10[5] . '</a></li>');
        }

        //display comment bar and comments if enabled
        if ($enable_comments == 1){
            require_once ( $_CONF['path_system'] . 'lib-comment.php' );
            if ($access == 3 || SEC_hasRights('inmemoriam.admin')){
                $delete_option = true;
            } else $delete_option = false;
            $cid = $A['mid'];
            $commentbar = CMT_userComments ($cid,$title,'inmemoriam',$valid['order'],$valid['mode'],0,$page,false,$delete_option);
            $T->set_var('commentbar', $commentbar . '<br />');
        } else $T->set_var('commentbar', '');

        if (array_key_exists($extension, $INM_CONF['image_ext'])){
            $T->parse('output', 'page');
        } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
            $T->parse('output', 'aud');
        } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
            $T->parse('output', 'vid');
        } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
            $T->parse('output', 'cod');
        }

        return $T->finish($T->get_var('output'));
    }
    //return no access

}

//saves an entry to the user's fav album
function inm_saveFave(){
    global $INM_TABLES, $_CONF, $_USER, $INM_CONF;
    $valid = inm_validatePost();
    if(!empty($valid['fav']) && !empty($valid['mid'])){
        if ($valid['alter'] == 'add'){
            DB_query("INSERT INTO {$INM_TABLES['favorites']} SET uid='{$_USER['uid']}', mid='{$valid['mid']}', date=NOW()");
        } elseif ($valid['alter'] == 'delete'){
            DB_query("DELETE FROM {$INM_TABLES['favorites']} WHERE uid='{$_USER['uid']}' AND mid='{$valid['mid']}' LIMIT 1");
        }
        if (!empty($valid['sort'])){
            $linksort = '&amp;sort=' . $valid['sort'];
        }
        if (!empty($valid['size'])){
            $linksize = '&amp;size=' . $valid['size'];
        }
        if (!empty($valid['page'])){
            $linkpage = '&amp;page=' . $valid['page'];
        } else $linkpage = '&amp;page=1';
        $get = $linksort . $linksize . $linkpage;
        
        if ($valid['fav'] >= 2){
            return COM_refresh($INM_CONF['url_html'] . '/browse.php?fav='. $valid['fav']);
        } else {
            return COM_refresh($INM_CONF['url_html'] . '/browse.php?mid='. $valid['mid'] . $get);
        }
    }
}

//displays favorite thumbs
//takes an array of thumb ids
function inm_favThumbs($mids){
    global $INM_TABLES, $_CONF, $INM_CONF, $GET, $LANG_INM10, $_USER;

    if (!is_array($mids)) {
        return;
    }
    $valid = inm_validateInput('get');
    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array('page' => 'fav-browse.thtml', 'thumbs' => 'thumbs.thtml', 'comcount' => 'comment-count.thtml', 'editli' => 'edit-link.thtml', 'remove' => 'remove.thtml'));
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('url_html', $INM_CONF['url_html']);
    $T->set_var('class', 'inm-' . $INM_CONF['themes'][0]);
    if (!empty($valid['size'])){
        $height = $INM_CONF['thd_height'][$valid['size']];
        $width = $INM_CONF['thd_width'][$valid['size']];
    } else {
        $height = $INM_CONF['thd_height'][2];
        $width = $INM_CONF['thd_width'][2];
    }
    $T->set_var('style', ' style="height: ' . $height . 'px; width: ' . $width . 'px;"');
    if (!empty($valid['size'])){
        $size = $valid['size'];
    } else $size = '2';

    $i = 0;
    foreach ($mids as $value){
        //check access first
        $access = inm_hasMediaAccess($value);
        if ($access < 2){
            //remove old items that user no longer has access to
            DB_query("DELETE FROM {$INM_TABLES['favorites']} WHERE uid='{$_USER['uid']}' AND mid='$value' LIMIT 1");
        } else {
            //get mid info
            $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE mid='$value'");
            $A = DB_fetchArray($result);

            $result = DB_query("SELECT path, enable_comments FROM {$INM_TABLES['albums']} WHERE id='{$A['aid']}'");
            list($path, $enable_comments) = DB_fetchArray($result);

            //show thumb and related info
            //the check for a static thumb occurs on image.php
            $extension = strtolower(strrchr($A['filename'],"."));
            if (array_key_exists($extension, $INM_CONF['image_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?mid=' . $A['mid'] . '&amp;thumb=1&amp;size=' . $size;
                $dimensions = inm_reportImageSize($path,$A['filename']);
                list($x,$y) = $dimensions;
                $T->set_var('dimensions', $x . 'x' . $y);
            } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?aud=1&amp;thumb=1&amp;size=' . $size;
                $T->set_var('dimensions', 'audio');
            } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?vid=1&amp;thumb=1&amp;size=' . $size;
                $T->set_var('dimensions', 'video');
            } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?cod=1&amp;thumb=1&amp;size=' . $size;
                $T->set_var('dimensions', 'text');
            }

            $T->set_var('src', $thumb);
            $T->set_var('mid', $A['mid']);
            if (!empty($A['title'])){
                if (strlen($A['title']) > 24){
                    $title = substr(COM_stripslashes($A['title']), 0, 22) . '...';
                } else $title = COM_stripslashes($A['title']);
            } else $title = COM_stripslashes($A['filename']);
            $T->set_var('title', $title);
            $T->set_var('alt', $title);
            $T->set_var('uid', $A['owner_id']);
            $T->set_var('langauthor', $LANG_INM10[4]);
            $T->set_var('photographer', inm_prflink($A['owner_id']));
            $T->clear_var('comments');
            if ($enable_comments == 1){
                $T->set_var('langcomments', $LANG_INM10[64]);
                if ($A['comments'] < 1){
                    $A['comments'] = '0';
                }
                $T->set_var('commentcount', $A['comments']);
                $T->parse('comments', 'comcount');
            }
            $T->set_var('langhits', $LANG_INM10[19]);
            $T->set_var('hits', $A['hits']);
            $T->set_var('langremove', $LANG_INM10[58]);
            $T->set_var('fav', $_USER['uid']);
            $T->set_var('favaction', $INM_CONF['url_html'] . '/browse.php');
            $T->set_var('mid', $A['mid']);
            $T->parse('removeform', 'remove');
            if ($access == 3){
                $T->set_var('editlink', '<a href="' . $INM_CONF['url_html'] . '/media.php?mid=' . $a['mid'] . '">' . $LANG_INM10[5] . '</a>');
            $T->parse('editlink', 'editli');
            }

            $T->parse('thumbnails', 'thumbs', true);
            $i++;
        }
    }
    if ($i < 1){
        //no longer have access to media. media has been removed from your favorites
        return $LANG_INM10[57];
    } else {
        $T->parse('output','page');
        return $T->finish($T->get_var('output'));
    }
}

//displays popular thumbs
//takes an array of thumb ids
function inm_popThumbs($mids){
    global $INM_TABLES, $_CONF, $INM_CONF, $GET, $LANG_INM10, $_USER;

    if (!is_array($mids)) {
        return;
    }
    $valid = inm_validateInput('get');
    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array('page' => 'fav-browse.thtml', 'thumbs' => 'thumbs.thtml', 'comcount' => 'comment-count.thtml', 'editli' => 'edit-link.thtml'));
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('url_html', $INM_CONF['url_html']);
    $T->set_var('class', 'inm-' . $INM_CONF['themes'][0]);
    if (!empty($valid['size'])){
        $height = $INM_CONF['thd_height'][$valid['size']];
        $width = $INM_CONF['thd_width'][$valid['size']];
    } else {
        $height = $INM_CONF['thd_height'][2];
        $width = $INM_CONF['thd_width'][2];
    }
    $T->set_var('style', ' style="height: ' . $height . 'px; width: ' . $width . 'px;"');
    if (!empty($valid['size'])){
        $size = $valid['size'];
    } else $size = '2';

    $i = 0;
    foreach ($mids as $value){
        //check access first
        $access = inm_hasMediaAccess($value);
        if ($access >= 2){
            //get mid info
            $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE mid='$value'");
            $A = DB_fetchArray($result);
            $result = DB_query("SELECT path, enable_comments FROM {$INM_TABLES['albums']} WHERE id='{$A['aid']}'");
            list($path, $enable_comments) = DB_fetchArray($result);

            //show thumb and related info
            //the check for a static thumb occurs on image.php
            $extension = strtolower(strrchr($A['filename'],"."));
            if (array_key_exists($extension, $INM_CONF['image_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?mid=' . $A['mid'] . '&amp;thumb=1&amp;size=' . $size;
                $dimensions = inm_reportImageSize($path,$A['filename']);
                list($x,$y) = $dimensions;
                $T->set_var('dimensions', $x . 'x' . $y);
            } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?aud=1&amp;thumb=1&amp;size=' . $size;
                $T->set_var('dimensions', 'audio');
            } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?vid=1&amp;thumb=1&amp;size=' . $size;
                $T->set_var('dimensions', 'video');
            } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
                $thumb = $INM_CONF['url_html'] . '/image.php?cod=1&amp;thumb=1&amp;size=' . $size;
                $T->set_var('dimensions', 'text');
            }

            $T->set_var('src', $thumb);
            $T->set_var('mid', $A['mid']);
            if (!empty($A['title'])){
                if (strlen($A['title']) > 24){
                    $title = substr(COM_stripslashes($A['title']), 0, 22) . '...';
                } else $title = COM_stripslashes($A['title']);
            } else $title = COM_stripslashes($A['filename']);
            $T->set_var('title', $title);
            $T->set_var('alt', $title);
            $T->set_var('uid', $A['owner_id']);
            $T->set_var('langhits', '<b>' . $LANG_INM10[19]);
            $T->set_var('hits', $A['hits'] . '</b>');
            $T->set_var('langauthor', $LANG_INM10[4]);
            $T->set_var('photographer', inm_prflink($A['owner_id']));
            $T->clear_var('comments');
            if ($enable_comments == 1){
                $T->set_var('langcomments', $LANG_INM10[64]);
                if ($A['comments'] < 1){
                    $A['comments'] = '0';
                }
                $T->set_var('commentcount', $A['comments']);
                $T->parse('comments', 'comcount');
            } 
            if ($access == 3){
                $T->set_var('editlink', '<a href="' . $INM_CONF['url_html'] . '/media.php?mid=' . $a['mid'] . '">' . $LANG_INM10[5] . '</a>');
                $T->parse('editlink', 'editli');
            }

            $T->parse('thumbnails', 'thumbs', true);
            $i++;
            if ($i >= 10) {
                break;
            }
        }
    }
    if ($i < 1){
        //no accessible media
        return $LANG_INM10[41];
    } else {
        $T->parse('output','page');
        return $T->finish($T->get_var('output'));
    }
}

//searches allowable media for keywords
function inm_searchMedia($valid){
    global $INM_TABLES, $LANG_INM10, $_CONF, $INM_CONF, $_TABLES;

    //get keywords
    $keywords = explode(" ", $valid['searchtxt']);
    $numwords = count($keywords);

    $i = 0;
    //build query
    $query = "SELECT DISTINCT * FROM {$INM_TABLES['media']} m, {$_TABLES['users']} u WHERE m.status='0' AND";
    foreach ($keywords as $value){
        $value = eregi_replace(',', '', $value);
        $value = trim($value);
        if (empty($value)){
            continue;
        }
        if ($i > 0) $or = ' OR';
        $where .=  $or . ' (m.keywords LIKE "%'.$value.'%" OR m.title LIKE "%'.$value.'%" OR m.caption LIKE "%'.$value.'%" OR u.username LIKE "%'.$value.'%")';
        $i++;
    }

    $where = trim($where);
    if (empty($where)){
        //bad query
        return $LANG_INM10[21];
    }

    $orderby = ' ORDER BY date DESC, mid DESC';

    if(!isset($valid['page'])){
        $page = '1';
    } else {
        $page = $valid['page'];
    }
    //for the pagenav
    $result = DB_query($query . $where);
    $totalrows = DB_numRows($result);

    $perpage = DB_getItem($INM_TABLES['settings'], 'searchdisplim');
    $limit = ($perpage * $page) - $perpage;
    $offset = ' LIMIT ' . $limit . ', ' . $perpage;

    $result = DB_query($query . $where . $orderby . $offset);
    $numrows = DB_numRows($result);
    if ($numrows >= 1){
        //display media using thumbs.thtml
        $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
        $T->set_file(array('page' => 'search.thtml', 'thumbs' => 'thumbs.thtml', 'comcount' => 'comment-count.thtml', 'editli' => 'edit-link.thtml'));
        $T->set_var('pagenav', inm_searchnav($totalrows, $valid));
        $T->set_var('site_url', $_CONF['site_url']);
        $T->set_var('url_html', $INM_CONF['url_html']);
        $T->set_var('langauthor', $LANG_INM10[4]);
        if (!empty($valid['size'])){
            $height = $INM_CONF['thd_height'][$valid['size']];
            $width = $INM_CONF['thd_width'][$valid['size']];
        } else {
            $height = $INM_CONF['thd_height'][1];
            $width = $INM_CONF['thd_width'][1];
        }
        $T->set_var('style', ' style="height: ' . $height . 'px; width: ' . $width . 'px;"');


        //loop thru results
        //$numresults = 0;
        $minusresults = 0;
        while ($A = DB_fetchArray($result)){
            //check access to media
            $access = inm_hasMediaAccess($A['mid']);

            if ($access >= 2){
                $T->set_var('mid', $A['mid']);
                $alq = DB_query("SELECT path, enable_comments FROM {$INM_TABLES['albums']} WHERE id='{$A['aid']}'");
                list($path, $enable_comments) = DB_fetchArray($alq);

                $extension = strtolower(strrchr($A['filename'],"."));
                if (array_key_exists($extension, $INM_CONF['image_ext'])){
                    $thumb = $INM_CONF['url_html'] . '/image.php?mid=' . $A['mid'] . '&amp;thumb=1&amp;size=1';
                    $dimensions = inm_reportImageSize($path,$A['filename']);
                    list($x,$y) = $dimensions;
                    $T->set_var('dimensions', $x . 'x' . $y);
                } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
                    $thumb = $INM_CONF['url_html'] . '/image.php?aud=1&amp;thumb=1&amp;size=1';
                    $T->set_var('dimensions', 'audio');
                } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
                    $thumb = $INM_CONF['url_html'] . '/image.php?vid=1&amp;thumb=1&amp;size=1';
                    $T->set_var('dimensions', 'video');
                } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
                    $thumb = $INM_CONF['url_html'] . '/image.php?cod=1&amp;thumb=1&amp;size=1';
                    $T->set_var('dimensions', 'text');
                }

                $T->set_var('src', $thumb);
                if (!empty($A['title'])){
                    if (strlen($A['title']) > 24){
                        $title = substr(COM_stripslashes($A['title']), 0, 22) . '...';
                    } else $title = COM_stripslashes($A['title']);
                } else $title = COM_stripslashes($A['filename']);
                $T->set_var('title', $title);
                $T->set_var('alt', $title);
                $T->set_var('langhits', $LANG_INM10[19]);
                $T->set_var('hits', $A['hits']);
                $T->set_var('photographer', inm_prflink($A['owner_id']));
                $T->parse('results', 'thumbs', true);
                if ($enable_comments == 1){
                    $T->set_var('langcomments', $LANG_INM10[64]);
                    if ($A['comments'] < 1){
                        $A['comments'] = '0';
                    }
                    $T->set_var('commentcount', $A['comments']);
                    $T->parse('comments', 'comcount');
                }
                if ($access == 3) {
                    $T->set_var('editlink', '<a href="' . $INM_CONF['url_html'] . '/media.php?mid=' . $A['mid'] . '">' . $LANG_INM10[5] . '</a>');
                    $T->parse('editlink', 'editli');
                }
                //$numresults++;
            } else $minusresults++;
            $totalrows = $totalrows - $minusresults;
            $T->set_var('numresults', sprintf($LANG_INM10[20], $totalrows));
        }
        $T->parse('output', 'page');
        return $T->finish($T->get_var('output'));
    } else {
        //return no results
        return sprintf($LANG_INM10[20], '0');
    }
}

//display the full size image using a template file for easy editing
function inm_fullview($valid){
    global $INM_CONF, $_CONF, $INM_TABLES;
    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file('page','full-view.thtml');
    $T->set_var('url_html', $INM_CONF['url_html']);
    if (!empty($valid['wid'])){
        $wid = '&amp;wid=' . $valid['wid'];
    }
    $T->set_var('src', $INM_CONF['url_html'] . '/image.php?full=1&amp;mid=' . $valid['mid'] . $wid);
    $result = DB_query("SELECT filename, title FROM {$INM_TABLES['media']} WHERE mid='{$valid['mid']}'");
    list($filename,$title) = DB_fetchArray($result);
    if (!empty($title)){
        $title = COM_stripslashes($title);
    } else $title = COM_stripslashes($filename);
    $T->set_var('alt', $title);
    $T->set_var('title', $title);
    $T->parse('output', 'page');
    return $T->finish($T->get_var('output'));
}

/*
* main function
*/

if(!empty($_POST['fav']) && !empty($_POST['mid'])){
    $display = inm_saveFave();
    echo $display;
    exit;
}
if(!empty($_POST['rate'])){
    $display = inm_saveRate();
    echo $display;
    exit;
}

$valid = inm_validateInput('get');
$validp = inm_validatePost();
$valid = array_merge($valid, $validp);

//display full view
if (!empty($valid['full']) && $valid['full'] == 1){
    $display = inm_fullview($valid);
    echo $display;
    exit;
}

//does album exist
if (!empty($valid['id'])){

    //$valid['id'] = $valid['jumpto'];
    $result = DB_query("SELECT * FROM {$INM_TABLES['albums']} WHERE id='{$valid['id']}'" . COM_getPermSQL('and') . " LIMIT 1");
    if (DB_numRows($result) >= 1){
        $A = DB_fetchArray($result);
        if(!empty($A['name'])){
            $name = ' -- ' . stripslashes($A['name']);
        }
        $pagetitle = $LANG_INM01[11] . $name;
        $display = inm_siteHeader($pagetitle);
        $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
        $display .= inm_menurow();

        //number of images
        $items = DB_query("SELECT count(*) as items FROM {$INM_TABLES['media']} WHERE aid='{$valid['id']}'" . COM_getPermSQL('and'));
        list($items) = DB_fetchArray($items);
        //get number of images in any subalbums
        $numsubs = DB_count($INM_TABLES['albums'], 'pid', "{$valid['id']}");
        //add number of images from any subalbums to $numimages
        if ($numsubs >= 1){
            //this query needs to change to reflect inaccessible media
            $t = DB_query("SELECT m.mid FROM {$INM_TABLES['albums']} a, {$INM_TABLES['media']} m WHERE m.aid=a.id AND a.pid='{$A['id']}'");
            $subnumimages = DB_numRows($t);
        } else $subnumimages = '0';
        $items = $items + $subnumimages;

        if (!empty($A['description'])){
            $desc = sprintf($LANG_INM10[23], stripslashes($A['description']));
        } else $desc = '';
        $gldate = inm_getUserDateTimeFormat($A['date_created']);
        if ($A['date_lastadd'] == '0000-00-00 00:00:00'){
            $gldatelastadd[0] = '';
        } else {
            $gldatelastadd = inm_getUserDateTimeFormat($A['date_lastadd']);
            $gldatelastadd = sprintf($LANG_INM10[63], $gldatelastadd[0]);
        }
        $display .= inm_showintro(sprintf($LANG_INM10[1], $A['hits'], $gldate[0], $gldatelastadd, stripslashes($desc), $items));
        $display .= COM_endblock();

        // get block title
        $blocktitle = inm_buildBrowseTitle($valid['id'], true);
        $display .= COM_startBlock($blocktitle);

        //display thumbs
        $display .= inm_albumThumbs($A);
        //display subalbums
        $subalbums = inm_showSubAlbumSummary($valid['id']);
        if (!empty($subalbums)){
            $display .= COM_endBlock();
            $display .= COM_startBlock($LANG_INM05[7]);
            $display .= $subalbums;
        }
    } else {
        //return not extant album
        $pagetitle = $LANG_INM01[11] . $LANG_INM01[12];
        $display = inm_siteHeader($pagetitle);

        $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
        $display .= inm_menurow();
        $display .= inm_showintro();
        $display .= COM_endBlock();
        $display .= COM_startBlock($LANG_INM00['access_denied']);
        $display .= $LANG_INM10[2];
    }

} elseif (!empty($valid['mid']) && isset($valid['exif'])){

    //display exif data
    $display = inm_showIPTC($valid['mid']);
    echo $display;
    exit;

} elseif (!empty($valid['mid'])){

    //display full image
    $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE mid='{$valid['mid']}' AND status='0'" . COM_getPermSQL('and') . " LIMIT 1");
    if (DB_numRows($result) >= 1){
        $A = DB_fetchArray($result);
        if (!empty($A['title'])){
            $title = ' -- ' . COM_stripslashes($A['title']);
        }
        $pagetitle = $LANG_INM01[11] . $title;
        $display = inm_siteHeader($pagetitle);


        // get block title
        $blocktitle = inm_buildBrowseTitle($valid['mid'], false);
        $display .= COM_startBlock($blocktitle);

        //display image
        $display .= inm_showImage($A, $valid);
        $display .= COM_endBlock();

        $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
        $display .= inm_menurow();

        $resultb = DB_query("SELECT * FROM {$INM_TABLES['albums']} WHERE id='{$A['aid']}'" . COM_getPermSQL('and') . " LIMIT 1");
        $B = DB_fetchArray($resultb);
        $numres = DB_query("SELECT count(*) as items FROM {$INM_TABLES['media']} WHERE aid='{$A['aid']}' AND status='0'" . COM_getPermSQL('and'));
        list($items) = DB_fetchArray($numres);
        if (!empty($B['description'])){
            $desc = sprintf($LANG_INM10[23], stripslashes($B['description']));
        } else $desc = '';

        $gldate = inm_getUserDateTimeFormat($B['date_created']);
        if ($B['date_lastadd'] == '0000-00-00 00:00:00'){
            $gldatelastadd[0] = '';
        } else {
            $gldatelastadd = inm_getUserDateTimeFormat($B['date_lastadd']);
            $gldatelastadd = sprintf($LANG_INM10[63], $gldatelastadd[0]);
        }
        $display .= inm_showintro(sprintf($LANG_INM10[1], $B['hits'], $gldate[0], $gldatelastadd, stripslashes($desc), $items));
    } else {
        //return not extant media
        $pagetitle = $LANG_INM01[11] . $LANG_INM01[12];
        $display = inm_siteHeader($pagetitle);

        $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
        $display .= inm_menurow();
        $display .= inm_showintro();
        $display .= COM_endBlock();
        $display .= COM_startBlock($LANG_INM00['access_denied']);
        $display .= $LANG_INM10[41];
    }

} elseif (!empty($valid['mode']) && $valid['mode'] == $LANG_INM01[8]){

    //display search results
        $pagetitle = $LANG_INM01[11] . $LANG_INM01[12];
        $display = inm_siteHeader($pagetitle);

        $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
        $display .= inm_menurow();
        $display .= inm_showintro(sprintf($LANG_INM10[18], $valid['searchtxt']));
        $display .= COM_endBlock();

        $display .= COM_startBlock($LANG_INM10[22]);
        $display .= inm_searchMedia($valid);

} elseif (!empty($valid['fav']) && $_USER['uid'] >= 2 && $_USER['uid'] == $valid['fav']){
    
    //display a user's favorites
    $result = DB_query("SELECT mid FROM {$INM_TABLES['favorites']} WHERE uid='{$_USER['uid']}' ORDER BY date DESC");
    $numfavs = DB_numRows($result);
    if ($numfavs >= 1){
        $mids = array();
        while($A = DB_fetchArray($result)){
            $mids[] = $A['mid'];
        }
        $pagetitle = $LANG_INM01[11] . sprintf($LANG_INM10[55], $_USER['username']);
        $display = inm_siteHeader($pagetitle);
        $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
        $display .= inm_menurow();
        $desc = sprintf($LANG_INM10[56], $_USER['username'], $numfavs);
        $display .= inm_showintro($desc);
        $display .= COM_endBlock();

        $display .= COM_startBlock(sprintf($LANG_INM10[55], $_USER['username']));
        //display thumbs
        $display .= inm_favThumbs($mids);
    } else {
        //return no favorites exist
        $pagetitle = $LANG_INM01[11] . $LANG_INM01[12];
        $display = inm_siteHeader($pagetitle);

        $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
        $display .= inm_menurow();
        $display .= inm_showintro();
        $display .= COM_endBlock();
        $display .= COM_startBlock($LANG_INM00['access_denied']);
        $display .= $LANG_INM10[2];
    }
} elseif (!empty($valid['pop'])){
    
    //display most pop
    $result = DB_query("SELECT mid FROM {$INM_TABLES['media']} WHERE hits<>'0' AND status='0'" . COM_getPermSQL('and') . " ORDER BY hits DESC, date DESC, mid DESC LIMIT 10");
    $numrows = DB_numRows($result);
    $retval .= COM_startBlock($LANG_INM01[22]);
    if ($numrows > 0) {
        $mids = array();
        while($A = DB_fetchArray($result)){
            $mids[] = $A['mid'];
        }
        $pagetitle = $LANG_INM01[11] . $LANG_INM10[59];
        $display = inm_siteHeader($pagetitle);
        $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
        $display .= inm_menurow();
        $display .= inm_showintro($LANG_INM10[60]);
        $display .= COM_endBlock();

        $display .= COM_startBlock($LANG_INM10[59]);
        //display thumbs
        $display .= inm_popThumbs($mids);
    } else {
        //return no pop exist
        $pagetitle = $LANG_INM01[11] . $LANG_INM01[12];
        $display = inm_siteHeader($pagetitle);

        $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
        $display .= inm_menurow();
        $display .= inm_showintro();
        $display .= COM_endBlock();
        $display .= COM_startBlock($LANG_INM00['access_denied']);
        $display .= $LANG_INM10[2];
    }
} else {
    //refresh to index.php
    $display = COM_refresh($INM_CONF['url_html'] . '/index.php');
    echo $display;
    exit;
}
$display .= COM_endBlock();
$display .= inm_poweredBy();
$display .= inm_siteFooter();
echo $display;
exit;
?>