<?PHP

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | image.php                                                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//


require_once('../lib-common.php');
require_once ($_CONF['path'] . 'plugins/inmemoriam/image-functions.inc');
$valid  = inm_validateInput('get');

// Retrieve access settings
$anonview = DB_getItem($INM_TABLES['settings'], 'anonview');
// Check user has rights to access this page
if (($anonview == '0') && ($_USER['uid'] < 2)) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access image.php.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    //return a default image with courtesy info...
    if(!empty($valid['size'])){
        $size = $INM_CONF['thn_auto_size'][$valid['size']];
    }
    inm_courtesyImage($INM_CONF['path_html'] . 'images/splash.jpg',$size);
    exit;
}


$mid    = $valid['mid'];
$thumb  = $valid['thumb'];
$id     = $valid['id'];
$wid    = $valid['wid'];
$default_size = '1';

//main function delivers an image to the browser

if ($valid['default'] == 1){
    //default thumb is used when no thumb exists otherwise
    //this instance is called purposefully when we know no thumb exists
    //see last else when for some reason we are asked to display an image not extant or not accessible
    inm_thumbnail($INM_CONF['path_html'] . 'images/default_thumb.png');


} elseif ($valid['aud'] == 1){
    if ($thumb == '1'){
        //default thumb is used to indicate an audio item
        if(!empty($valid['size'])){
            $size = $INM_CONF['thn_auto_size'][$valid['size']];
        } else $size = $INM_CONF['thn_auto_size'][$default_size];
        inm_thumbnail($INM_CONF['path_html'] . 'images/audio.jpg', $size);
    } elseif (empty($mid)){
        //same pic for the scaled image
        inm_constrainedImage($INM_CONF['path_html'] . 'images/audio.jpg', '300', '300', '100');
    } elseif (!empty($mid) && inm_hasMediaAccess($mid) >= 2){
        $result = DB_query("SELECT filename, aid FROM {$INM_TABLES['media']} WHERE mid='$mid'");
        list($filename,$aid) = DB_fetchArray($result);
        $path = DB_getItem($INM_TABLES['albums'], 'path', "id='$aid'");
        inm_readfile($path . $filename);
    }


} elseif ($valid['vid'] == 1){
    if ($thumb == '1'){
        //default thumb is used to indicate an video item
        if(!empty($valid['size'])){
            $size = $INM_CONF['thn_auto_size'][$valid['size']];
        } else $size = $INM_CONF['thn_auto_size'][$default_size];
        inm_thumbnail($INM_CONF['path_html'] . 'images/video.jpg', $size);
    } elseif (empty($mid)) {
        //same pic for the scaled image
        inm_constrainedImage($INM_CONF['path_html'] . 'images/video.jpg', '300', '300', '100');
    } elseif (!empty($mid) && inm_hasMediaAccess($mid) >= 2){
        $result = DB_query("SELECT filename, aid FROM {$INM_TABLES['media']} WHERE mid='$mid'");
        list($filename,$aid) = DB_fetchArray($result);
        $path = DB_getItem($INM_TABLES['albums'], 'path', "id='$aid'");
        inm_readfile($path . $filename);
    }


} elseif ($valid['cod'] == 1){
    if ($thumb == '1'){
        //default thumb is used to indicate an text item
        if(!empty($valid['size'])){
            $size = $INM_CONF['thn_auto_size'][$valid['size']];
        } else $size = $INM_CONF['thn_auto_size'][$default_size];
        inm_thumbnail($INM_CONF['path_html'] . 'images/code.jpg', $size);
    } elseif (empty($mid)) {
        //same pic for the scaled image
        inm_constrainedImage($INM_CONF['path_html'] . 'images/code.jpg', '300', '300', '100');
    } elseif (!empty($mid) && inm_hasMediaAccess($mid) >=2){
        $result = DB_query("SELECT filename, aid FROM {$INM_TABLES['media']} WHERE mid='$mid'");
        list($filename,$aid) = DB_fetchArray($result);
        $path = DB_getItem($INM_TABLES['albums'], 'path', "id='$aid'");
        inm_readfile($path . $filename);
    }


} elseif ($valid['prt'] == 1 && !empty($mid) && inm_hasMediaAccess($mid) >= 2){
    //provides an image to replace an autotag
    $result = DB_query("SELECT filename, aid FROM {$INM_TABLES['media']} WHERE mid='$mid'");
    list($filename,$aid) = DB_fetchArray($result);
    $path = DB_getItem($INM_TABLES['albums'], 'path', "id='$aid'");
    inm_constrainedImage($path . $filename,$_CONF['max_image_width'],$_CONF['max_image_height']);


} elseif ($valid['splash'] == 1){
    //displays the splash image inside a 480(x) by 480(y) box
    inm_constrainedImage($INM_CONF['path_html'] . 'images/splash.jpg', '480', '480','100');


}elseif ($thumb == '1' && !empty($mid) && inm_hasMediaAccess($mid) >= 2){
    //create a thumbnail from an image for a random album thumb or media thumbs within the album
    //...also serves the media editor with a small thumb
    $result = DB_query("SELECT filename, aid FROM {$INM_TABLES['media']} WHERE mid='$mid'");
    list($filename,$aid) = DB_fetchArray($result);
    $path = DB_getItem($INM_TABLES['albums'], 'path', "id='$aid'");
    if(!empty($valid['size'])){
        $size = $INM_CONF['thn_auto_size'][$valid['size']];
    } else $size = $INM_CONF['thn_auto_size'][$default_size];
    if (inm_isFile($INM_CONF['path_thumbs'] . $aid . '/' . $INM_CONF['thumb_prefix'][$valid['size']] . $filename)){
        //static
        inm_staticImage($INM_CONF['path_thumbs'] . $aid . '/' . $INM_CONF['thumb_prefix'][$valid['size']] . $filename);
        //inm_readfile($INM_CONF['path_thumbs'] . $aid . '/' . $INM_CONF['thumb_prefix'][$valid['size']] . $filename);
    } else {
        //dynamic
        inm_thumbnail($path . $filename, $size);
    }


} elseif ($thumb == '2' && !empty($id) && inm_hasAlbumAccess($id) >= 2){
    //create a thumbnail from an image serving solely as an album thumb
    $filename = DB_getItem($INM_TABLES['albums'], 'thumb', "id='$id'");
    inm_thumbnail($INM_CONF['path_albums'] . $filename);


} elseif ($thumb == '3' && !empty($mid) && inm_hasMediaAccess($mid) >= 2){
    //create a thumbnail from an image for the media editor
    $result = DB_query("SELECT filename, aid FROM {$INM_TABLES['media']} WHERE mid='$mid'");
    list($filename,$aid) = DB_fetchArray($result);
    $path = DB_getItem($INM_TABLES['albums'], 'path', "id='$aid'");
    inm_thumbnail($path . $filename);


} elseif ($valid['full'] == '1' && !empty($mid)){
    if (inm_hasMediaAccess($mid)){
        //display an image full/original size
        $result = DB_query("SELECT filename, aid, owner_id, size, position, opacity FROM {$INM_TABLES['media']} WHERE mid='$mid'");
        list($filename,$aid,$owner_id,$size,$position,$opacity) = DB_fetchArray($result);
        $result = DB_query("SELECT path, dispfullimg, limitfullimg FROM {$INM_TABLES['albums']} WHERE id='$aid'");
        list ($path, $dispfullimg, $limitfullimg) = DB_fetchArray($result);
        if (($dispfullimg == 1 && ($limitfullimg == 1 || ($limitfullimg == 2 && $_USER['uid'] >= 2) || ($limitfullimg == 3 && SEC_hasRights('inmemoriam.fullview')))) || SEC_hasRights('inmemoriam.admin') || $_USER['uid'] == $owner_id) {
            if (!empty($wid)){
                $result = DB_query("SELECT img_mark, txt_mark FROM {$INM_TABLES['watermarks']} WHERE wid='$wid'");
                list($img_mark,$txt_mark) = DB_fetchArray($result);
            }
            inm_fullSizeImage($path . $filename, $img_mark, $txt_mark, $size, $position, $opacity);
        } else {
            inm_courtesyImage();
        }
    } else {
        inm_courtesyImage();
    }


} elseif (empty($thumb) && !empty($mid) && inm_hasMediaAccess($mid) >= 2){
    //create an image from an image for the browse page.
    //This image is constrained by the default album's maximum X and Y values.
    //Nothing is done to an image that is smaller than the X/Y box.
    $result = DB_query("SELECT filename, aid, size, position, opacity FROM {$INM_TABLES['media']} WHERE mid='$mid'");
    list($filename,$aid,$size,$position,$opacity) = DB_fetchArray($result);
    $bres = DB_query("SELECT path, maxw, maxh FROM {$INM_TABLES['albums']} WHERE id='$aid'");
    list($path,$maxX,$maxY) = DB_fetchArray($bres);
    if (!empty($wid)){
        $result = DB_query("SELECT img_mark, txt_mark FROM {$INM_TABLES['watermarks']} WHERE wid='$wid'");
        list($img_mark,$txt_mark) = DB_fetchArray($result);
        inm_constrainedImage($path . $filename,$maxX,$maxY,$INM_CONF['scaled_quality'],$img_mark,$txt_mark,$size,$position,$opacity);
    } else {
        if (inm_isFile($INM_CONF['path_scaled'] . $aid . '/' . $filename)){
            //static
            /* check old static size.
            // because max x & y are configurable there is little way of
            // knowing if an existing static image was built with the current
            // maximums or some previous settings.
            // Therefore, this check only ensures that nothing bigger than
            // the current maximums are displayed.
            */
            $dimensions = inm_reportImageSize($INM_CONF['path_scaled'] . $aid . '/',$filename);
            list($x,$y) = $dimensions;
            if ($x > $maxX || $y > $maxY){
                @unlink($INM_CONF['path_scaled'] . $aid . '/' . $filename);
                inm_constrainedImage($path . $filename,$maxX,$maxY,$INM_CONF['scaled_quality']);
            } else {
                inm_staticImage($INM_CONF['path_scaled'] . $aid . '/' . $filename);
                //inm_readfile($INM_CONF['path_scaled'] . $aid . '/' . $filename);
            }
        } else {
            //dynamic
            inm_constrainedImage($path . $filename,$maxX,$maxY,$INM_CONF['scaled_quality']);
        }
    }


} elseif (!empty($wid)){
    //create a thumbnail from a watermark image for the media editor
    $filename = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='$wid'");
    inm_thumbnail($INM_CONF['path_wm'] . $filename);


} else {
    // display the default courtesy image when an image is improperly called
    if(!empty($valid['size'])){
        $size = $INM_CONF['thn_auto_size'][$valid['size']];
    }
    inm_courtesyImage($INM_CONF['path_html'] . 'images/splash.jpg',$size);
}


exit;
?>