<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | index.php                                                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Retrieve access settings
$anonview = DB_getItem($INM_TABLES['settings'], 'anonview');
// Check user has rights to access this page
if (($anonview == '0') && ($_USER['uid'] < 2)) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the inmemoriam page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_INM00['access_denied']);
    $display .= $LANG_INM00['access_denied_msg1'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

//displays the Inmemoriam splash
function display_splash(){
    global $_CONF, $LANG_INM01, $INM_CONF;

    //default image for splash page
    //$imagesrc = $INM_CONF['url_html'] . '/images/splash.jpg';

    //it's probably quicker to use the above definition for your splash image
    //but using the image functions allow for more display possibilities. 
    $imagesrc = $INM_CONF['url_html'] . '/image.php?splash=1';

    $alt = $LANG_INM01[47];
    $title = $alt;
    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file('page', 'splash.thtml');
    $T->set_var('url_html', $INM_CONF['url_html']);
    $T->set_var('heading', $LANG_INM01[11]);
    $T->set_var('slogan', $LANG_INM01[12]);
    $T->set_var('imagesrc', $imagesrc);
    $T->set_var('alt', $alt);
    $T->set_var('title', $title);
    $T->set_var('about', $LANG_INM01[13]);
    $T->set_var('copyright', $LANG_INM01[14]);
    $T->parse('output','page');
    $display .= $T->finish($T->get_var('output'));
    return $display;
}

//displays the google-like page nav
function inm_pagenav()
{
    global $_CONF, $INM_TABLES, $_GET, $INM_CONF;

    //print page nav here
    if(!isset($_GET['page'])){
        $page = '1';
    } else $page = $_GET['page'];
    if (isset($_GET['sort'])){
        $sortvar = "sort=".$_GET['sort'];
    } else $sortvar = 'sort=date';

    $query1 = DB_query ("SELECT COUNT(*) AS albums FROM {$INM_TABLES['albums']} WHERE (pid='' OR pid IS NULL)" . COM_getPermSQL('and'));
    list($albums) = DB_fetchArray($query1);
    $query2 = DB_query("SELECT albums_perpage AS perpage FROM {$INM_TABLES['settings']}");
    list($perpage) = DB_fetchArray($query2);
    if ($albums > $perpage) {
        $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
        $T->set_file('page', 'pagenav.thtml');
        $prevpage = $page - 1;
        $nextpage = $page + 1;
        $baseurl = $INM_CONF['url_html'] . '/index.php?' . $sortvar;
        $numpages = ceil ($albums / $perpage);
        $T->set_var ('google_paging',
                inm_printPageNavigation ($baseurl, $page, $numpages));
        $T->parse('output','page');
        $retval .= $T->finish($T->get_var('output'));
    }
    return $retval;
}

/* 
* Main Function
*/

//show slogan or if on an image then show image name
$pagetitle = $LANG_INM01[11] . $LANG_INM01[12];
$display = inm_siteHeader($pagetitle);

if ($_GET['splash'] == '1'){
    $display .= display_splash();
    $display .= inm_menurow();
} else {
    $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
    $display .= inm_menurow();

    $result = DB_query("SELECT COUNT(*) as count FROM {$INM_TABLES['albums']} WHERE status='0'" . COM_getPermSQL('and'));
    list($numalbums) = DB_fetchArray($result);
    $result = DB_query("SELECT COUNT(*) as count FROM {$INM_TABLES['media']} WHERE status='0'" . COM_getPermSQL('and'));
    list($nummedia) = DB_fetchArray($result);

    $display .= inm_showintro(sprintf($LANG_INM01[32], $LANG_INM01[15], $numalbums, $nummedia));
    $display .= COM_endBlock();
    //$result = DB_query("SELECT aid FROM {$INM_TABLES['albums']}" . COM_getPermSQL("where"));
    //$albumcount = DB_numRows($result);
    //sprintf($LANG_INM05[9], $albumcount)
    $display .= COM_startBlock($LANG_INM05[14]);
    $display .= inm_showAlbumSummary();
    $display .= inm_pagenav();
    $display .= COM_endBlock();
}

$display .= inm_poweredBy();
$display .= inm_siteFooter();
echo $display;
?>