<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | media.php                                                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Retrieve access settings
$result = DB_query("SELECT loginadd FROM {$INM_TABLES['settings']}");
list($loginadd) = DB_fetchArray($result);

// Check user has rights to access this page
if (SEC_hasRights('inmemoriam.add') || SEC_hasRights('inmemoriam.create') || SEC_hasRights('inmemoriam.admin')){
    //allow
} elseif (($_USER['uid'] < 2) || (($loginadd == '0') && ($_USER['uid'] >= 2))) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the inmemoriam page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_INM00['access_denied']);
    $display .= $LANG_INM00['access_denied_msg1'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}


//displays the media editor
function inm_mediaEditor($valid = ''){
    global $_CONF, $INM_CONF, $_USER, $_GROUPS, $_TABLES, $INM_TABLES, $LANG_INM08, $LANG_INM03, $LANG_INM11;
    
    //if !empty($valid['mid']) --extant media is being edited
    //if !empty($valid['aid']) --new media is being added to extant album
    //if !isset($valid['aid']) && !isset($valid['mid']) --must select album
    $mid = $valid['mid'];
    $id = $valid['id'];

    if (!empty($mid)){
        if (isset($valid['status'])){
            $result = DB_query("SELECT STRAIGHT_JOIN a.owner_id FROM {$INM_TABLES['media']} m, {$INM_TABLES['albums']} a WHERE m.mid='$mid' AND m.aid=a.id");
            list ($owner_id) = DB_fetchArray($result);
            if ($_USER['uid'] == $owner_id || SEC_hasRights('inmemoriam.admin')){
                $and = " AND status='1'";
            }
        } else $and = " AND status='0'";

        $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE mid='$mid'" . $and . " LIMIT 1");
        if (DB_numRows($result) < 1){
            //no media exists by that id
            //but let's shoot a msg and log the attempt
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[13];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally edit not extant media: $mid.");
            return $display;
        }
        $M = DB_fetchArray($result);
        $access = inm_hasMediaAccess($mid);
        if (empty($access) || $access < 3) {
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[13];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally edit media: $mid.");
            return $display;
        }
        //for use in our script
        $result2 = DB_query("SELECT * FROM {$INM_TABLES['albums']} WHERE id='{$M['aid']}' LIMIT 1");
        $A = DB_fetchArray($result2);
        $id = $A['id'];

    } elseif (!empty($id)){
        $result = DB_query("SELECT * FROM {$INM_TABLES['albums']} WHERE id='$id'" . COM_getPermSQL('and') . " LIMIT 1");
        if (DB_numRows($result) < 1){
            //no albums exists by that id
            //but let's shoot a msg and log the attempt
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[15];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally add media to album: $aid.");
            return $display;
        }
        $A = DB_fetchArray($result);
        if (SEC_hasRights('inmemoriam.admin')){
            //allow
        } elseif ($A['allow_submit'] == '0' && $_USER['uid'] != $A['owner_id']) {
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[15];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally add media to album: $aid.");
            return $display;
        }
        $access = inm_hasAlbumAccess($id);
        $mid = '';
    }

    $T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
    $T->set_file(array('page' => 'media-editor.thtml', 'perms' => 'mperm-editor.thtml', 'albumsel' => 'media-select.thtml', 'uploadfieldset' => 'upload-media.thtml', 'currentmedia' => 'current-media.thtml', 'movetoalbum' => 'move-media.thtml', 'javaadd' => 'add-script.thtml', 'wmapply' => 'apply-wm.thtml', 'wmapplyg' => 'applyglobal-wm.thtml'));
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('url_html', $INM_CONF['url_html']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);

    if (empty($id) && empty($mid)){
        //dropdown of accessible albums
        if (SEC_hasRights('inmemoriam.admin')){
            $bresult = DB_query("SELECT id, name, pid, allow_submit, owner_id FROM {$INM_TABLES['albums']} ORDER BY name ASC");
        } else {
            $bresult = DB_query("SELECT id, name, pid, allow_submit, owner_id FROM {$INM_TABLES['albums']} WHERE allow_submit='1' OR owner_id='{$_USER['uid']}'" . COM_getPermSQL('and') . " ORDER BY name ASC");
        }
        if (DB_numRows($bresult) > 0){
            $albumoptions = '';
            while ($B = DB_fetchArray($bresult)){
                if ($B['allow_submit'] == '1' || $B['owner_id'] == $_USER['uid'] || SEC_hasRights('inmemoriam.admin')){
                    $cresult = DB_query("SELECT id, name, allow_submit, owner_id FROM {$INM_TABLES['albums']} WHERE pid='{$B['id']}'" . COM_getPermSQL('and') . " ORDER BY name ASC");
                    if (DB_numRows($cresult) > 0){
                        $subalbumoptions = '';
                        while ($C = DB_fetchArray($cresult)){
                            if ($C['allow_submit'] == '1' || $C['owner_id'] == $_USER['uid']){
                                $subalbumoptions .= '<option value="' . $C['id'] . '">';
                                $subalbumoptions .= '--' . stripslashes($C['name']) . '</option>' . LB;
                            }
                        }
                    }
                    if ($B['pid'] == ''){
                        $albumoptions .= '<option value="' . $B['id'] . '">';
                        $albumoptions .= stripslashes($B['name']) . '</option>' . LB;
                    }
                    $albumoptions .= $subalbumoptions;
                    $subalbumoptions = '';
                }
            }
            $T->set_var('langaddto', $LANG_INM08[1]);
            $T->set_var('albumoptions', $albumoptions);
            $T->parse('albumselect', 'albumsel');

            $display = $T->finish($T->get_var('albumselect'));
            return $display;
        } else {
            //no albums exists or access denied
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM08[45];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            return $display;
        }
    } else {
        if (!empty($id) && empty($mid)){
            //adding new media to extant album

            $albumname = stripslashes($A['name']);
            if (strlen($albumname) > 12){
                $albumname = substr($albumname, 0, 12) . '...';
            }
            $T->set_var('existingalbum', sprintf($LANG_INM08[61], $albumname));
            $T->set_var('albumid', '<input type="hidden" name="aid" value="' . $id . '" />');
            $T->set_var('langupload', $LANG_INM08[3]);
            $T->set_var('uploaddocs', sprintf($LANG_INM08[4], 'uploadmedia'));
            $T->set_var('langfile', $LANG_INM08[5]);
            $T->set_var('langtype', $LANG_INM08[6]);
            $T->set_var('image', $LANG_INM08[7]);
            $T->set_var('audio', $LANG_INM08[8]);
            $T->set_var('video', $LANG_INM08[9]);
            $T->set_var('code', $LANG_INM08[10]);
            $T->set_var('notsupported', $LANG_INM08[11]);
            if ($access == 3){
                $T->parse('addanother', 'javaadd');
                $T->set_var('uploadnote', $LANG_INM08[13]);
                $button = '<button id="inm-button" onclick="addfilefield(); return false;">' . $LANG_INM08[24] . '</button>';
                $T->set_var('addbutton', $button);
            }
            $T->set_var('langmaxfile', $LANG_INM08[49]);
            //$maxfile = DB_getItem($INM_TABLES['settings'], 'max_filesize');
            $T->set_var('maxfile', inm_readbytes($A['max_filesize']));

            if ($A['enable_image'] == 1){
                $x = 0;
                $extarray = '';
                foreach ($INM_CONF['image_ext'] as $key => $value){
                    if ($x < 1){
                        $extarray = $key;
                    } else $extarray .= '; ' . $key;
                    $x++;
                }
                $T->set_var('allowable_img', '<li><small>' . $LANG_INM08[50] . ': ' . $extarray . '</small></li>');
            }
            if ($A['enable_audio'] == 1){
                $x = 0;
                $aud_extA = '';
                foreach ($INM_CONF['aud_ext'] as $key => $value){
                    if ($x < 1){
                        $aud_extA = $key;
                    } else $aud_extA .= '; ' . $key;
                    $x++;
                }
                $T->set_var('allowable_aud', '<li><small>' . $LANG_INM08[50] . ': ' . $aud_extA . '</small></li>');
            }
            if ($A['enable_video'] == 1){
                $x = 0;
                $vid_extA = '';
                foreach ($INM_CONF['vid_ext'] as $key => $value){
                    if ($x < 1){
                        $vid_extA = $key;
                    } else $vid_extA .= '; ' . $key;
                    $x++;
                }
                $T->set_var('allowable_vid', '<li><small>' . $LANG_INM08[50] . ': ' . $vid_extA . '</small></li>');
            }
            if ($A['enable_code'] == 1){
                $x = 0;
                $cod_extA = '';
                foreach ($INM_CONF['cod_ext'] as $key => $value){
                    if ($x < 1){
                        $cod_extA = $key;
                    } else $cod_extA .= '; ' . $key;
                    $x++;
                }
                $T->set_var('allowable_cod', '<li><small>' . $LANG_INM08[50] . ': ' . $cod_extA . '</small></li>');
            }

            $T->parse('uploadfieldset', 'uploadfieldset');
            $T->set_var('mediaaction', $INM_CONF['url_html'] . '/media.php');

        } elseif (!empty($mid)){
            if (!empty($valid['status'])){
                $T->set_var('mediaaction', $INM_CONF['url_html'] . '/queue.php');
            } else {
                $T->set_var('mediaaction', $INM_CONF['url_html'] . '/media.php');
            }
            $T->set_var('filename', $M['filename']);

            //source for thumb
            $extension = strtolower(strrchr($M['filename'],"."));
            if (array_key_exists($extension, $INM_CONF['image_ext'])){
                $midactual = $INM_CONF['url_html'] . '/image.php?thumb=1&amp;mid=' . $mid;
            } elseif (array_key_exists($extension, $INM_CONF['aud_ext'])){
                $midactual = $INM_CONF['url_html'] . '/image.php?aud=1&amp;thumb=1';
            } elseif (array_key_exists($extension, $INM_CONF['vid_ext'])){
                $midactual = $INM_CONF['url_html'] . '/image.php?vid=1&amp;thumb=1';
            } elseif (array_key_exists($extension, $INM_CONF['cod_ext'])){
                $midactual = $INM_CONF['url_html'] . '/image.php?cod=1&amp;thumb=1';
            }

            $T->set_var('midactual', $midactual);
            $T->set_var('mid', $mid);
            $T->set_var('aid', $M['aid']);
            $albumname = COM_stripslashes($A['name']);
            if (strlen($albumname) > 24){
                $albumname = substr($albumname, 0, 23) . '...';
            }
            $T->set_var('albumname', $albumname);
            $T->set_var('langmedia', $LANG_INM08[22]);
            $T->set_var('langalbum', $LANG_INM08[23]);

            //dropdown of accessible albums to which you can move media
            if (SEC_hasRights('inmemoriam.admin')){
                $mresult = DB_query("SELECT id, name, pid, owner_id FROM {$INM_TABLES['albums']} ORDER BY name ASC");
            } else {
                $mresult = DB_query("SELECT id, name, pid, allow_submit, owner_id FROM {$INM_TABLES['albums']} WHERE owner_id='{$_USER['uid']}'" . COM_getPermSQL('and') . " ORDER BY name ASC");
            }
            if (DB_numRows($mresult) > 0){
                $albumoptions = '';
                while ($V = DB_fetchArray($mresult)){
                    if ($V['owner_id'] == $_USER['uid'] || SEC_hasRights('inmemoriam.admin')){
                        $sresult = DB_query("SELECT id, name, allow_submit, owner_id FROM {$INM_TABLES['albums']} WHERE pid='{$V['id']}'" . COM_getPermSQL('and') . " ORDER BY name ASC");
                        if (DB_numRows($sresult) > 0){
                            $subalbumoptions = '';
                            while ($S = DB_fetchArray($sresult)){
                                if ($S['owner_id'] == $_USER['uid']){
                                    $subalbumoptions .= '<option value="' . $S['id'] . '">';
                                    $subalbumoptions .= '--' . COM_stripslashes($S['name']) . '</option>' . LB;
                                }
                            }
                        }
                        if ($V['pid'] == ''){
                            $albumoptions .= '<option value="' . $V['id'] . '">';
                            $albumoptions .= COM_stripslashes($V['name']) . '</option>' . LB;
                        }
                        $albumoptions .= $subalbumoptions;
                        $subalbumoptions = '';
                    }
                }
                $T->set_var('langnewalbum', $LANG_INM08[70]);
                $T->set_var('newalbumoptions', $albumoptions);
                $T->parse('albumselect', 'movetoalbum');
            }

            $T->parse('currentmedia', 'currentmedia');
        }

        $selected = ' selected="selected"';
        $checked = ' checked="checked"';


        $T->set_var('langdisplay', $LANG_INM08[14]);
        $T->set_var('displaydocs', sprintf($LANG_INM08[4], 'mdisplay'));
        $T->set_var('langwatermark', $LANG_INM08[19]);
        $T->set_var('watermarkdocs', sprintf($LANG_INM08[4], 'watermark'));
        $T->set_var('langmaxfile', $LANG_INM08[49]);
        $T->set_var('maxfile', inm_readbytes('65536'), false);
        $T->set_var('langallext', $LANG_INM08[50]);
        $T->set_var('extarray', '.PNG', false);
        $T->set_var('langenablewm', $LANG_INM08[20]);
        if ($access == 3){
            if (empty($mid)){
                $T->set_var('disabled', 'disabled="disabled"');
            }
            $T->set_var('langapptoall', $LANG_INM08[21]);
            if (SEC_hasRights('inmemoriam.admin')){
                $T->set_var('langapptoglobal', $LANG_INM08[67]);
                $T->parse('applytoglobal', 'wmapplyg');
            }
            $T->parse('applytoall', 'wmapply');
        }

        $T->set_var('langaccessrights', $LANG_INM03[1]);
        $T->set_var('langowner', $LANG_INM03[3]);
        $T->set_var('langgroup', $LANG_INM03[4]);
        $T->set_var('accessdocs', sprintf($LANG_INM08[4], 'mediaaccess'));
        $T->set_var('langpermkey', $LANG_INM03[8]);
        $T->set_var('langmembers', $LANG_INM03[5]);
        $T->set_var('langanon', $LANG_INM03[6]);
        $T->set_var('perm_note', $LANG_INM03[7]);
        if (empty($mid)){
            //default perms/access
            $T->set_var('ownerid', $_USER['uid']);
            $T->set_var('ownerusername', $_USER['username']);
            if (isset ($_GROUPS['inmemoriam Admin'])) {
                $M['group_id'] = $_GROUPS['inmemoriam Admin'];
            } else {
                $M['group_id'] = SEC_getFeatureGroup ('inmemoriam.add');
            }
            //$access = 3;//access must be 3 to be on this page anyway
            if(SEC_hasRights('inmemoriam.admin')){
                $T->set_var('ownchecked2', $checked);
                $T->set_var('ownchecked1', $checked);
                $T->set_var('grpchecked2', $checked);
                $T->set_var('grpchecked1', '');
                $T->set_var('memchecked', $checked);
                $T->set_var('anonchecked', $checked);
            }
        } elseif (!empty($mid)){
            //album perms/access
            $username = DB_getItem($_TABLES['users'], 'username', "uid='{$M['owner_id']}'");
            $T->set_var('ownerid', $M['owner_id']);
            $T->set_var('ownerusername', $username);
            if(SEC_hasRights('inmemoriam.admin')){
                if ($M['perm_owner'] >= 2){
                    $T->set_var('ownchecked2', $checked);
                }
                if ($M['perm_owner'] == 3){
                    $T->set_var('ownchecked1', $checked);
                } else $T->set_var('ownchecked1', '');
                if ($M['perm_group'] >= 2){
                    $T->set_var('grpchecked2', $checked);
                }
                if ($M['perm_group'] == 3){
                    $T->set_var('grpchecked1', $checked);
                }
                if ($M['perm_members'] == 2){
                    $T->set_var('memchecked', $checked);
                } else $T->set_var('memchecked', '');
                if ($M['perm_anon'] == 2){
                    $T->set_var('anonchecked', $checked);
                } else $T->set_var('anonchecked', '');
            }
        }

        $usergroups = SEC_getUserGroups();
        $groupoptions = '';
        if ($access == 3) {
            $groupoptions .= '<select name="groupid">';
            for ($i = 0; $i < count($usergroups); $i++) {
                $groupoptions .= '<option value="' . $usergroups[key($usergroups)] . '"';
                if ($A['group_id'] == $usergroups[key($usergroups)]) {
                    $groupoptions .= $selected;
                }
                $groupoptions .= '>' . key($usergroups) . '</option>' . LB;
                next($usergroups);
            }
            $groupoptions .= '</select>';
            $T->set_var('groupoptions', $groupoptions);
        } else {
            // they can't set the group then
            $groupoptions .= '<span style="vertical-align: top;">' . DB_getItem ($_TABLES['groups'],
                'grp_name', "grp_id = {$M['group_id']}") . '</span>';
            $groupoptions .= '<input type="hidden" name="group_id" value="' . $M['group_id'] . '">' . LB;
        }
        if(SEC_hasRights('inmemoriam.admin')){
            $T->parse('permissions_editor', 'perms');
        }


        $T->set_var('langexif', $LANG_INM08[25]);
        //album editor for comments and rating
        //$T->set_var('langcomments', $LANG_INM08[25]);
        //$T->set_var('langrating', $LANG_INM08[29]);
        $T->set_var('langshowcaption', $LANG_INM08[30]);
        $T->set_var('langcaption', $LANG_INM08[27]);
        $T->set_var('langtitle', $LANG_INM08[28]);
        //$T->set_var('langalttext', $LANG_INM08[28]);
        $T->set_var('langkeywords', $LANG_INM08[53]);
        $T->set_var('keywordsnote', $LANG_INM08[54]);
        $T->set_var('langentext', $LANG_INM08[31]);
        $T->set_var('langenimage', $LANG_INM08[32]);
        $T->set_var('wmmaxfile', '65536');//more than enuf for a small png
        $T->set_var('langwmtext', $LANG_INM08[33]);
        $T->set_var('langcusttext', $LANG_INM08[75]);
        $T->set_var('txtname', $LANG_INM08[76]);
        $T->set_var('txtslogan', $LANG_INM08[77]);
        $T->set_var('txtcopyright', $LANG_INM08[78]);
        $T->set_var('txtdate', $LANG_INM08[79]);
        $T->set_var('langwmimage', $LANG_INM08[34]);
        $T->set_var('langwmdefault', $LANG_INM08[68]);
        $T->set_var('langwmsize', $LANG_INM08[35]);
        $T->set_var('langwmposition', $LANG_INM08[36]);
        $T->set_var('langwmopacity', $LANG_INM08[69]);
        $T->set_var('textonly_note', $LANG_INM08[73]);
        $T->set_var('imageonly_note', $LANG_INM08[74]);
        $T->set_var('small', $LANG_INM08[37]);
        $T->set_var('medium', $LANG_INM08[38]);
        $T->set_var('large', $LANG_INM08[39]);
        $T->set_var('tl', $LANG_INM08[40]);
        $T->set_var('tr', $LANG_INM08[41]);
        $T->set_var('bl', $LANG_INM08[42]);
        $T->set_var('br', $LANG_INM08[43]);
        $T->set_var('tc', $LANG_INM08[63]);
        $T->set_var('bc', $LANG_INM08[64]);
        $T->set_var('cl', $LANG_INM08[65]);
        $T->set_var('cr', $LANG_INM08[66]);
        $T->set_var('cc', $LANG_INM08[44]);
        $T->set_var('reset', $LANG_INM08[16]);
        if (!empty($mid)){//if access was anything else, we wouldn't be here anyway
            if(!empty($valid['status'])){
                $T->set_var('delete', '<input type="submit" name="submit" value="'.$LANG_INM11[5].'" />' . LB);
                $T->set_var('save', $LANG_INM11[8]);
                $T->set_var('cancel', $LANG_INM11[9]);
            } else {
                $T->set_var('delete', '<input type="submit" name="submit" value="'.$LANG_INM08[17].'" />' . LB);
                $T->set_var('save', $LANG_INM08[52]);
                $T->set_var('cancel', $LANG_INM08[18]);
            }
        } else {
            $T->set_var('save', $LANG_INM08[15]);
            $T->set_var('cancel', $LANG_INM08[18]);
        }

        if (empty($mid)){
            //default settings for new media
            $T->set_var('exifchk', '');
            $T->set_var('showcaptionchk', $checked);
            $T->set_var('disabled', 'disabled="disabled"');
            $T->set_var('textchk', $checked);
            $T->set_var('size1', $checked);
            $T->set_var('pos1', $checked);
            $T->set_var('opac1', $checked);
            $T->set_var('newmid', '<input type="hidden" name="newmid" value="1" />');
        } elseif (!empty($mid)){
            $T->set_var('oldmid', '<input type="hidden" name="oldmid" value="'.$mid.'" />');
            //$M contains the media data
            if ($M['enable_exif'] == 1){
                $T->set_var('exifchk', $checked);
            } else $T->set_var('exifchk', '');
            //if ($M['enable_caption'] == 1){
            //    $T->set_var('showcaptionchk', $checked);
            //} else $T->set_var('showcaptionchk', '');
            $T->set_var('caption', COM_stripslashes($M['caption']));
            $T->set_var('title', $M['title']);
            $T->set_var('keywords', $M['keywords']);
            if ($M['enable_watermark'] == 1){
                $T->set_var('enablewmchk', $checked);
                $T->set_var('disabled', '');
                $wmresult = DB_query("SELECT * FROM {$INM_TABLES['watermarks']} WHERE wid='{$M['wid']}'");
                $W = DB_fetchArray($wmresult);
                if (!empty($W['img_mark'])){
                    $T->set_var('textchk', '');
                    if ($W['img_mark'] != $INM_CONF['default_wm']){
                        $T->set_var('imagechk', $checked);
                        $T->set_var('defaultchk', '');
                    } else {
                        $T->set_var('defaultchk', $checked);
                        $T->set_var('imagechk', '');
                    }
                    $T->set_var('wmactual', '<img src="' . $INM_CONF['url_html'] . '/image.php?wid=' . $M['wid'] . '" alt="" />');
                    $T->set_var('widinput', '<input type="hidden" name="wid" value="' . $M['wid'] . '" />');
                } elseif (!empty($W['txt_mark'])){
                    $T->set_var('imagechk', '');
                    $T->set_var('defaultchk', '');
                    $T->set_var('textchk', $checked);
                    $nt = array(1,2,3,4);
                    if(in_array($W['txt_mark'], $nt)){
                        $T->set_var('txt' . $W['txt_mark'], $selected);
                    } else {
                        $T->set_var('wmtext', COM_stripslashes($W['txt_mark']));
                    }
                }
                $T->set_var('size' . $M['size'], $selected);
                $T->set_var('pos' . $M['position'], $selected);
                $T->set_var('opac' . $M['opacity'], $selected);
            } else {
                $T->set_var('enablewmchk', '');
                $T->set_var('disabled', 'disabled="disabled"');
                $T->set_var('defaultchk', $checked);
            }
        }

    $T->parse('output','page');
    $display = $T->finish($T->get_var('output'));
    return $display;
    }
}

//adds media to album and db
function inm_addMedia($valid){
    global $INM_TABLES, $_FILES, $INM_CONF, $_CONF, $_USER, $LANG_INM08, $LANG_INM07, $LANG_INM01, $LANG_INM11;

    /*
    //  problems that may occur here include:
    //  **max_input_time (default is 60 seconds) may be exceeded
    //    for large or multiple files, or users on slower connections.
    //  **post_max_size (mine is 55M) may be set smaller than your large files.
    //    It should be set larger than upload_max_filesize, which
    //    defaults to 2M.
    //  **upload_max_filesize (default is 2M--mine is 10M) may be exceeded
    //  **memory_limit -- not investigated yet, but must be larger
    //    than post_max_size.
    //  **max_execution_time should not be problem as it does not
    //    include time taken by the upload process.
    //
    //    Solution to all theses issues: use FTP.
    */

    //does album exist?
    if (DB_count($INM_TABLES['albums'], 'id', "{$valid['aid']}") >= 1){

        //get album access and settings
        $result = DB_query("SELECT * FROM {$INM_TABLES['albums']} WHERE id='{$valid['aid']}'" . COM_getPermSQL('and') . " LIMIT 1");
        $A = DB_fetchArray($result);
        //get global settings
        $sendmail = DB_getItem($INM_TABLES['settings'], 'sendmail');

        //if allowed to submit to album
        if ($A['allow_submit'] == '1' || $A['owner_id'] == $_USER['uid'] || SEC_hasRights('inmemoriam.admin')){

            $errors = '0';
            $successes = '0';
            $notuploaded = $LANG_INM07[2] . LB . '<br /><ul>' . LB;
            //$i = 0;
            //foreach ($_FILES['newmedia']]['name'] as $key => $value){
            for($i = 0; $i < count($_FILES['newmedia']['tmp_name']); $i++){
                if ((($A['owner_id'] == $_USER['uid'] || SEC_hasRights('inmemoriam.admin')) && $i > 0) || $i == 0){

                    $filename = trim(strtolower($_FILES['newmedia']['name'][$i]));
                    if (!empty($filename)){

                        // check if filename exists in specified album
                        $result = DB_query("SELECT mid FROM {$INM_TABLES['media']} WHERE aid='{$valid['aid']}' AND filename='$filename'");
                        if(DB_numRows($result) >= 1){

                            //log file exists and move to next file
                            $errors++;
                            $notuploaded .= '<li><b>' . $filename . '</b>: ' . $LANG_INM07[3] . '</li>';
                        } else {
                            //vars to upload class
                            $newfiles = new inmUpload;
                            $newfiles->temp_file_name = trim($_FILES['newmedia']['tmp_name'][$i]);
                            $newfiles->file_name = $filename;
                            $newfiles->upload_dir = $A['path'];
                            $newfiles->upload_log_dir = $INM_CONF['path_logs'];
                            $newfiles->max_file_size = $A['max_filesize'];
                            $allowable_extensions = array();
                            if ($A['enable_image'] == 1){
                                array_merge($allowable_extensions, $INM_CONF['image_ext']);
                            }
                            if ($A['enable_audio'] == 1){
                                array_merge($allowable_extensions, $INM_CONF['aud_ext']);
                            }
                            if ($A['enable_video'] == 1){
                                array_merge($allowable_extensions, $INM_CONF['vid_ext']);
                            }
                            if ($A['enable_code'] == 1){
                                array_merge($allowable_extensions, $INM_CONF['cod_ext']);
                            }
                            $newfiles->ext_array = $allowable_extensions;

                            //validate file
                            $valid_ext = $newfiles->validate_extension();
                            $valid_size = $newfiles->validate_size();
                            $max_size = $newfiles->get_max_size();
                            $file_size = $newfiles->get_file_size();
                            $file_exists = $newfiles->existing_file();

                            if ($file_exists){
                                //check file exists in dir
                                $errors++;
                                $notuploaded .= '<li><b>' . $filename . '</b>: ' . $LANG_INM07[4] . '</li>';
                            } elseif (!$valid_ext){
                                //check extension
                                $errors++;
                                $notuploaded .= '<li><b>' . $filename . '</b>: ' . $LANG_INM07[6] . '</li>';
                            } elseif (!$valid_size){
                                //check filesize
                                $errors++;
                                $notuploaded .= '<li><b>' . $filename . '</b>: ' . sprintf($LANG_INM07[5], $max_size, $file_size) . '</li>';
                            } else {
                                //upload file
                                $uploaded_file = $newfiles->upload_file_with_validation();
                                if (!$uploaded_file){
                                    $errors++;
                                    $notuploaded .= '<li><b>' . $filename . '</b>: ' . $LANG_INM07[7] . '</li>';
                                } else {
                                    //insert data to db
                                    /*
                                    //note:
                                    //mid is auto incrementing
                                    //media type is not supported ATM
                                    */
                                    $sql = "INSERT INTO {$INM_TABLES['media']} SET";
                                    $sql .= " filename='$filename'";
                                    $sql .= ", aid='{$valid['aid']}'";
                                    if ($i == '0'){
                                        //this will only be applied to the first iteration
                                        if (!empty($valid['title'])){
                                            $sql .= ", title='{$valid['title']}'";
                                        }
                                        if (!empty($valid['caption'])){
                                            $sql .= ", caption='{$valid['caption']}'";
                                        }
                                        if (!empty($valid['keywords'])){
                                            $sql .= ", keywords='{$valid['keywords']}'";
                                        }
                                    }
                                    //if ($valid['showcaption'] == '1'){
                                    //    $sql .= ", enable_caption='1'";
                                    //} else $sql .= ", enable_caption='0'";
                                    if ($valid['exif'] == '1'){
                                        $sql .= ", enable_exif='1'";
                                    } else $sql .= ", enable_exif='0'";

                                    $sql .= ", group_id='{$valid['groupid']}', owner_id='{$valid['ownerid']}'";
                                    if(SEC_hasRights('inmemoriam.admin')){
                                        // Convert array values to numeric permission values
                                        list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($valid['perm_owner'],$valid['perm_group'],$valid['perm_members'],$valid['perm_anon']);
                                        $sql .= ", perm_owner='$perm_owner', perm_group='$perm_group', perm_members='$perm_members', perm_anon='$perm_anon'";
                                    }

                                    $sql .= ", date=NOW()";

                                    //to queue or not to queue
                                    if ($A['queue'] == '0' || $A['owner_id'] == $_USER['uid'] || SEC_hasRights('inmemoriam.admin')){
                                        $sql .= ", status='0'";
                                        $status = 0;
                                    } else {
                                        $sql .= ", status='1'";
                                        $status = 1;
                                    }
                                    if($valid['enablewm'] != '1'){
                                        $sql .= ", enable_watermark='0'";
                                    } else {
                                        if ($i == '0'){
                                            //this needs only to be uploaded once
                                            //new or replaced text wm
                                            if ($valid['wmtype'] == 'usetext' && !empty($valid['wmtext'])){
                                                $setwm = "txt_mark='{$valid['wmtext']}'";
                                            //empty text field--use prefab text marks or default text wm
                                            } elseif ($valid['wmtype'] == 'usetext' && empty($valid['wmtext'])){
                                                if (!empty($valid['prefabtext'])){
                                                    $textmark = $valid['prefabtext'];
                                                } else {
                                                    //site name
                                                    $textmark = $LANG_INM01[48] . $_CONF['site_name'];
                                                }
                                                $setwm = "txt_mark='$textmark'";
                                            //default img wm
                                            } elseif ($valid['wmtype'] == 'usedefault'){
                                                $setwm = "img_mark='" . $INM_CONF['default_wm'] . "'";
                                            //empty img field--default img wm
                                            } elseif ($valid['wmtype'] == 'useimage' && empty($_FILES['wmimage']['name'])){
                                                $setwm = "img_mark='" . $INM_CONF['default_wm'] . "'";
                                            //new or replaced img
                                            } elseif ($valid['wmtype'] == 'useimage' && !empty($_FILES['wmimage']['name'])){
                                                $wm = new inmUpload;
                                                $wm->temp_file_name = trim($_FILES['wmimage']['tmp_name']);
                                                $wm->file_name = trim($_FILES['wmimage']['name']);
                                                $wmfilename = $wm->file_name;
                                                $wm->upload_dir = $INM_CONF['path_wm'];
                                                $wm->upload_log_dir = $INM_CONF['path_logs'];
                                                $wm->max_file_size = '65536';
                                                $wm->ext_array = $INM_CONF['wm_ext'];

                                                //validate watermark image
                                                $valid_ext = $wm->validate_extension();
                                                $valid_size = $wm->validate_size();
                                                $max_size = $wm->get_max_size();
                                                $file_size = $wm->get_file_size();
                                                $file_exists = $wm->existing_file();

                                                $errorfile = trim(strtolower($_FILES['wmimage']['name']));
                                                if ($file_exists){
                                                    //check file exists in dir
                                                    $errors++;
                                                    $notuploaded .= '<li>' . $errorfile . ': ' . $LANG_INM07[4] . '</li>';
                                                } elseif (!$valid_size){
                                                    //check filesize
                                                    $errors++;
                                                    $notuploaded .= '<li>' . $errorfile . ': ' . sprintf($LANG_INM07[5], $max_size, $file_size) . '</li>';
                                                } elseif (!$valid_ext){
                                                    //check extension
                                                    $errors++;
                                                    $notuploaded .= '<li>' . $errorfile . ': ' . $LANG_INM07[6] . '</li>';
                                                } else {
                                                    //upload file
                                                    $uploaded_file = $wm->upload_file_with_validation();
                                                    if (!$uploaded_file){
                                                        $errors++;
                                                        $notuploaded .= '<li>' . $errorfile . ': ' . $LANG_INM07[7] . '</li>';
                                                    } else {
                                                        //add watermark to db
                                                        $setwm = "img_mark='$wmfilename'";
                                                    }
                                                }
                                            }

                                            //store watermark
                                            //wid is auto incrementing
                                            DB_query("INSERT INTO {$INM_TABLES['watermarks']} SET " . $setwm);
                                            //this is gathered on the 1st loop and the only loop for wm's
                                            $wid = DB_insertId();
                                        }
                                        //but this need to be applied to all images
                                        if(!empty($wid)){
                                            $sql .= ", wid='$wid', enable_watermark='1', size='{$valid['size']}', position='{$valid['position']}', opacity='{$valid['opacity']}'";
                                        }
                                    }
                                    //finally insert new media to db
                                    DB_query($sql);
                                    $mid = DB_insertID();
                                    $newMediaUploaded = true;
                                    $midA[] = $mid;
                                    $filenameA[] = $filename;

                                    //update last_add field in current album
                                    DB_query("UPDATE {$INM_TABLES['albums']} SET date_lastadd=NOW() WHERE id='{$valid['aid']}'");

                                    $successes++;
                                }
                            }
                        }
                    } else {
                        //no file specified
                        $errors++;
                        $notuploaded .= '<li><b>' . $LANG_INM07[8] . '</b></li>';
                    }
                }
            }

            //update watermark status on other media same album if necessary
            if ($valid['apptoall'] == '1' && ($A['owner_id'] == $_USER['uid'] || SEC_hasRights('inmemoriam.admin'))) {
                $result = DB_query("SELECT DISTINCT wid FROM {$INM_TABLES['media']} WHERE aid='{$valid['aid']}' AND wid<>'$wid'");
                while($widA = DB_fetchArray($result)){
                    $obselete = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$widA['wid']}'");
                    $used = DB_query("SELECT m.wid FROM {$INM_TABLES['media']} m, {$INM_TABLES['watermarks']} w WHERE m.aid<>'{$valid['aid']}' AND w.img_mark='$obselete'");
                    if (!empty($obselete) && DB_numRows($used) < 1){
                        //delete other watermarks this album
                        if (!empty($obselete) && $obselete != $INM_CONF['default_wm']){
                            $obselete = $INM_CONF['path_wm'] . $obselete;
                            if (!file_exists($obselete) || !@unlink($obselete)){
                                $errors++;
                                $notuploaded .= '<li>' . $LANG_INM08[56] . '</li>';
                            }
                        }
                        //remove wm from database
                        DB_delete($INM_TABLES['watermarks'], 'wid', "{$widA['wid']}");
                    }
                }
                DB_query("UPDATE {$INM_TABLES['media']} SET wid='$wid', enable_watermark='1', size='{$valid['size']}', position='{$valid['position']}', opacity='{$valid['opacity']}' WHERE aid='{$valid['aid']}'");

            //update watermark status on other media all albums if necessary
            } elseif ($valid['apptoall'] == '2' && ($A['owner_id'] == $_USER['uid'] || SEC_hasRights('inmemoriam.admin'))){
                $result = DB_query("SELECT DISTINCT wid FROM {$INM_TABLES['media']} WHERE wid<>'$wid'");
                while($widA = DB_fetchArray($result)){
                    $obselete = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$widA['wid']}'");
                    //delete image watermarks from server all albums
                    if (!empty($obselete) && $obselete != $INM_CONF['default_wm']){
                        $obselete = $INM_CONF['path_wm'] . $obselete;
                        if (!file_exists($obselete) || !@unlink($obselete)){
                            $errors++;
                            $notuploaded .= '<li>' . $LANG_INM08[56] . '</li>';
                        }
                    }
                    //remove wm from database
                    DB_delete($INM_TABLES['watermarks'], 'wid', "{$widA['wid']}");
                }
                //apply new wm to all media
                DB_query("UPDATE {$INM_TABLES['media']} SET wid='$wid', enable_watermark='1', size='{$valid['size']}', position='{$valid['position']}', opacity='{$valid['opacity']}'");
            }

            //conclude
            if ($errors >= 1){
                $notuploaded .= '</ul>';
            } else $notuploaded = '';
            $message = sprintf($LANG_INM07[1], $errors, $successes, $valid['aid']);
            $message = '<br />' . $message . '<br /><br />' . $notuploaded;

            if ($status == '1' && $errors < 1){
                //return approval pending
                $summary = $LANG_INM08[62];
            } elseif ($status == '0'){
                foreach($midA as $value){
                    $summary .= inm_showMediaSumm($value) . '<br />';
                }
            }
            $retval = $message . $summary;

            //notify admin that media has been submitted/submitted and awaits approval
            if ($newMediaUploaded && $sendmail == '1'){
                //$to = COM_formatEmailAddress ($LANG_INM11[12], $_CONF['site_mail']);
                $to = $_CONF['site_mail'];
                $subject = $LANG_INM11[16];
                $body .= $LANG_INM11[17];
                $body .= "<br><br>";
                if ($status == '1'){
                    $body .= $LANG_INM11[18] . "<br>";
                } else {
                    $body .= $LANG_INM11[21] . "<br>";
                }
                if (is_array($midA) && !empty($midA[0])){
                    foreach ($midA as $key => $value){
                        if($status == '1'){
                            $body .= sprintf($LANG_INM11[20], $filenameA[$key], $value) . "<br>";
                        } elseif ($status == '0'){
                            $body .= sprintf($LANG_INM11[22], $filenameA[$key], $value) . "<br>";
                        }
                    }
                }
                $body .= "<br>";
                $gldate = COM_getUserDateTimeFormat();
                $body .= sprintf($LANG_INM11[19], $gldate[0], inm_prflink($valid['ownerid'])) . "<br>";
                $body .= $_CONF['site_name'] . "<br>";
                $body .= '<a href="'.$_CONF['site_url'].'">'.$_CONF['site_url'].'</a><br>';
                //change $from to suit your gallery moderator email address
                $from = COM_formatEmailAddress ($LANG_INM11[12], $_CONF['site_mail']);
                COM_mail($to,$subject,$body,$from,true);
            }

            return $retval;
        } else {
            //this should never happen unless the form source has been edited--by cheaters
            //return not allowed to add to this album
            return $LANG_INM08[47];
        }
    } else {
        //return album doesn't exist
        return $LANG_INM08[47];
    }
}

//delete media from album and db
function inm_deleteMedia($mid){
    global $INM_TABLES, $LANG_INM08, $LANG_INM03, $INM_CONF;

    //check access
    if (!empty($mid)){
        $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE mid='$mid' LIMIT 1");
        if (DB_numRows($result) < 1){
            //no media exists by that id
            //but let's shoot a msg and log the attempt
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[13];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally delete not extant media: $mid.");
            return $display;
        }
        $M = DB_fetchArray($result);
        $access = inm_hasMediaAccess($mid);
        if (empty($access) || $access < 3) {
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[13];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally delete media: $mid.");
            return $display;
        }
    }
    if ($access == 3){
        $path = DB_getItem($INM_TABLES['albums'], 'path', "id='{$M['aid']}'");
        $path = $path . $M['filename'];
        //unlink media
        if (!file_exists($path) || !@unlink($path)){
            //halt process
            return sprintf($LANG_INM08[55], stripslashes($M['filename']));
        } else {
            //unlink associated watermark if not being used otherwise
            if (!empty($M['wid'])){
                $used = DB_count($INM_TABLES['media'], 'wid', "{$M['wid']}");
                if ($used == 1){
                    $wmimg = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$M['wid']}'");
                    if (!empty($wmimg) && $wmimg != $INM_CONF['default_wm']){
                        $wmpath = $INM_CONF['path_wm'] . $wmimg;
                        if (!file_exists($wmpath) || !@unlink($wmpath)){
                            $error = $LANG_INM08[56];
                        }
                    }
                    //remove wm from database
                    DB_delete($INM_TABLES['watermarks'], 'wid', "{$M['wid']}");
                }
            }

            //remove associated comments from database
            //DB_delete($INM_TABLES['comments'], 'mid', "{$B['mid']}");

            //delete static images
            inm_deleteStatic($mid,'media');
            //delete favorite
            inm_deleteFav($mid);
            //remove media from database
            DB_delete($INM_TABLES['media'], 'mid', "{$M['mid']}");
            return $LANG_INM08[57] . $error;
        }
    }
}

//updates extant media
function inm_updateMedia($valid){
    global $INM_TABLES, $LANG_INM08, $LANG_INM07, $LANG_INM03, $LANG_INM01, $INM_CONF, $_CONF, $_FILES, $_USER;
//return print_r($valid);
    //check access
    if (!empty($valid['oldmid'])){
        $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE mid='{$valid['oldmid']}' LIMIT 1");
        if (DB_numRows($result) < 1){
            //no media exists by that id
            //but let's shoot a msg and log the attempt
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[13];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally edit not extant media: {$valid['oldmid']}.");
            return $display;
        }
        $access = inm_hasMediaAccess($valid['oldmid']);
        if (empty($access) || $access < 3) {
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[13];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally delete media: {$valid['mid']}.");
            return $display;
        }
        $M = DB_fetchArray($result);
        $aresult = DB_query("SELECT path, owner_id FROM {$INM_TABLES['albums']} WHERE id='{$valid['aid']}'");
        list($A['path'],$A['owner_id']) = DB_fetchArray($aresult);
    }
    if ($access == 3){
        $update = "UPDATE {$INM_TABLES['media']} SET";
        $update .= " title='{$valid['title']}', caption='{$valid['caption']}', keywords='{$valid['keywords']}'";
        $update .= ", enable_exif='{$valid['exif']}'";

        if (!empty($valid['newalbum']) && is_numeric($valid['newalbum'])){
            $newalbumaccess = inm_hasAlbumAccess($valid['newalbum']);
            //reassign media on server
            $newpath = DB_getItem($INM_TABLES['albums'], 'path', "id='{$valid['newalbum']}'");
            $newpathf = $newpath . $M['filename'];
            if(!@file_exists($newpathf) || $newalbumaccess < 3){
                if(!@rename($A['path'] . $M['filename'], $newpathf)){
                    //return error
                    $movemedia = sprintf($LANG_INM08[72], $newpath) . '<br />';
                } else {
                    $update .= ", aid='{$valid['newalbum']}'";
                    $addednew = 1;
                }
            } else {
                //return msg: couldn't move file, file exists or no access
                $movemedia = sprintf($LANG_INM08[71], $M['filename']) . '<br />';
            }
        }
        $update .= ", group_id='{$valid['groupid']}', owner_id='{$valid['ownerid']}'";
        if(SEC_hasRights('inmemoriam.admin')){
            // Convert array values to numeric permission values
            list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($valid['perm_owner'],$valid['perm_group'],$valid['perm_members'],$valid['perm_anon']);
            $update .= ", perm_owner='$perm_owner', perm_group='$perm_group', perm_members='$perm_members', perm_anon='$perm_anon'";
        }

        if ($valid['enablewm'] == 1){
            $errors = 0;
            $notuploaded = '<ul>';
            //replaced or unchanged wid
            if (!empty($M['wid'])){
                $wmupdate = "UPDATE {$INM_TABLES['watermarks']} SET";
                $where = " WHERE wid='{$M['wid']}'";
            } else {
                $wmupdate = "INSERT INTO {$INM_TABLES['watermarks']} SET";
                $where = '';
            }
            //new or replaced text wm
            if ($valid['wmtype'] == 'usetext' && !empty($valid['wmtext'])){
                $wmupdate .= " txt_mark='{$valid['wmtext']}', img_mark=''";
            //empty text field--use prefab text marks or default text wm
            } elseif ($valid['wmtype'] == 'usetext' && empty($valid['wmtext'])){
                if (!empty($valid['prefabtext'])){
                    $textmark = $valid['prefabtext'];
                } else {
                    //site name
                    $textmark = $LANG_INM01[48] . $_CONF['site_name'];
                }
                $wmupdate .= " txt_mark='$textmark', img_mark=''";
            //default img wm
            } elseif ($valid['wmtype'] == 'usedefault'){
                $wmupdate .= " img_mark='" . $INM_CONF['default_wm'] . "', txt_mark=''";
            //empty img field--default img wm
            } elseif ($valid['wmtype'] == 'useimage' && empty($_FILES['wmimage']['name'])){
                $wmupdate .= " img_mark='" . $INM_CONF['default_wm'] . "', txt_mark=''";
                $errors++;
                $notuploaded .= '<li>' . $LANG_INM07[9] . '</li>';
            //new or replaced img
            } elseif ($valid['wmtype'] == 'useimage' && !empty($_FILES['wmimage']['name'])){
                //unlink old image if any
                $used = DB_count($INM_TABLES['media'], 'wid', "{$M['wid']}");
                if ($used == 1){
                    $presentwm = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$M['wid']}'");
                    if (!empty($presentwm) && $presentwm != $INM_CONF['default_wm']){
                        $wmpath = $INM_CONF['path_wm'] . $presentwm;
                        if (!file_exists($wmpath) || !@unlink($wmpath)){
                            $errors++;
                            $notuploaded .= '<li>' . $presentwm . ': ' . $LANG_INM07[10] . '</li>';
                        }
                    }
                }
                $wm = new inmUpload;
                $wm->temp_file_name = trim($_FILES['wmimage']['tmp_name']);
                $wm->file_name = trim($_FILES['wmimage']['name']);
                $wm->upload_dir = $INM_CONF['path_wm'];
                $wm->upload_log_dir = $INM_CONF['path_logs'];
                $wm->max_file_size = '65536';
                $wm->ext_array = $INM_CONF['wm_ext'];

                //validate watermark image
                $valid_ext = $wm->validate_extension();
                $valid_size = $wm->validate_size();
                $max_size = $wm->get_max_size();
                $file_size = $wm->get_file_size();
                $file_exists = $wm->existing_file();

                $errorfile = trim(strtolower($_FILES['wmimage']['name']));
                if ($file_exists){
                    //check file exists in dir
                    $errors++;
                    $notuploaded .= '<li>' . $errorfile . ': ' . $LANG_INM07[4] . '</li>';
                } elseif (!$valid_size){
                    //check filesize
                    $errors++;
                    $notuploaded .= '<li>' . $errorfile . ': ' . sprintf($LANG_INM07[5], $max_size, $file_size) . '</li>';
                } elseif (!$valid_ext){
                    //check extension
                    $errors++;
                    $notuploaded .= '<li>' . $errorfile . ': ' . $LANG_INM07[6] . '</li>';
                } else {
                    //upload file
                    $uploaded_file = $wm->upload_file_with_validation();
                    if (!$uploaded_file){
                        $errors++;
                        $notuploaded .= '<li>' . $errorfile . ': ' . $LANG_INM07[7] . '</li>';
                    } else {
                        //add watermark to db
                        //$wmupdate .= " img_mark='$wmfilename',";
                        $wmupdate .= " img_mark='$errorfile', txt_mark=''";
                    }
                }
            }

            //store watermark
            DB_query($wmupdate . $where);
            if (empty($where)){
                //new wm so new id
                //wid is auto incrementing
                $wid = DB_insertId();
                if (!empty($wid)){
                    $update .= ", wid='$wid', enable_watermark='1', size='{$valid['size']}', position='{$valid['position']}', opacity='{$valid['opacity']}'";
                }
            } else {
                //only enabling wm not changing wid
                $update .= ", enable_watermark='1', size='{$valid['size']}', position='{$valid['position']}', opacity='{$valid['opacity']}'";
                $wid = $M['wid'];
            }

            //update watermark status on other media same album if necessary
            if ($valid['apptoall'] == '1' && ($A['owner_id'] == $_USER['uid'] || SEC_hasRights('inmemoriam.admin'))) {
                $result = DB_query("SELECT DISTINCT wid FROM {$INM_TABLES['media']} WHERE aid='{$valid['aid']}' AND wid<>'$wid'");
                while($widA = DB_fetchArray($result)){
                    $obselete = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$widA['wid']}'");
                    $used = DB_query("SELECT m.wid FROM {$INM_TABLES['media']} m, {$INM_TABLES['watermarks']} w WHERE m.aid<>'{$valid['aid']}' AND w.img_mark='$obselete'");
                    if (!empty($obselete) && DB_numRows($used) < 1){
                        //delete other watermarks this album
                        if (!empty($obselete) && $obselete != $INM_CONF['default_wm']){
                            $obselete = $INM_CONF['path_wm'] . $obselete;
                            if (!file_exists($obselete) || !@unlink($obselete)){
                                $errors++;
                                $notuploaded .= '<li>' . $LANG_INM08[56] . '</li>';
                            }
                        }
                        //remove wm from database
                        DB_delete($INM_TABLES['watermarks'], 'wid', "{$widA['wid']}");
                    }
                }
                DB_query("UPDATE {$INM_TABLES['media']} SET wid='$wid', enable_watermark='1', size='{$valid['size']}', position='{$valid['position']}', opacity='{$valid['opacity']}' WHERE aid='{$valid['aid']}' AND mid<>'{$valid['oldmid']}'");

            //update watermark status on other media all albums if necessary
            } elseif ($valid['apptoall'] == '2' && ($A['owner_id'] == $_USER['uid'] || SEC_hasRights('inmemoriam.admin'))){
                $result = DB_query("SELECT DISTINCT wid FROM {$INM_TABLES['media']} WHERE wid<>'$wid'");
                while($widA = DB_fetchArray($result)){
                    $obselete = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$widA['wid']}'");
                    //delete image watermarks from server all albums
                    if (!empty($obselete) && $obselete != $INM_CONF['default_wm']){
                        $obselete = $INM_CONF['path_wm'] . $obselete;
                        if (!file_exists($obselete) || !@unlink($obselete)){
                            $errors++;
                            $notuploaded .= '<li>' . $LANG_INM08[56] . '</li>';
                        }
                    }
                    //remove wm from database
                    DB_delete($INM_TABLES['watermarks'], 'wid', "{$widA['wid']}");
                }
                //apply new wm to all media
                DB_query("UPDATE {$INM_TABLES['media']} SET wid='$wid', enable_watermark='1', size='{$valid['size']}', position='{$valid['position']}', opacity='{$valid['opacity']}' WHERE mid<>'{$valid['oldmid']}'");
            }

        } elseif (empty($valid['enablewm']) && !empty($M['wid'])){
            //disable watermark--this means remove watermark from server and db
            $used = DB_count($INM_TABLES['media'], 'wid', "{$M['wid']}");
            if ($used == 1){
                $wmimg = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$M['wid']}'");
                if (!empty($wmimg) && $wmimg != $INM_CONF['default_wm']){
                    $wmpath = $INM_CONF['path_wm'] . $wmimg;
                    if (!file_exists($wmpath) || !@unlink($wmpath)){
                        $errors++;
                        $notuploaded .= '<li>' . $LANG_INM08[56] . '</li>';
                    }
                }
                //remove wm from database
                DB_delete($INM_TABLES['watermarks'], 'wid', "{$M['wid']}");
            }
            $update .= ", wid='', enable_watermark='', size='', position='', opacity=''";
        }
        //update media in db
        $update = $update . " WHERE mid='{$valid['oldmid']}'";
        DB_query($update);
        if($addednew == 1){
            //update last_add field in current album
            DB_query("UPDATE {$INM_TABLES['albums']} SET date_lastadd=NOW() WHERE id='{$valid['newalbum']}'");
        }
        if ($errors >= 1){
            $notuploaded = '<br />' . $LANG_INM08[60] . LB . $notuploaded . '</ul>';
        }

        $success = $LANG_INM08[59] . '<br />' . $movemedia . $notuploaded;
        $retval = $success . inm_showMediaSumm($valid['oldmid']);
        return $retval;
    }
}

/* 
* Main Function
*/

$pagetitle = $LANG_INM01[11] . $LANG_INM01[12];
$display = inm_siteHeader($pagetitle);

$albums = DB_query("SELECT id FROM {$INM_TABLES['albums']} LIMIT 1");
if (DB_numRows($albums) < 1){
    //no albums so give a link
    $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
    $display .= inm_menurow();
    $display .= inm_showintro(sprintf($LANG_INM06[78], $INM_CONF['url_html'] . '/albums.php'));
    $display .= COM_endBlock();
    $display .= inm_siteFooter();
    echo $display;
    exit;
}


$display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
$display .= inm_menurow();
if (!empty($_GET['mid']) || !empty($_GET['id'])){
    $valid = inm_validateInput('get');
    $display .= inm_showintro($LANG_INM02[1]);
    $display .= COM_endBlock();

    //display media editor
    $display .= COM_startBlock($LANG_INM08[2]);
    $display .= inm_mediaEditor($valid);
} elseif (isset($_POST['submit']) && !empty($_POST['oldmid'])){
    $valid = inm_validateInput('media');
    if (!is_array($valid)){
        //input validation error
        $display .= COM_endBlock();
        $display .= COM_startBlock($LANG_INM04[2]);
        $display .= $valid;
    } else {
        switch ($valid['submit']){
            case $LANG_INM08[52]:
                //update mid
                $display .= inm_showintro();
                $display .= COM_endBlock();
                $display .= COM_startBlock($LANG_INM08[46]);
                $display .= inm_updateMedia($valid);
                break;
            case $LANG_INM08[17]:
                //delete mid
                $display .= inm_showintro();
                $display .= COM_endBlock();
                $display .= COM_startBlock($LANG_INM08[51]);
                $display .= inm_deleteMedia($valid['oldmid']);
                break;
            case $LANG_INM08[18]:
                //cancels operation
                //refresh to index.php
            default:
                //refresh to index.php
                $display = COM_refresh($INM_CONF['url_html'] . '/index.php');
                echo $display;
                exit;
        }
    }
} elseif (isset($_POST['submit']) && !empty($_POST['newmid'])){
    //add new mid
    $valid = inm_validateInput('media');
    $display .= inm_showintro();
    if (is_array($valid)){
        $display .= COM_endBlock();
        $display .= COM_startBlock($LANG_INM08[48]);
        $display .= inm_addMedia($valid);
    } else {
        //input validation error
        $display .= COM_endBlock();
        $display .= COM_startBlock($LANG_INM04[2]);
        $display .= $valid;
    }
} else {
    $display .= inm_showintro($LANG_INM02[1]);
    $display .= COM_endBlock();
    //display media editor
    $display .= COM_startBlock($LANG_INM08[2]);
    $display .= inm_mediaEditor();
}

$display .= COM_endBlock();
$display .= inm_poweredBy();
$display .= inm_siteFooter();
echo $display;
?>