<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | queue.php                                                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Retrieve access settings
$result = DB_query("SELECT logincreate FROM {$INM_TABLES['settings']}");
list($logincreate) = DB_fetchArray($result);

// Check user has rights to access this page
if (SEC_hasRights('inmemoriam.create') || SEC_hasRights('inmemoriam.admin')){
    //allow
} elseif ($_USER['uid'] < 2 || ($_USER['uid'] >= 2 && $logincreate != 1) || $_GET['status'] != '1'){
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the inmemoriam page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_INM00['access_denied']);
    $display .= $LANG_INM00['access_denied_msg1'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}



//delete media from album and db
function inm_deleteMedia($mid){
    global $INM_TABLES, $LANG_INM08, $LANG_INM03, $INM_CONF;

    //check access
    if (!empty($mid)){
        $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE mid='$mid' LIMIT 1");
        if (DB_numRows($result) < 1){
            //no media exists by that id
            //but let's shoot a msg and log the attempt
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[13];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally delete not extant media: $mid.");
            return $display;
        }
        $M = DB_fetchArray($result);
        $access = inm_hasMediaAccess($mid);
        if (empty($access) || $access < 3) {
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[13];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally delete media: $mid.");
            return $display;
        }
    }
    if ($access == 3){
        $path = DB_getItem($INM_TABLES['albums'], 'path', "id='{$M['aid']}'");
        $path = $path . $M['filename'];
        //unlink media
        if (!file_exists($path) || !@unlink($path)){
            //halt process
            return sprintf($LANG_INM08[55], stripslashes($M['filename']));
        } else {
            //unlink associated watermark if not being used otherwise
            if (!empty($M['wid'])){
                $used = DB_count($INM_TABLES['media'], 'wid', "{$M['wid']}");
                if ($used == 1){
                    $wmimg = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$M['wid']}'");
                    if (!empty($wmimg) && $wmimg != $INM_CONF['default_wm']){
                        $wmpath = $INM_CONF['path_wm'] . $wmimg;
                        if (!file_exists($wmpath) || !@unlink($wmpath)){
                            $error = $LANG_INM08[56];
                        }
                    }
                    //remove wm from database
                    DB_delete($INM_TABLES['watermarks'], 'wid', "{$M['wid']}");
                }
            }

            //remove associated comments from database
            //DB_delete($INM_TABLES['comments'], 'mid', "{$B['mid']}");

            //remove media from database
            DB_delete($INM_TABLES['media'], 'mid', "{$M['mid']}");
            return $LANG_INM08[57] . $error;
        }
    }
}

//updates extant media
function inm_updateMedia($valid){
    global $INM_TABLES, $LANG_INM08, $LANG_INM07, $LANG_INM03, $LANG_INM01, $LANG_INM11, $INM_CONF, $_CONF, $_FILES, $_TABLES;

    //check access
    if (!empty($valid['oldmid'])){
        $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE mid='{$valid['oldmid']}' LIMIT 1");
        if (DB_numRows($result) < 1){
            //no media exists by that id
            //but let's shoot a msg and log the attempt
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[13];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally edit not extant media: {$valid['oldmid']}.");
            return $display;
        }
        $access = inm_hasMediaAccess($valid['oldmid']);
        if (empty($access) || $access < 3) {
            $display = COM_startBlock($LANG_INM03[10], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
            $display .= $LANG_INM03[13];
            $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally delete media: {$valid['mid']}.");
            return $display;
        }
        $M = DB_fetchArray($result);
        $aresult = DB_query("SELECT path, owner_id FROM {$INM_TABLES['albums']} WHERE id='{$valid['aid']}'");
        list($A['path'],$A['owner_id']) = DB_fetchArray($aresult);
    }
    if ($access == 3){
        $update = "UPDATE {$INM_TABLES['media']} SET";
        $update .= " title='{$valid['title']}', caption='{$valid['caption']}', keywords='{$valid['keywords']}'";
        $update .= ", enable_exif='{$valid['exif']}', status='0'";
        if (!empty($valid['newalbum']) && is_numeric($valid['newalbum'])){
            $newalbumaccess = inm_hasAlbumAccess($valid['newalbum']);
            //reassign media on server
            $newpath = DB_getItem($INM_TABLES['albums'], 'path', "id='{$valid['newalbum']}'");
            $newpathf = $newpath . $M['filename'];
            if(!@file_exists($newpathf) || $newalbumaccess < 3){
                if(!@rename($A['path'] . $M['filename'], $newpathf)){
                    //return error
                    $movemedia = sprintf($LANG_INM08[72], $newpath) . '<br />';
                } else {
                    $update .= ", aid='{$valid['newalbum']}'";
                    $addednew = 1;//for later
                }
            } else {
                //return msg: couldn't move file, file exists or no access
                $movemedia = sprintf($LANG_INM08[71], $M['filename']) . '<br />';
            }
        }

        // Convert array values to numeric permission values
        list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($valid['perm_owner'],$valid['perm_group'],$valid['perm_members'],$valid['perm_anon']);
        $update .= ", perm_owner='$perm_owner', perm_group='$perm_group', perm_members='$perm_members', perm_anon='$perm_anon'";
        $update .= ", group_id='{$valid['groupid']}', owner_id='{$valid['ownerid']}'";

        if ($valid['enablewm'] == 1){
            $errors = 0;
            $notuploaded = '<ul>';
            //replaced or unchanged wid
            if (!empty($M['wid'])){
                $wmupdate = "UPDATE {$INM_TABLES['watermarks']} SET";
                $where = " WHERE wid='{$M['wid']}'";
            } else {
                $wmupdate = "INSERT INTO {$INM_TABLES['watermarks']} SET";
                $where = '';
            }
            //new or replaced text wm
            if ($valid['wmtype'] == 'usetext' && !empty($valid['wmtext'])){
                $wmupdate .= " txt_mark='{$valid['wmtext']}', img_mark=''";
            //empty text field--use prefab text marks or default text wm
            } elseif ($valid['wmtype'] == 'usetext' && empty($valid['wmtext'])){
                if (!empty($valid['prefabtext'])){
                    $textmark = $valid['prefabtext'];
                } else {
                    //site name
                    $textmark = $LANG_INM01[48] . $_CONF['site_name'];
                }
                $wmupdate .= " txt_mark='$textmark', img_mark=''";
            //default img wm
            } elseif ($valid['wmtype'] == 'usedefault'){
                $wmupdate .= " img_mark='" . $INM_CONF['default_wm'] . "', txt_mark=''";
            //empty img field--default img wm
            } elseif ($valid['wmtype'] == 'useimage' && empty($_FILES['wmimage']['name'])){
                $wmupdate .= " img_mark='wm_inmemoriam.png', txt_mark=''";
                $errors++;
                $notuploaded .= '<li>' . $LANG_INM07[9] . '</li>';
            //new or replaced img
            } elseif ($valid['wmtype'] == 'useimage' && !empty($_FILES['wmimage']['name'])){
                //unlink old image if any
                $used = DB_count($INM_TABLES['media'], 'wid', "{$M['wid']}");
                if ($used == 1){
                    $presentwm = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$M['wid']}'");
                    if (!empty($presentwm) && $presentwm != $INM_CONF['default_wm']){
                        $wmpath = $INM_CONF['path_wm'] . $presentwm;
                        if (!file_exists($wmpath) || !@unlink($wmpath)){
                            $errors++;
                            $notuploaded .= '<li>' . $presentwm . ': ' . $LANG_INM07[10] . '</li>';
                        }
                    }
                }
                $wm = new inmUpload;
                $wm->temp_file_name = trim($_FILES['wmimage']['tmp_name']);
                //$wmfilename = date( 'YmdHis' );
                //$wmfilename = 'wm_' . $wmfilename . '.png';
                //$wm->file_name = $wmfilename;
                $wm->file_name = trim($_FILES['wmimage']['name']);
                $wm->upload_dir = $INM_CONF['path_wm'];
                $wm->upload_log_dir = $INM_CONF['path_logs'];
                $wm->max_file_size = '65536';
                $wm->ext_array = $INM_CONF['wm_ext'];

                //validate watermark image
                $valid_ext = $wm->validate_extension();
                $valid_size = $wm->validate_size();
                $max_size = $wm->get_max_size();
                $file_size = $wm->get_file_size();
                $file_exists = $wm->existing_file();

                $errorfile = trim(strtolower($_FILES['wmimage']['name']));
                if ($file_exists){
                    //check file exists in dir
                    $errors++;
                    $notuploaded .= '<li>' . $errorfile . ': ' . $LANG_INM07[4] . '</li>';
                } elseif (!$valid_size){
                    //check filesize
                    $errors++;
                    $notuploaded .= '<li>' . $errorfile . ': ' . sprintf($LANG_INM07[5], $max_size, $file_size) . '</li>';
                } elseif (!$valid_ext){
                    //check extension
                    $errors++;
                    $notuploaded .= '<li>' . $errorfile . ': ' . $LANG_INM07[6] . '</li>';
                } else {
                    //upload file
                    $uploaded_file = $wm->upload_file_with_validation();
                    if (!$uploaded_file){
                        $errors++;
                        $notuploaded .= '<li>' . $errorfile . ': ' . $LANG_INM07[7] . '</li>';
                    } else {
                        //add watermark to db
                        //$wmupdate .= " img_mark='$wmfilename',";
                        $wmupdate .= " img_mark='$errorfile', txt_mark=''";
                    }
                }
            }

            //store watermark
            DB_query($wmupdate . $where);
            if (empty($where)){
                //new wm so new id
                //wid is auto incrementing
                $wid = DB_insertId();
                if (!empty($wid)){
                    $update .= ", wid='$wid', enable_watermark='1', size='{$valid['size']}', position='{$valid['position']}', opacity='{$valid['opacity']}'";
                }
            } else {
                //only enabling wm not changing wid
                $update .= ", enable_watermark='1', size='{$valid['size']}', position='{$valid['position']}', opacity='{$valid['opacity']}'";
            }

            //$valid['apptoall'] should never show up here if the process came thru the queue
            // so it is left out and wm is not applied to any other media

        } elseif (empty($valid['enablewm']) && !empty($M['wid'])){
            //disable watermark--this means remove watermark from server and db
            $used = DB_count($INM_TABLES['media'], 'wid', "{$M['wid']}");
            if ($used == 1){
                $wmimg = DB_getItem($INM_TABLES['watermarks'], 'img_mark', "wid='{$M['wid']}'");
                if (!empty($wmimg) && $wmimg != $INM_CONF['default_wm']){
                    $wmpath = $INM_CONF['path_wm'] . $wmimg;
                    if (!file_exists($wmpath) || !@unlink($wmpath)){
                        $errors++;
                        $notuploaded .= '<li>' . $LANG_INM08[56] . '</li>';
                    }
                }
                //remove wm from database
                DB_delete($INM_TABLES['watermarks'], 'wid', "{$M['wid']}");
            }
            $update .= ", wid='', enable_watermark='', size='', position='', opacity=''";
        }
        //update media in db
        $update = $update . " WHERE mid='{$valid['oldmid']}'";
        DB_query($update);
        if($addednew == 1){
            //update last_add field in current album
            DB_query("UPDATE {$INM_TABLES['albums']} SET date_lastadd=NOW() WHERE id='{$valid['newalbum']}'");
        }
        if ($errors >= 1){
            $notuploaded = '<br />' . $LANG_INM08[60] . LB . $notuploaded . '</ul>';
        }

        $sendmail = DB_getItem($INM_TABLES['settings'], 'sendmail');
        if ($sendmail == '1'){
            $result = DB_query("SELECT username, fullname, email FROM {$_TABLES['users']} WHERE uid='{$valid['ownerid']}'");
            list($username,$fullname,$email) = DB_fetchArray($result);
            //notify contributor that media has been approved
            //$to = COM_formatEmailAddress ($username, $email);
            $to = $email;
            $subject = $LANG_INM11[13];
            $body .= $LANG_INM11[15];
            $body .= "<br><br>";
            $body .= sprintf($LANG_INM11[14], $M['filename'], $valid['oldmid'], $valid['oldmid']);
            $body .= "<br><br>";
            $body .= $_CONF['site_name'] . "<br>";
            $body .= $_CONF['site_url'] . "<br>";
            //change $from to suit your gallery moderator email address
            $from = COM_formatEmailAddress ($LANG_INM11[12], $_CONF['site_mail']);
            if (!COM_mail($to,$subject,$body,$from,true)){
                $notified = $LANG_INM11[11];
            } else {
                $notified = $LANG_INM11[10];
            }
        }

        $success = $LANG_INM08[59] . '<br />' . $movemedia . $notuploaded . '<br />' . $notified;
        return $success;
    }
}

function inm_approveMedia($mid){
    global $INM_TABLES, $LANG_INM11, $_CONF, $_TABLES;

    //is exist media
    $extant = DB_getItem($INM_TABLES['media'], 'status', "mid='$mid'");
    if ($extant != 1 || empty($extant)){
        return $LANG_INM11[7];
    }
    DB_query("UPDATE {$INM_TABLES['media']} SET status='0' WHERE mid='$mid'");

    $sendmail = DB_getItem($INM_TABLES['settings'], 'sendmail');
    if ($sendmail == '1'){
        $result = DB_query("SELECT filename, title, owner_id FROM {$INM_TABLES['media']} WHERE mid='$mid'");
        list($filename, $title, $owner_id) = DB_fetchArray($result);
        $result = DB_query("SELECT username, fullname, email FROM {$_TABLES['users']} WHERE uid='$owner_id'");
        list($username,$fullname,$email) = DB_fetchArray($result);

        //notify contributor that media has been approved
        //$to = COM_formatEmailAddress ($username, $email);
        $to = $email;
        $subject = $LANG_INM11[13];
        $body .= $LANG_INM11[15];
        $body .= "<br><br>";
        $body .= sprintf($LANG_INM11[14], $filename, $mid, $mid);
        $body .= "<br><br>";
        $body .= $_CONF['site_name'] . "<br>";
        $body .= '<a href="'.$_CONF['site_url'].'">'.$_CONF['site_url'].'</a><br>';
        //change $from to suit your gallery moderator email address
        $from = COM_formatEmailAddress ($LANG_INM11[12], $_CONF['site_mail']);
        if (!COM_mail($to,$subject,$body,$from,true)){
            $notified = $LANG_INM11[11];
        } else {
            $notified = $LANG_INM11[10];
        }
    }
    $retval = sprintf($LANG_INM11[3], $filename) . '<br />' . $notified;

    return $retval;
}

/* 
* Main Function
*/

$pagetitle = $LANG_INM01[11] . $LANG_INM01[12];
$display = inm_siteHeader($pagetitle);

if ($_POST['submit'] == $LANG_INM11[4]){
    //approve media and return result
    $valid = inm_validateInput('queue');
    if(is_array($valid)){
        $display .= COM_startBlock($LANG_INM11[6]);
        $display .= inm_approveMedia($valid['mid']);
        $display .= COM_endBlock();
    } else {
        //input validation error
        $display .= COM_startBlock($LANG_INM04[2]);
        $display .= $valid;
        $display .= COM_endBlock();
    }
} elseif ($_POST['submit'] == $LANG_INM11[5]){
    //delete media and return result
    $valid = inm_validateInput('media');
    if(is_array($valid)){
        $display .= COM_startBlock($LANG_INM11[6]);
        $display .= inm_deleteMedia($valid['mid']);
        $display .= COM_endBlock();
    } else {
        //input validation error
        $display .= COM_startBlock($LANG_INM04[2]);
        $display .= $valid;
        $display .= COM_endBlock();
    }
} elseif ($_POST['submit'] == $LANG_INM11[8]){
    //update and approve media and return result
    $valid = inm_validateInput('media');
    if(is_array($valid)){
        $display .= COM_startBlock($LANG_INM11[6]);
        $display .= inm_updateMedia($valid);
        $display .= COM_endBlock();
    } else {
        //input validation error
        $display .= COM_startBlock($LANG_INM04[2]);
        $display .= $valid;
        $display .= COM_endBlock();
    }
}

if (SEC_hasRights('inmemoriam.admin')){
    $and = '';
} else {
    $and = "a.owner_id='{$_USER['uid']}'";
}

$result = DB_query("SELECT m.mid FROM {$INM_TABLES['media']} m, {$INM_TABLES['albums']} a WHERE m.status='1' AND m.aid=a.id" . $and . " ORDER BY a.id, m.owner_id, m.date ASC");
$inQueue = DB_numRows($result);

if ($inQueue < 1){
    //no albums so give a link
    $display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
    $display .= inm_menurow();
    $display .= inm_showintro(sprintf($LANG_INM11[2], $inQueue));
    $display .= COM_endBlock();
    $display .= inm_siteFooter();
    echo $display;
    exit;
}

$display .= COM_startBlock($LANG_INM01[11] . $LANG_INM01[12]);
$display .= inm_menurow();
$display .= inm_showintro(sprintf($LANG_INM11[2], $inQueue));
$display .= COM_endBlock();

//display queue contents
$display .= COM_startBlock($LANG_INM11[1]);
while ($A = DB_fetchArray($result)){
    $display .= inm_showMediaSumm($A['mid'], true) . '<br />' . LB;
}

$display .= COM_endBlock();
$display .= inm_poweredBy();
$display .= inm_siteFooter();
echo $display;
?>