<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | slide.inc                                                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Retrieve access settings
$anonview = DB_getItem($INM_TABLES['settings'], 'anonview');
// Check user has rights to access this page
if (($anonview == '0') && ($_USER['uid'] < 2)) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access media.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_INM00['access_denied']);
    $display .= $LANG_INM00['access_denied_msg1'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}



//a pause button?
//start button
//time delay - 3, 5, 10, 20

// main function
$valid = inm_validateInput('get');
if (!empty($valid['mid']) && is_numeric($valid['mid'])){
    //get media data
    $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE mid='{$valid['mid']}' AND status='0'" . COM_getPermSQL('and'));
    $M = DB_fetchArray($result);
    if (inm_hasAlbumAccess($M['aid']) < 2){
        //refresh to index.php
        $display = COM_refresh($INM_CONF['url_html'] . '/index.php');
        echo $display;
        exit;
    }
} elseif (!empty($valid['id']) && is_numeric($valid['id'])){
    if (inm_hasAlbumAccess($valid['id']) < 2){
        //refresh to index.php
        $display = COM_refresh($INM_CONF['url_html'] . '/index.php');
        echo $display;
        exit;
    }
    $result = DB_query("SELECT * FROM {$INM_TABLES['media']} WHERE aid='{$valid['id']}' AND status='0'" . COM_getPermSQL('and') . " ORDER BY date DESC LIMIT 1");
    $M = DB_fetchArray($result);
} else {
    //refresh to index.php
    $display = COM_refresh($INM_CONF['url_html'] . '/index.php');
    echo $display;
    exit;
}

//update hit counter
DB_query("UPDATE {$INM_TABLES['media']} SET hits=hits+1 WHERE mid='{$M['mid']}'");

$T = new Template($_CONF['path'] . 'plugins/inmemoriam/templates');
$T->set_file(array('page' => 'slide.thtml'));

//process media for prev, and next, based on current
$orderby = ' ORDER BY date DESC';
$result = DB_query("SELECT mid, filename FROM {$INM_TABLES['media']} WHERE status='0' AND aid='{$M['aid']}'" . COM_getPermSQL('and') . $orderby);
$media = array();
while ($A = DB_fetchArray($result)){
    $extension = strtolower(strrchr($A['filename'],"."));
    if (array_key_exists($extension, $INM_CONF['image_ext'])){
        $media[] = $A['mid'];
    }
}
if (count($media) < 2){
    $display = COM_refresh($INM_CONF['url_html'] . '/browse.php?mid=' . $M['mid']);
    echo $display;
    exit;
}

$pages = count($media);
$key = array_search($M['mid'], $media);
$firstimage = $media[0];
$previmage = $media[$key - 1];
$nextimage = $media[$key + 1];
$lastimage = $media[$pages - 1];

if ($firstimage == $M['mid']){
    $previmage = $lastimage;
}
if ($lastimage == $M['mid']){
    $nextimage = $firstimage;
}

//previmage goes to the prev thumb
$prevthumb = '<a href="' . $INM_CONF['url_html'] . '/browse.php?mid=' . $previmage . '"><img src="' . $INM_CONF['url_html'] . '/image.php?mid=' . $previmage . '&amp;thumb=1&amp;size=1" alt="' . $LANG_INM12[1] . '" /></a>';
$T->set_var('prevthumb', $prevthumb);

//nextimage goes to meta content and to the next thumb
$nextthumb = '<a href="' . $INM_CONF['url_html'] . '/browse.php?mid=' . $nextimage . '"><img src="' . $INM_CONF['url_html'] . '/image.php?mid=' . $nextimage . '&amp;thumb=1&amp;size=1" alt="' . $LANG_INM12[1] . '" /></a>';
$T->set_var('nextthumb', $nextthumb);

$refresh_url = $INM_CONF['url_html'] . '/slide.php?mid=' . $nextimage . '&amp;delay=' . $valid['delay'];
if (isset($valid['delay']) && is_numeric($valid['delay'])){
    $T->set_var('refresh', '<meta http-equiv=refresh content="' . $valid['delay'] . '; URL=' . $refresh_url . '" />');
}

$T->set_var('langdelay', $LANG_INM12[4]);
$T->set_var('d3link', $INM_CONF['url_html'] . '/slide.php?mid=' . $M['mid'] . '&amp;delay=3');
$T->set_var('d5link', $INM_CONF['url_html'] . '/slide.php?mid=' . $M['mid'] . '&amp;delay=5');
$T->set_var('d10link', $INM_CONF['url_html'] . '/slide.php?mid=' . $M['mid'] . '&amp;delay=10');
$T->set_var('d20link', $INM_CONF['url_html'] . '/slide.php?mid=' . $M['mid'] . '&amp;delay=20');

$T->set_var('url_html', $INM_CONF['url_html']);
$result = DB_query("SELECT name, theme FROM {$INM_TABLES['albums']} WHERE id='{$M['aid']}'");
list($name, $theme) = DB_fetchArray($result);
if (!empty($theme)){
    $T->set_var('class', 'inm-' . $INM_CONF['themes'][$theme]);
} else $T->set_var('class', 'inm-' . $INM_CONF['themes'][0]);
$T->set_var('albumname', COM_stripslashes($name));
$T->set_var('mid', $M['mid']);
if (!empty($M['wid'])){
    $wid = '&wid=' . $M['wid'];
}
$T->set_var('src', $INM_CONF['url_html'] . '/image.php?mid=' . $M['mid'] . $wid);
$T->set_var('alt', $LANG_INM12[1]);
$T->set_var('title', COM_stripslashes($M['title']));
$T->set_var('caption', PLG_replaceTags(COM_stripslashes($M['caption'])));
$T->set_var('langauthor', $LANG_INM12[2]);
$T->set_var('photographer', inm_prflink($M['owner_id']));
$T->set_var('langviews', $LANG_INM12[3]);
$T->set_var('hits', $M['hits'] + 1);
$T->set_var('poweredby', inm_poweredBy());

$T->parse('output', 'page');
$display = $T->finish($T->get_var('output'));

echo $display;
exit;
?>