<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | sql_install.php                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//


#
# Table structure for inmemoriam albums
#

$_SQL[] = "CREATE TABLE {$INM_TABLES['albums']} (
  id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  aid VARCHAR(128) NOT NULL,
  path VARCHAR(255) NOT NULL,
  name VARCHAR(64) NOT NULL,
  description TEXT,
  date_created DATETIME NOT NULL default 'NOW()',
  date_lastadd DATETIME NOT NULL default '0000-00-00 00:00:00',
  hits MEDIUMINT(8) UNSIGNED NOT NULL default '0',
  status TINYINT(1) NOT NULL default '0',
  featured TINYINT(1) NOT NULL default '0',
  cntrblktype TINYINT(1) NOT NULL default '1',
  allow_submit TINYINT(1) NOT NULL default '0',
  queue TINYINT(1) NOT NULL default '1',
  pid VARCHAR(24) NULL,
  frame VARCHAR(24) NOT NULL default '0',
  theme VARCHAR(24) NOT NULL default '0',
  thumbsize TINYINT(1) NOT NULL default '2',
  thumb VARCHAR(255) NULL,
  thumbs_perpage TINYINT(3) NOT NULL default '12',
  maxw MEDIUMINT(4) NOT NULL default '480',
  maxh MEDIUMINT(4) NOT NULL default '480',
  dispfullimg TINYINT(1) NOT NULL default '1',
  limitfullimg TINYINT(1) NOT NULL default '1',
  enable_rating TINYINT(1) NOT NULL default '0',
  enable_comments TINYINT(1) NOT NULL default '0',
  orderby TINYINT(1) NOT NULL default '1',
  cntrblkenable TINYINT(1) NOT NULL default '0',
  cntrblkpos TINYINT(1) NOT NULL default '2',
  cntrblkpage varchar(20) NOT NULL default '',
  enable_image TINYINT(1) NOT NULL default '1',
  enable_audio TINYINT(1) NOT NULL default '0',
  enable_video TINYINT(1) NOT NULL default '0',
  enable_code TINYINT(1) NOT NULL default '0',
  max_filesize INT NOT NULL default '2097152',
  group_id MEDIUMINT(8) UNSIGNED NOT NULL default '1',
  owner_id MEDIUMINT(8) UNSIGNED NOT NULL default '2',
  perm_owner TINYINT(1) UNSIGNED NOT NULL default '3',
  perm_group TINYINT(1) UNSIGNED NOT NULL default '3',
  perm_members TINYINT(1) UNSIGNED NOT NULL default '2',
  perm_anon TINYINT(1) UNSIGNED NOT NULL default '2',
  INDEX aid(aid),
  UNIQUE aid_pid (aid,pid)
) TYPE=MyISAM";

#
# Table structure for inmemoriam media
#
# aid = $INM_TABLES['albums']--id, not aid

$_SQL[] = "CREATE TABLE {$INM_TABLES['media']} (
  mid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  filename VARCHAR(128) NOT NULL,
  aid INT NOT NULL,
  title VARCHAR(64) NULL,
  caption TEXT NULL,
  keywords TEXT NULL,
  enable_exif TINYINT(1) NOT NULL default '0',
  enable_watermark TINYINT(1) NOT NULL default '0',
  wid INT NULL,
  size TINYINT(1) NOT NULL default '1',
  position TINYINT(1) NOT NULL default '1',
  opacity TINYINT(3) NOT NULL default '25',
  totalrating INT(255) NULL,
  numvotes INT(255) NULL,
  date DATETIME NOT NULL default 'NOW()',
  hits INT(255) UNSIGNED NOT NULL default '0',
  comments MEDIUMINT(8) UNSIGNED NOT NULL default '0',
  status TINYINT(1) NOT NULL default '1',
  group_id MEDIUMINT(8) UNSIGNED NOT NULL default '1',
  owner_id MEDIUMINT(8) UNSIGNED NOT NULL default '2',
  perm_owner TINYINT(1) UNSIGNED NOT NULL default '3',
  perm_group TINYINT(1) UNSIGNED NOT NULL default '3',
  perm_members TINYINT(1) UNSIGNED NOT NULL default '2',
  perm_anon TINYINT(1) UNSIGNED NOT NULL default '2'
) TYPE=MyISAM";

#
# Table structure for inmemoriam exif
#not in use at the moment

#$_SQL[] = "CREATE TABLE {$INM_TABLES['exif']} (
#  mid INT NOT NULL PRIMARY KEY,
#  data TEXT NULL
#) TYPE=MyISAM";

#
# Table structure for inmemoriam watermark
#

$_SQL[] = "CREATE TABLE {$INM_TABLES['watermarks']} (
  wid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  img_mark VARCHAR(128) NULL,
  txt_mark VARCHAR(128) NULL
) TYPE=MyISAM";

#
# Table structure for inmemoriam favorite
#

$_SQL[] = "CREATE TABLE {$INM_TABLES['favorites']} (
  uid MEDIUMINT(8) UNSIGNED NULL,
  mid INT NULL,
  date DATETIME NOT NULL default 'NOW()',
  INDEX uid(uid)
) TYPE=MyISAM";

#
# Table structure for inmemoriam prefs
#

$_SQL[] = "CREATE TABLE {$INM_TABLES['settings']} (
  searchdisplim TINYINT(3) UNSIGNED NOT NULL default '10',
  anonview TINYINT(1) NOT NULL default '1',
  loginadd TINYINT(1) NOT NULL default '1',
  logincreate TINYINT(1) NOT NULL default '1',
  albums_perpage TINYINT(3) NOT NULL default '10',
  enable_splash TINYINT(1) NOT NULL default '1',
  enable_menuitem TINYINT(1) NOT NULL default '1',
  lr_blocks TINYINT(1) NOT NULL default '1',
  whatsnew TINYINT(1) NOT NULL default '1',
  listtype TINYINT(1) NOT NULL default '2',
  thumbsize TINYINT(1) NOT NULL default '2',
  max_filesize INT NOT NULL default '2097152',
  sendmail TINYINT(1) NOT NULL default '1',
  dfid TINYINT(2) NOT NULL default '2'
) TYPE=MyISAM";

?>