<?php

//
// +---------------------------------------------------------------------------+
// | Inmemoriam v 1.0 plug-in for Geeklog                                      |
// | upgrade.inc                                                               |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// | Author: Alf Deeley aka machinari - ajdeeley@summitpages.ca                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

/*
 *
 * the following queries will update your Inmemoriam database tables to 0.9.0 on a 1.3.11 GL installation
 *
 */
function inm_upgrade_090()
{
    global $INM_TABLES;

    $_SQL = array();

    //adds a column to store the new option of having media or albums display in the what's new block.
    $_SQL[] = "ALTER TABLE {$INM_TABLES['settings']} ADD `whatsnew` TINYINT( 1 ) DEFAULT '1' NOT NULL AFTER `lr_blocks`";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['settings']} ADD `listtype` TINYINT( 1 ) DEFAULT '2' NOT NULL AFTER `whatsnew`";

    //accommodates the mail notifications
    $_SQL[] = "ALTER TABLE {$INM_TABLES['settings']} ADD `sendmail` TINYINT( 1 ) DEFAULT '1' NOT NULL AFTER `max_filesize`";

    //accommodates custom date format
    $_SQL[] = "ALTER TABLE {$INM_TABLES['settings']} ADD `dfid` TINYINT( 2 ) DEFAULT '0' NOT NULL";

    //stores the option to turn on/off the menu item
    $_SQL[] = "ALTER TABLE {$INM_TABLES['settings']} ADD `enable_menuitem` TINYINT( 1 ) DEFAULT '1' NOT NULL AFTER `enable_splash`";

    //accommodates further watermark functionality
    $_SQL[] = "ALTER TABLE {$INM_TABLES['watermarks']} DROP `size`";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['watermarks']} DROP `position`";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['media']} ADD `opacity` TINYINT( 3 ) DEFAULT '100' NOT NULL AFTER `wid`";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['media']} ADD `size` TINYINT( 1 ) DEFAULT '1' NOT NULL AFTER `wid`";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['media']} ADD `position` TINYINT( 3 ) DEFAULT '1' NOT NULL AFTER `size`";

    //miscellany
    $_SQL[] = "ALTER TABLE {$INM_TABLES['watermarks']} CHANGE `txt_mark` `txt_mark` VARCHAR( 128 ) DEFAULT NULL";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['media']} CHANGE `aid` `aid` INT NOT NULL";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['albums']} CHANGE `aid` `aid` VARCHAR( 128 ) NOT NULL";

    /* Execute SQL now to perform the upgrade */
    for ($i = 1; $i <= count($_SQL); $i++) {
        COM_errorLOG("Inmemoriam Media Gallery plugin 0.9.0 update: Executing SQL => " . current($_SQL));
        DB_query(current($_SQL));
        if (DB_error()) {
            COM_errorLog("SQL Error during Inmemoriam Media Gallery plugin update",1);
            return 1;
            break;
        }
        next($_SQL);
    }
    COM_errorLog("Success - Completed Inmemoriam Media Gallery plugin version 0.9.0 update",1);
    return 0;
}

/*
 *
 * the following queries will update your Inmemoriam database tables to 1.0cvs on a 1.3.12 GL installation
 *
 */
function inm_upgrade_10()
{
    global $INM_TABLES;

    $_SQL = array();


    //adding optional support for image, audio, video file types
    $_SQL[] = "ALTER TABLE {$INM_TABLES['albums']} ADD `enable_image` TINYINT( 1 ) DEFAULT '1' NOT NULL AFTER `cntrblkpage`";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['albums']} ADD `enable_audio` TINYINT( 1 ) DEFAULT '0' NOT NULL AFTER `enable_image`";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['albums']} ADD `enable_video` TINYINT( 1 ) DEFAULT '0' NOT NULL AFTER `enable_audio`";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['albums']} ADD `enable_code` TINYINT( 1 ) DEFAULT '0' NOT NULL AFTER `enable_video`";

    //adding max file setting per album
    $_SQL[] = "ALTER TABLE {$INM_TABLES['albums']} ADD `max_filesize` INT DEFAULT '2097152' NOT NULL AFTER `enable_code`";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['settings']} CHANGE `max_filesize` `max_filesize` INT( 11 ) DEFAULT '2097152' NOT NULL ";
    $_SQL[] = "ALTER TABLE {$INM_TABLES['favorites']} ADD `date` DATETIME DEFAULT 'NOW()' NOT NULL";

    /* Execute SQL now to perform the upgrade */
    for ($i = 1; $i <= count($_SQL); $i++) {
        COM_errorLOG("Inmemoriam Media Gallery plugin 1.0 update: Executing SQL => " . current($_SQL));
        DB_query(current($_SQL));
        if (DB_error()) {
            COM_errorLog("SQL Error during Inmemoriam Media Gallery plugin update",1);
            return 1;
            break;
        }
        next($_SQL);
    }
    COM_errorLog("Success - Completed Inmemoriam Media Gallery plugin version 1.0 update",1);
    return 0;
}

?>